2022-03-21  Karl Berry  <karl@tug.org>

	* TL'22 release.

2022-02-27  TANAKA Takuji  <ttk@t-lab.opal.ne.jp>

	* dvipdfmx-upjf.test, Makefile.{am,in},
	tests/Makefile_upjf,
	tests/upjf-g00.{opl,ofm}, tests/upjv-g00.{opl,ofm}:
	Add a new test for pTeX & OFM FONTDIR.

2022-02-24  TANAKA Takuji  <ttk@t-lab.opal.ne.jp>

	* dvipdfmx-upjf.test, Makefile.{am,in},
	tests/Makefile_upjf, tests/upjv{,-r,-g}.tfm,
	tests/upjf.{tex,dvi,map}, tests/upjv_{full,omit}.vf,
	tests/UPJF-UTF16-V:
	Add a new test for upTeX vertical writing.

2021-11-17  Akira Kakuto  <kakuto@jcom.zaq.ne.jp>

	* spc_dvips.c: Realize PSTricks on XeTeX without -dNOSAFER,
	in the way described in
	https://tug.org/pipermail/dvipdfmx/2021-November/000308.html
	* configure.ac: version 20211117.

2021-11-12  Karl Berry  <karl@freefriends.org>

	* dvipdfmx.c (show_usage): mention -i.
	Change bug report line to CTAN package page, for more information.

2021-11-03  Naveen M K  <naveen521kk@gmail.com>

	* Makefile.am (install-exec-hook) [WIN32]: install via libtool,
	so as to install the real program, not just the libtool wrapper.
	Found for msys2.
	https://tug.org/pipermail/dvipdfmx/2021-October/000301.html

2021-10-29  Marcel Fabian Kr\"uger  <tex@2krueger.de>

	* cidtype0.c: Fix a bug that dvipdfmx segfaults when embedding
	a CFF based OpenType font which does not contain a private
	dictionary.
	* configure.ac: version 20211029.

2021-10-16  Akira Kakuto  <kakuto@jcom.zaq.ne.jp>

	* dvipdfmx.c: Fix a bug that the -r option was not effective,
	as reported in
	https://tug.org/pipermail/dvipdfmx/2021-September/000296.html.
	* configure.ac: version 20211016.

2021-09-26  Akira Kakuto  <kakuto@jcom.zaq.ne.jp>
	* pdfdev.c: Remove all my changes on 2021-03-04 and 2021-03-05
	which were completely wrong.
	* pkfont.c: Before calling kpse_find_glyph(ident, ...), remove
	a suffix .pfb from the ident, if the suffix exists, because the
	suffix prevents mktexpk to work right.
	* configure.ac: version 20210926.

2021-06-09  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfencoding.c: Replace the changes made on 2021-06-02. The
	segmentation fault problem was introduced by the changes in
	rev.7557 which were not just problematic but also making it
	unclear that it's not possible to freely choose which
	encodings to use as the base encoding. Remove useless base
	encoding entry which was causing the problem from the
	pdf_encoding struct.
	* configure.ac: Version 20210609.

2021-06-05  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfximage.c: Improved error messages when PDF/PS inclusion
	fails. Output page numbers too.
	* configure.ac: Version 20210605.

2021-06-02  Masamichi HOSODA  <trueroad@trueroad.jp>

	* pdfencoding.c: Fix a segmentation fault on pdfencoding.
	https://tug.org/pipermail/dvipdfmx/2021-May/000270.html
	https://github.com/texjporg/tex-jp-build/issues/114

2021-05-31  Karl Berry  <karl@tug.org>

	* dvipdfmx.1: bug reporting address now dvipdfmx@tug.org
	(https://lists.tug.org/dvipdfmx).

2021-05-05  Akira Kakuto  <kakuto@w32tex.org>

	* pdfximage.c: Support non-ascii TMP and TEMP to call
	Ghostscript.

2021-04-17  Akira Kakuto  <kakuto@w32tex.org>

	* pkfont.c: Remove all changes in 2020-12-14 and recover the
	original pkfont.c.

2021-04-15  Akira Kakuto  <kakuto@w32tex.org>

	* tfm.c: Improve to find ofm files.

2021-04-03  Akira Kakuto  <kakuto@w32tex.org>

	* pkfont.c: Remove unnecessary changes made on 2020-12-14.

2021-03-23  Karl Berry  <karl@tug.org>

	* TL'21.

2021-03-18  Akira Kakuto  <kakuto@w32tex.org>

	* dvipdfmx.c: A bug in compat mode is found and fixed by
	Christian Schenk:
	https://tug.org/pipermail/tex-live/2021-March/046609.html
	* configure.ac: Version 20210318.

2021-03-14  Akira Kakuto  <kakuto@w32tex.org>

	* dvipdfmx.c: Do not allow directory separators in an optarg
	in an option -i optarg for security reason.

2021-03-05  Akira Kakuto  <kakuto@w32tex.org>

	* pdfdev.c: Correct the incomplete fix on 2021-03-04.
	* pdffont.c: Avoid unnecessary warnings, reported in
	https://tug.org/pipermail/dvipdfmx/2021-March/000242.html

2021-03-04  Akira Kakuto  <kakuto@w32tex.org>

	* pdfdev.c: Fix to call mktexpk with correct arguments when
	pdftex.map is used and type1 font is not found.
	Reported by Igor Liferenko:
	https://tug.org/pipermail/dvipdfmx/2021-March/000241.html
	* configure.ac: Version 20210304.

2021-02-12  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* dvi.c: Fix a bug (segfault) that current_font is not checked
	properly when catch_phantom=1.
	* configure.ac: Version 20210212.

2021-01-31  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* spc_misc.c: Processing of pdffontatrr special should be
	delayed until the end of the document since the font may not
	be loaded at the time this special is executed.

2021-01-26  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* dvipdfmx.c: Set the runtime flag suppressing error messages
	for kpathsea library when "-q" option is used.
	* dvipdfmx.c, xbb.c: Update copyright year.
	https://tug.org/pipermail/dvipdfmx/2021-January/000216.html

2021-01-24  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* spc_misc.c: Add a compatibility special pdffontattr.
	* configure.ac: Version 20210124.

2021-01-22  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* cidtype0.c: Fix the VORG bug reported in
	https://tug.org/pipermail/dvipdfmx/2021-January/000193.html
	* configure.ac: Version 20210122.

2021-01-16  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfximage.c: Dvipdfmx behavior changed. Now it stops
	processing and exits with non-zero exit status when image
	inclusion fails.
	* dvi.c: Ignore dvi_set with invalid gid when processing DVI
	files created by dvilua[la]tex.
	* dvipdfmx.c: Bump copyright year.
	* configure.ac: Version 20210116.

2021-01-15  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* dvi.c, dvipdfmx.c, pdfdoc.[ch]: Experimental support for
	dviluatex extended fnt_def. Separate annot_grow (linkmargin)
	for horizontal and vertical direction can be specified.
	* configure.ac: Version 20210115.

2021-01-10  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* cmap_read.c, t1_load.c: Fix a bug causing a segfault
	reported as dvipdfmx-upjf.test test failure. Add missing size
	tests for the data comparison.
	https://tug.org/pipermail/tlbuild/2021q1/004765.html

2021-01-09  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* cidtype0.c, cidtype2.c, pdffont.[ch], type0.c: Fix a bug
	that vertical metrics are not written. Introduced in rev.56400.
	* configure.ac: Version 20210109.

2020-12-16  Karl Berry  <karl@freefriends.org>

	* dvipdfmx.c (show_usage): -f loads an additional map file,
	does not omit loading of default map(s).
	https://tug.org/pipermail/dvipdfmx/2020-December/000146.html

2020-12-16  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* spc_pdfm.c: Fix a bug introduced in rev.56265: When the
	resource dictionary (of some resource category) is an indirect
	object and then pdf:put operation is done against that
	resource category, the operation fails. Now this situation is
	taken into account. (The content of old resource is merged
	into new one).
	* configure.ac: Version 20201216.

2020-12-14  Akira Kakuto  <kakuto@w32tex.org>

	* pkfont.c: Fix an incorrect argument for mktexpk.
	https://tug.org/pipermail/dvipdfmx/2020-December/000142.html.
	* configure.ac: Version 20201214.

2020-11-11  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* spc_html.c: Fix a bug that html-special was not working
	after the changes introduced in rev.55722 (pdf:bann accepts a
	reference ID).
	* type0.c: Add pseudo-unique tag to ToUnicode CMap name again.
	* configure.ac: Version 20201111.

2020-10-31  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfximage.c: Fix a bug that mps images are not reused when
	they are included multiple times. Bug introduced by "Forward
	reference" support added on 2020-07-21.
	* configure.ac: Version 20201031.

2020-10-28  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* cidtype0.c: Fix a bug that the conditional for deciding if
	CIDSet should be written is inverted. CIDSet is deprecated in
	PDF version 2.0.
	* cidtype2.c, type1.c, type1c.c: Do not write CIDSet and
	CharSet when the output PDF version is set to 2.0 or higher.
	* configure.ac: Version 20201028.

2020-10-19  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* cidtype0.c, cidtype2.c, type0.c: User defined CID-to-GID
	PostScript CMap with filename of the form
	REGISTRY-ORDERING-PSFontName can be loaded (if exist) for
	mapping CIDs to GIDs. This feature can be used for directory
	mapping CIDs to GIDs instead of
	CID -> to-code CMaps -> TrueType cmap -> GID route.
	* data/Adobe-Japan1-YuMincho-Regular: An example of CID-to-GID
	CMap file.
	* configure.ac: Version 20201019.

2020-10-14  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* tt_cmap.c: Fix a bug that checking array indices is wrong.
	* cidtype2.c: Warning message when CID is mapped to a sequence
	of several Unicode characters is corrected. Fix a wrong
	assumption introduced by xdvipdfmx.
	* configure.ac: Version 20201014.

2020-10-08  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* dvi.c: Fix problems introduced by the changes on 2020/10/03.
	Fix a possible problem of invalid access. Fix a problem that
	non-BMP characters are not handled properly for the "unicode"
	encoding.
	* spc_pdfm.c: pdf:bcolor and pdf:scolor accept both fill and
	stroke color specified at the same time. Change the behavior
	when an indirect object is specified for pdf:pageresources.
	* configure.ac: Version 20201008.

2020-10-06  Akira Kakuto  <kakuto@w32tex.org>

	* spc_dvips.c: Add an option -dALLOWPSTRANSPARENCY in
	GS_CALCULATOR to obtain correct results in PSTrics for XeTeX
	in the case of newer Ghostscript such as gs-9.53.3.
	Reported in
	https://tug.org/pipermail/dvipdfmx/2020-October/000109.html

2020-10-06  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* dvipdfmx.c: Fix a bug that printing output file name is wrong.
	* dvi.c: Change XeTeX font handling. Convert glyph metrics to
	an internal format at load time. Don't interpret type1
	CharStrings again and again.
	* configure.ac: Version 20201006.

2020-10-05  Karl Berry  <karl@tug.org>

	* man/dvipdfmx.1: update date.

2020-10-05  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* man/dvipdfmx.1: Fix a problem in the man page as reported in
	https://tug.org/pipermail/dvipdfmx/2020-October/000107.html.

2020-10-03  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* cid.c, cid.h: Add "const" attribute to arguments fontmap_rec
	and fmap_opt.
	* cmap.c: Correct calculation of min-bytes and max-bytes. Fix
	indentation.
	* dvi.c, mpost.c, pdfdev.[ch], pdffont.[ch]: Simplify input
	text handling. The "mapc" option is handled in dvi.c.
	* configure.ac: Version 20201003.

2020-09-26  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfobj.c: Fix a bug that the max number of indirect objects
	is wrongly set, causing a problem when too many indirect
	objects are created.
	* pdflimit.h: Add PDF_NUM_INDIRECT_MAX indicating the maximum
	number of indirect objects which can be allocated as described
	in PDF Ref. v.1.7 and ISO 32000-1.
	* configure.ac: Version 20200926.

2020-09-24  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdffont.c: Fix a bug introduced by the recent font related
	changes which can cause a problem when there is a font
	defined but not used.
	* configure.ac: Version 20200924.

2020-09-22  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* cid.[ch], cidtype0.[ch], cidtype2.[ch], pdfdev.c,
	pdffont.[ch], pkfont.[ch], truetype.[ch], type0.[ch],
	type1.[ch], type1c.[ch]: Revise font related code and largely
	simplify it. Type0 and CIDFont now use the same struct as
	simple fonts.
	* Makefile.am, cid_p.h: Remove cid_p.h.
	* pdfdraw.[ch]: Fix a bug in calculation of determinant.
	Enable few functions for future improvement.
	* dpxutil.c: Fix a bug in the roll operation.
	* configure.ac: Version 20200922.

2020-09-07  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* spc_misc.c: Fix a bug that the upper limit of stack id is wrong.
	* Update copyright years and README. Remove outdated
	information from README.

2020-09-06  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* spc_pdfm.c: pdf:bcolor and pdf:scolor now accept new
	keywords "fill" and "stroke" to indicate either of fill/stroke
	color is specified.
	* spc_misc.[ch], specials.[ch]: New special commands for
	pdfcolorstack are added. This is a compatibility feature to
	pdfcolorstack in pdftex.
	* configure.ac: Version 20200906.

2020-09-05  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* spc_pdfm.c: Workaround for an issue that occurs when an
	indirect object (object reference) is used for a resource
	dictionary entry in pdf:put command. The content of an already
	existing resource dictionary is copied to the new dictionary.
	* pdfobj.c, pdfdoc.c: pdf_indirect stores a pointer to the
	object itself but there is no way to know if the object is
	released. This can result in using junk pointers. To resolve
	this issue, a list is added to record released indirect objects.
	* configure.ac: Version 20200905.

2020-09-02  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfnames.c: Fix an incompatible behavior introduced by the
	previous changes on the named object (rev.55887).
	* configure.ac: Version 20200902.

2020-08-26  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* spc_pdfm.c: Fix a bug exposed by the previous changes on the
	named object (rev.55887). Remove unnecessary spc_flush_object.
	* configure.ac: Version 20200826.

2020-08-16  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* dpxutil.[ch]: Add stack operation.
	* epdf.[ch], pdfdraw.[ch]: Revise Clip path support for PSTricks.
	Revert changes related to "rectadd" introduced in rev.31262
	and rev.31302 which cause non-conforming behavior in "clip"
	operatation.
	* dvi.[c], mpost.c, pdfdev.[ch], pdfdoc.[ch], pdfdraw.[ch],
	spc_html.c, spc_misc.c. spc_pdfm.c, spc_xtx.c, specials.[ch]:
	Revise bcontent support. Try to resolve various inconsistent
	behaviors when special commnads are used within pdf:bcontent
	and pdf:econtent. dev_coords and pt_fixee are removed from pdf
	module and moved to specials.c.
	* mpost.h, spc_html.h, spc_misc.h, spc_pdfm.h, spc_xtx.h:
	Update copyright years.
	* configure.ac: Version 20200816.

2020-08-08  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* fontmap.[ch], pdffont.[ch], tt_aux.[ch], tt_cmap.[ch]:
	Use uint32_t for TTC index.

2020-07-31  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* cid.c: Avoid accessing array elements exceeding max array index.
	* spc_pdfm.c: Check array elements also for to-unicode conversion.
	* tt_cmap.c: Additional changes are required for the previous CMap name fix.

2020-07-29  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* spc_pdfm.c: Improve codes in unicode conversion and
	annotation rect calculation.
	* spc_xtx.c: Add missing reset_xgstate().
	* tt_cmap.c: Add wmode to auto-generated CMap names.

2020-07-28  Clerk Ma  <maqiyuan130324@vip.qq.com>

	* pdfobj.c: Simple modifications for LIBDPX.

2020-07-26  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* cmap_write.c: Change ariable names.
	* dvipdfmx.c: Remove unused variables. Modify init sequence.
	Page size specified as a command line option overwrites
	settings specified by pagesize specials.
	* pdfdev.[ch], pdfdoc.[ch], pdfencrypt.[ch], pdfobj.[ch]:
	File static variables are now placed in a single struct.
	* pdfparse.[ch], spc_pdfm.c: PDF parse object function is
	called with a callback function to be called when an object of
	unknown type is encountered.
	* pdfximage.c: Do not include an unnecessary file.
	* dpxconf.[ch], xbb.c: Add is_xbb in dpx_conf.
	* dpxutil.[ch], dvi.c, dvipdfmx.c: Add dpx_util_read_length().
	* configure.ac: Version 20200726.

2020-07-24  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* cidtype0.c: Fix a bug introduced in rev.37144 that generated
	CIDType0 font file is corrupt when the "force fixed-pitch"
	option is enabled.
	* pdfximage.c: "filename" was wrongly used for cached converted
	PS images.

2020-07-21  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfdoc.[ch], pdfnames.[ch], pdfobj.c, pdfximage.[ch],
	spc_dvips.c, spc_html.c, spc_misc.c, spc_pdfm.c, specials.c:
	"Forward reference" of image objects is also supported.
	Object reference by name is now available globally but not
	only for the "special" module.
	* configure.ac: Version 20200721.

2020-07-19  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfdraw.c: Avoid invoking gs operation for an empty ExtGState.

2020-07-18  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* dvipdfmx.c, pdfximage.[ch]: Don't call ordinary functions
	such as pdf_close_images() which can call ERROR() in
	error_cleanup(). This can result in a recursive call of
	error_cleanup().

2020-07-11  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfdev.c, pdfdoc.c, pdfdraw.[ch], pdfobj.[ch], spc_pdfm.c:
	ExtGState can be manipulated with a dedicated stack.
	Add new specials pdf:bxgstate and pdf:exgstate to push/pop
	ExtGState into/from the stack.
	* pdfcolor.c: Fix a bug that assignment was missing
	in pdf_color_compare().
	* configure.ac: Version 20200711.

2020-07-04  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfcolor.c, spc_util.c: Fix a bug in pdfcolor.c.
	Add initialization of a variable and NULL pointer check.
	* configure.ac: Version 20200704.

2020-07-02  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfdoc.c, spc_pdfm.c: Possible fix for a bug that pdf:btrans
	inside pdf:bcontent and pdf:econtent does not work correctly.
	Extend pdf:bann to accept a reference ID which can be used
	later to refer the annotation dictionary object. When
	line-breaks occur, it just points to the first annotation
	dictionary of the line-breaking annotation series.

2020-06-28  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* dvi.[ch], spc_dvipdfmx.c, spc_pdfm.c, specials.[ch]: Two new
	special commands added as workarounds for \phantom text issue
	in creating annotation (link). "pdf:xann" which extends the
	current annotation area by a specified amount.
	"dvipdfmx:catch_phantom" to control the behavior of dvipdfmx,
	when this is set to true, then dvipdfmx extends the annotation
	area when it encounters "horizontal movement" such as DVI
	"right". Optionally height and depth of such area can be
	specified (default: current font size for height and depth 0).
	* pdfcolor.c: Change prefix for ColorSpace resource name to "XC".
	* pdfdoc.c: Add missing release object.

2020-06-27  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfcolor.[ch], pdfdoc.c, pdfdraw.c, spc_util.c: An extension
	to the color support. All color-spaces can be supported (only
	for pdf: color commands). ColorSpace can be specified by a
	name key (e.g. DeviceRGB) or an object reference which is a
	reference to an object defining ColorSpace itself.
	* configure.ac: Version 20200627.

2020-06-24  Akira Kakuto  <kakuto@w32tex.org>

	* dpxfile.c, pdfximage.c: Remove unnecessary changes on
	2020-06-22.

2020-06-22  Akira Kakuto  <kakuto@w32tex.org>

	* dvipdfmx.c: Move dpx_delete_old_cache(image_cache_life)
	because image caching did'nt work.
	* dvi.c: Use MFOPEN() instead of fopen().
	* dpxfile.c, pdfximage.c: Use generalized stat() to handle
	UTF-8 names (Windows only).

2020-06-21  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* tt_cmap.c: Lower priority for Soft-hyphen U+00AD when
	generating ToUnicode CMap.
	* tt_cmap.c, type1c.c: Cause an error when "CFF " table is not
	found. (Possibly due to variable font which uses unsupported
	"CFF2" table)

2020-06-09  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* pdfdev.c: Another workaround for fake-bold issue.
	(See changes 2019-06-30 and 2020-02-29)

2020-05-26  Akira Kakuto  <kakuto@w32tex.org>

	* dvi.c: Introduce rgba_used in order to indicate that
	rgba_color for a XeTeX font is used or not. It enables full
	range of opacity, 0-255.
	* configure.ac: Version 20200526.

2020-05-10  TANAKA Takuji  <ttk@t-lab.opal.ne.jp>

	* vf.c: reduce message by '-v' less than by '-vv' for
	fallback of virtual fonts.

2020-05-03  TANAKA Takuji  <ttk@t-lab.opal.ne.jp>

	* dvipdfmx-upjf.test, Makefile.{am,in},
	tests/Makefile_upjf, tests/upjf{,-r,-g}.tfm,
	tests/upjf.{tex,dvi,map}, tests/upjf_{full,omit}.vf,
	tests/upjf_{full,omit}.cnf, tests/UPJF-UTF16-H:
	Add a new test for fallback of virtual fonts.
	* vf.c: Tweak debugging message for fallback of virtual fonts.

2020-03-27  Karl Berry  <karl@tug.org>

	* TeX Live 2020.

2020-03-15  TANAKA Takuji  <ttk@t-lab.opal.ne.jp>

	* tfm.c, tfm.h, vf.c: Fallback multibyte character
	in virtual font for (u)pTeX.
	* configure.ac: version 20200315.
	https://github.com/texjporg/tex-jp-build/issues/99

	A new rule for virtual fonts is implemented:
	If a virtual font has no entry of a codepoint and the first
	MAPFONT designates a (u)pTeX TFM(JFM), then we designate the
	glyph (usually with a fullwidth metric) of the same codepoint
	in the TFM(JFM) with the smallest font ID.
	The new rule helps to shrink size of Japanese virtual fonts.

2020-02-29  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* pdfdev.c: Revert the commit on 2019-06-30: see
	https://tug.org/pipermail/tex-live/2020-February/044855.html.
	Note that the problem with fake-bold reappears!
	https://tug.org/pipermail/dvipdfmx/2019-June/000014.html.

2020-02-12  Akira Kakuto  <kakuto@w32tex.org>

	* dvipdfmx.c: Fix a potential bug in set_default_pdf_filename().
	see https://tug.org/pipermail/tex-live/2020-February/044731.html

2020-02-06  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfobj.c: In pdf_new_string(), the supplied string was
	checked and dvipdfmx aborted when it was NULL. This check
	is removed since it is actually not necessary. The string is
	regarded simply as an empty string if it is NULL from now on.
	See https://tex.stackexchange.com/questions/522794/problem-in-updated-tex-live,
	although we can't reproduce the problem.
	* spc_pdfm.c: Add two pdftex specials which are basically
	similar to the existing dvipdfmx special "pdf:literal",
	"pdf:page:" and "pdf:direct:". It is not possible to test
	properly since exact spec is unknown to us. Currently,
	"pdf:direct:" is just an alias of "pdf:page:". It cannot be
	properly implemented at present.

2020-01-24  Akira Kakuto  <kakuto@w32tex.org>

	* dvi.c: Forgot to null-terminate strings in the previous
	changes.

2020-01-22  Akira Kakuto  <kakuto@w32tex.org>

	* dvi.c: Correct wrong sizes of opassword and upassword
	in scan_special_encrypt().

2020-01-16  Karl Berry  <karl@freefriends.org>

	* xbb.c (show_version),
	* dvipdfmx.c (show_version): copyright 2020.
	* configure.ac: version 20200116 for TL'20.

2019-11-14  Akira Kakuto  <kakuto@w32tex.org>

	* mt19937ar.c: Add to support common font names in all
	platforms when SOURCE_DATE_EPOCH is suitably set. A pseudo
	random number generating program coded by Takuji Nishimura and
	Makoto Matsumoto.
	* README: Add a subject "11. Random number generating function".
	* mem.h: Add "#define srand(x) init_genrand((x))", etc. because
	it is the only common header file for dpxcrypt.c, pdfencrypt.c,
	and pdffont.c, which use rand().
	* Makefile.am: Add mt19937ar.c.
	* configure.ac: Version 20191114.

2019-11-13  Akira Kakuto  <kakuto@w32tex.org>

	* spc_dvips.c: Add -dDELAYSAFER in GS_CALCULATOR because
	SAFER mode became the default in the gs-9.50.

2019-09-08  Akira Kakuto  <kakuto@w32tex.org>

	* dvi.c: Show appropriate message if unsupported pfa
	is used. Reported in
	https://tug.org/pipermail/dvipdfmx/2019-September/000031.html.

2019-08-24  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* dpxutil.c: Timezone offset is incremented by 1 hour if
	tm_isdst > 0, as suggested in
	https://tug.org/pipermail/dvipdfmx/2019-July/000017.html
	* pdfcolor.c: Always output color change instruction when color
	push/pop is invoked. Fix for the issue reported in
	https://tug.org/pipermail/dvipdfmx/2019-August/000029.html
	* configure.ac: Version 20190824.

2019-08-17  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfdoc.c, spc_pdfm.c: Workaround for some problems reported
	in https://tug.org/pipermail/dvipdfmx/2019-August/000021.html.
	Try to deref page resource dictionary when adding page resources.
	Allow direct objects for page resources.
	* configure.ac: Version 20190817.

2019-08-05  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfobj.c: Ignore zlib error while uncompressing data.
	Z_DATA_ERROR is ignored when avail_in is 0.
	Accepting some incorrectly written compressed data.
	Reported by Jens Adam:
	https://tug.org/pipermail/tex-live/2019-August/043983.html
	* dvipdfmx.c: Fix a bug that 'm' option was broken.
	This option must be processed before dvi_init().
	Bug reported to TUG mailing list:
	https://tug.org/pipermail/dvipdfmx/2019-July/000019.html
	* configure.ac: Version 20190805.

2019-08-03  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* tt_gsub.c: Fix a bug that OTL coverage data were not read and
	were initialized to wrong values when LigatureSetCount was 0.
	Similar issue is found also in alternate substitution.
	Reported by Jens Adam:
	https://tug.org/pipermail/tex-live/2019-August/043983.html

2019-06-30  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfdev.c: Fix a bug that fake-bold is not handled properly
	in some situations as reported in
	https://tug.org/pipermail/dvipdfmx/2019-June/000014.html.
	When text rendering mode is changed within a text block which
	is enclosed by q and Q, the change does not affect subsequent
	text blocks. Current implementation of text handling is not
	robust so we may need to reconsider it.

2019-06-01  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* unicode.c: Fix a bug that end of buffer check was wrong.

2019-05-26  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* cmap_write.c, dvipdfmx.c, pdfdev.c, pdfdev.h, pdfdoc.c
	spc_dvips.c, spc_pdfm.c, truetype.c, xbb.c:
	Fix for compiler warnings.
	* tt_post.c: Add missing "*/" in a deactivated section.
	* system.h: "pragma warning" only when _MSC_VER is defined.

2019-05-22  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* tt_gsub.c: Fix a bug that otl_gsub_read_alternate() and
	otl_gsub_read_ligature() exit loops wrongly for erroneous
	data, which leads to uninitialized values.
	Reported by Chih-Hsuan Yen:
	https://tug.org/pipermail/dvipdfmx/2019-May/000004.html.
	* configure.ac: Version 20190522.

2019-05-08  Akira Kakuto  <kakuto@w32tex.org>

	* dpxfile.c: Avoid buffer overflow.

2019-05-08  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* spc_pdfm.c: Transformation also applies to annotations
	created by pdf:ann.

2019-05-07  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* tt_cmap.c: Fix a bug that CFF charset data were not read.
	* unicode.c: Fix a bug that end-of-buffer calculation was
	wrong.

2019-05-05  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfdoc.c: g option affects only annotations created by
	"pdf:bann/eann" and html "a link" specials.
	Report from Joseph Wright:
	https://tug.org/pipermail/tex-live/2019-May/043612.html

2019-05-03  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* specials.c: transformation applied to current point was not
	done properly.

2019-05-03  Akira Kakuto  <kakuto@w32tex.org>

	* dpxfile.c, mfileio.h, pdfximage.c: Support non-ascii file
	names in default code page of OS irrespective of values of a
	variable 'command_line_encoding' (Windows only).

2019-05-03  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfobj.c, pdfobj.h: Add support for ASCIIHex and ASCII85
	decode filter. Support for decoding stream data with multiple
	filters applied. Remove unused function.
	* tt_cmap.c, tt_gsub.[ch]: Revise ToUnicode CMap creation for
	OpenType. Use GSUB for mapping unencoded glyphs to Unicode
	(XeTeX support), lowering priority of CJK compatibility
	ideographs.
	* configure.ac: Version 20190503.

2019-04-07  Karl Berry  <karl@freefriends.org>

	* TeX Live 2019.

2019-04-01  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfencoding.c: Fix a bug that dvipdfmx wrongly tries to
	create ToUnicode CMap even when there is no valid mapping
	entry. It just results in "Invalid CMap" warning.

2019-03-30  Akira Kakuto  <kakuto@w32tex.org>

	* spc_xtx.c: "ap->curptr" was copied to "buffer" without
	length validation. Fix this security problem.
	* spc_pdfm.c: "ap->curptr" was copied to "buffer" without
	length validation. Fix this security problem.
	* specials.c: Error message was written using vsprintf(),
	which has no length limitation. Use vsnprintf() instead.

	Report from Andy Nguyen of ETH Zurich.

2019-03-05  Clerk Ma  <maqiyuan130324@vip.qq.com>

	* tt_table.c: Fix 'null character(s)' warning caused by
	fonts like Roboto (Android) or YuMincho (Windows 10).

2019-02-25  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* tt_cmap.c (is_PUA_or_presentation):
	Skip also CJK Radicals Supplement, to lower the priority for
	double encoded glyphs. This does not break tounicode entries
	for glyphs which are only encoded in this region.

2019-02-25  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* tt_post.c: Since OpenType ver. 1.7, PostScript glyph names
	more than 32767 are allowed for version 2.0 post table. Some
	minore fixes in chek of valid index range.
	* configure.ac: Version 20190225.

2019-02-23  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* tt_post.c (tt_lookup_post_table): Fix a bug that the loop
	exceeds post->numberOfGlyphs (= the size of post->glyphNamePtr).
	https://github.com/texjporg/tex-jp-build/issues/74

2019-02-11  Karl Berry  <karl@tug.org>

	* configure.ac,
	* dvipdfmx.c: copyright 2019.

2019-02-10  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* cidtype0.c, cidtype2.c: Fix typo.

2019-01-27  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* spc_pdfm.c: Suppress a warning in tounicode special.
	Dvipdfmx had been giving a wrong warning when an optional
	argument to tounicode special is not supplied.

2018-12-27  Clerk Ma  <maqiyuan130324@vip.qq.com>

	* pdfobj.c: Introduce a static variable pdf_output_file_stats
	for LIBDPX. It does not affect (x)dvipdfmx.

2018-12-21  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* dvi.[ch], dvipdfmx.c, pdfdoc.[ch], pdfencrypt.[ch],
	spc_pdfm.c: Add a new special pdf:trailerid for directly
	specifying trailer ID.
	* spc_tpic.c, tfm.c, tt_gsub.c: Avoid compiler warning.
	* configure.ac: Version 20181221.

2018-10-12  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* dvipdfmx.c: Fix a bug that landscape option is not handled
	properly.
	* configure.ac: Version 20181012.

2018-10-08  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* mpost.c: Fix a bug in inline PS code handling.
	* dpxfile.c, pdfencrypt.c, type0.c: Avoid compiler warnings.
	* pdfobj.c: Fix a bug in (unused) TIFF predictor code.
	* configure.ac: Version 20181008.

2018-10-07  Simon Cozens  <simon@simon-cozens.org>

	* pdfobj.c: Clear static variables to allow PDF funcfions to
	be used more than once.

2018-10-02  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* dvipdfmx.c: Fixed a bug in handling of command line option '-M'.
	* mpost.c:  Fixed a bug in MetaPost generated PS files.
	Font selection had not been properly done for gsave/grestore.
	* configure.ac: Version 20181002.

2018-09-16  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* dvi.[ch], dvipdfmx.c: Fixed a bug that papersize special does
	not work (introduced in the previous change). Command line
	options other than papersize now take precedence over special
	command options.
	* dpxconf.[ch], tt_aux.c: Moved always_embed flag to dpx_conf.
	* pdfencrypt.c: Fixed a bug that calculation of encryption key
	was not done properly for RC4 and revision 2-3 AES security.

2018-09-16  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* dpxutil.[ch], dvi.[ch], dvipdfmx.c, pdfdoc.[ch], pdfencrypt.[ch],
	pdffont.[ch], xbb.c: Remove duplicated code. Reorganize
	initialization process. Use struct for passing options.
	* configure.ac: Version 20180916.

2018-09-14  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* agl.[ch], bmpimage.c, cid.[ch], cidtype0.[ch], cidtype2.[ch],
	cmap.[ch], cmap_read.c, dpxconf.[ch], dpxfile.[ch], dvi.[ch],
	dvipdfmx.[ch], epdf.c, fontmap.[ch], jp2image.c, jpegimage.c,
	mpost.[ch], pdfcolor.[ch], pdfdev.[ch], pdfdoc.[ch], pdfdraw.c,
	pdfencoding.[ch], pdfencrypt.[ch], pdffont.[ch], pdfobj.[ch],
	pdfximage.[ch], pngimage.c, spc_pdfm.c, spc_util.[ch],
	specials.[ch], subfont.[ch], t1_char.c, tfm.[ch], truetype.c,
	tt_aux.[ch], tt_cmap.[ch], tt_gsub.[ch], type0.[ch], type1.c,
	type1c.c, vf.[ch], xbb.c: Cleanup. Remove duplicated code.
	Reorganize global variables.
	* configure.ac: Version 20180914.

2018-09-09  Karl Berry  <karl@tug.org>

	* xdvipfm-bb.test: LC_ALL=LANGUAGE=C.

2018-09-06  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfencoding.c: Reverted change made for 20071115.
	ToUnicode creation for simple font was broken. Not working
	as intended at all.
	* pdfdoc.c, epdf.c, pdffont.c: Rearranged code.
	* pdfobj.c: Added some debugging code.
	* configure.ac: Version 20180906.

2018-09-04  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfobj.c: More fix on circular reference issue.
	* configure.ac: Version 20180904.

2018-09-02  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* dvi.c: Experimental support for XeTeX transparency font feature.
	* cid.c, cid_p.h, cidtype0.c, cmap.[ch], cmap_p.h, fontmap.[ch],
	pdfdev.c, pdffont.c, tt_cmap.[ch], type0.c:
	Removed reverse CMap mappings. Do not use cff charset data
	directly in pdfdev. Using reverse CMap for ToUnicode creation
	causes problems since input CMap can not be assumed to be
	always Unicode. Also, current implementation is imcomplete.
	* configure.ac: Version 20180902.

2018-08-28  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* otl_conf.[ch]: Removed. This undocumented feature is no
	longer used.
	* Makefile.am: Update for otl_conf.[ch] removal.

2018-08-27  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* jpegimage.c: Do not write application specific markers which
	are not necessary for displaying images.
	* pdfencrypt.c: Set a compatibility flag bit for PDF 2.0.
	* spc_pdfm.c: Fixed a bug that string objects are not handled
	properly in pdf:stream special. Additional dictionay keys can
	be specified for tounicode conversion.
	* configure.ac: Version 20180827.

2018-08-23  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* type1.c: Add glyph names of component glyphs used by seac
	operator to CharSet string.
	* configure.ac: Version 20180823.

2018-08-21  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfobj.c: Fix for "infinite loop" detection. Now handles the
	case of circular reference properly.
	* pdfencrypt.c: Fixed bug that key size is not adjusted
	correctly.
	* configure.ac: Version 20180821.

2018-08-18  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* cidtype2.c: Workaround for CIDSet issue. All glyphs
	including component glyphs and dummy glyphs except .notdef
	should be listed in CIDSet.

2018-08-17  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* cmap_write.c, tt_cmap.[ch], type0.c: Fixed a bug that
	CMapName in CMap resource is not properly written.
	Not correctly handles PostScript name and string objects.
	Use CMapName constructed from font's BaseFont entry.
	* spc_pdfm.c, spc_pdfm.h, specials.c: Added new special command
	pdf:pageresources similar to pdfTeX \pdfpageresources
	primitive.
	* pdfencrypt.c: Adobe extension for AES 256-bit encryption is
	not necessary for PDF version 2.0.

2018-05-23  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dvi.c: First search for an input file with a suffix .xdv
	or .dvi. Report from Andreas Scherer:
	http://tug.org/pipermail/tex-k/2018-May/002882.html.

2018-05-16  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* pdfparse.c: Revert. The changes on 2018-05-14 must be
	problematic. Again, kanji characters including 0x5c can't be
	used as names of image files in (e)-pTeX.

2018-05-14  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* pdfparse.c: Allow image file names including 0x5c for
	(e)-pTeX in CP932-like system (Windows only).

2018-05-06  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* tt_cmap.c: Revert a part of changes in 2017-12-09,
	which breaks to give tounicode entries for ligatures.
	http://tug.org/pipermail/tex-live/2018-May/041608.html.
	* configure.ac: Version 20180506.

2018-04-28  Stefan Br\"uns  <stefan.bruens@rwth-aachen.de>

	* pngimage.c: Fix a bug which causes a segfault with 1/2/4-bit
	transparent indexed PNGs.
	* configure.ac: Version 20180428.

2018-03-03  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* xbb.c: Remove unused lines.

2018-03-02  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* epdf.c, pdfobj.c, pdfobj.h: Remove multiple warnings.

2018-03-01  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* pdfobj.c: Fix typo and improve a warning (incomplete fix).

2018-02-17  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* cid.c, dpxfile.[ch], dvipdfmx.c, epdf.c, jp2image.c,
	jpegimage.c, pdfcolor.c, pdfencoding.c, pdfencrypt.c,
	pdflimits.h, pdfobj.[ch], pdfximage.c, pngimage.c,
	spc_dvips.c, spc_pdfm.c, spc_tpic.c, type0.c, xbb.c:
	Accept PDF version tag 2.0.
	* numbers.[ch], tfm.c: Remove format specific number
	representation from numbers.[ch].
	* configure.ac: Version 20180217.

2018-01-27  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* tfm.c, number.[ch]: Support new JFM spec (3-byte characters
	in TYPE > 0).

2017-12-21  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* jpegimage.c: If j_info->xdpi and j_info->ydpi are not
	determined in JPEG_scan_file(), they are assumed to be 72.0.

2017-12-09  Jiang Jiang  <gzjjgod@gmail.com>

	* tt_cmap.c (is_PUA_or_presentation, add_to_cmap_if_used):
	Skip KANGXI RADICALs which are commonly double encoded.
	http://tug.org/pipermail/xetex/2017-June/027147.html

2017-10-02  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* dvi.c: Initialize direction mode in clear_state(). See
	https://github.com/texjporg/tex-jp-build/issues/30

2017-09-18  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* tt_gsub.c: Fixed a bug that only last specified OTL GSUB
	feature was enabled.
	* configure.ac: Version 20170918.

2017-08-25  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* pdfximage.h, spc_pdfm.c: Remove MAX_IMAGES which is not
	needed.

2017-08-06  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* dpxutil.[ch], epdf.c, pdfdoc.[ch], pdfximage.c, xbb.c:
	Support for /Rotate page attribute in PDF inclusion.
	* configure.ac: Version 20170806.

2017-06-27  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* pdfdoc.c: Simplify the change in pdf_doc_get_page().
	* configure.ac: Change version number to distinguish from TL 2017.

2017-06-25  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* pdfdoc.c: Discard the backward compatibility for pdf BoundingBox
	in pdf_doc_get_page(), to be consistent with the latex
	driver dvipdfmx.def.

2017-06-25  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* tt_cmap.c: Fix a bug that different CMaps are not attached
	to each instances of font using different OpenType layout features.
	Fix a bug that ToUnicode support for substituted glyph was incomplete.

2017-06-24  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* spc_pdfm.c: Remove unused variable attr in spc_handler_pdfm_image().

2017-05-19  Karl Berry  <karl@tug.org>

	* Version 20170318 for TeX Live 2017 release.

2017-05-08  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* pdfdraw.c: Replace a small number 1.0e-8 by OUR_EPSILON = 2.5e-16,
	responding incompletely to
	http://tug.org/pipermail/tex-live/2017-May/040090.html.

2017-04-26  Paul Vojta  <vojta@math.berkeley.edu>

	* dvi.c, dvipdfmx.c, spc_html.c, spc_util.c: Support additional
	length units.

2017-04-16  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* tt_cmap.c: Fix a bug that generation of GID to CID mapping for
	format 2 CFF charsets was wrong. "unicode" encoding support was
	broken for fonts using this format.

2017-04-15  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* fontmap.c, tt_cmap.c, tt_gsub.c, tt_gsub.h, pdffont.c: Removed
	undocumented OpenType Layout GSUB support.  Added simplified version of
	OpenType Layout GSUB support. Fontmap option "-l otl_tags" enables
	OpenType GSUB features specified by otl_tags, where otl_tags is a ":"
	separated list of OpenType Layout feature tags
	(or strings of script.language.feature form).
	
2017-04-12  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dvipdfmx.c: Fix a bug in static const char *optstrig.
	
2017-04-09  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* tt_cmap.c: Vertical writing support had been broken since at some
	point of xdvipdfmx merge for "unicode" encoding. Apply vert/vrt2 GSUB
	feature when generating Unicode mapping.
	
2017-03-18  Karl Berry  <karl@tug.org>

	* xbb.c: update copyright years.
	
	* xdvipdfm-bb.test: remove any ^%%Creat line, not just %%CreationDate.
	* tests/*.[x]bb: remove %%Creator: lines since they embed version.

2017-03-18  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	Bump version to 20170318 for TeX Live 2017.

2017-03-01  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dvipdfmx.c: Command line -p option wins papersize and pagesize
	specials, as dvips.

2017-02-17  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dvi.c: Add possibly forgotten braces.

2017-01-24  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* jpegimage.c: Support Exif tags 0x5110, 0x5111, and 0x5112 in order to
	avoid warnings for some kind of jpeg images. Changes are borrowed from
	writejpg.w by Luigi in the recent LuaTeX.

2016-12-29  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* cid_basefont.h: Add data for STHeiti-Regular-Acro, and correct
	several data.

2016-12-18  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dvi.c, dvi.h, dvipdfmx.c, mpost.c, pdfencoding.c, pdfobj.c,
	pdfparse.c, pdfparse.h, tt_cmap.c, type0.c, type1.c, vf.c, xbb.c:
	Merge libdpx by Clerk Ma at https://github.com/clerkma/ptex-ng.

2016-10-30  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* pdffont.c, pdfobj.h: Use (time_t)-1 for INVALID_EPOCH_VALUE.

2016-10-05  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dpxfile.c: Use PATH_MAX instead of _MAX_PATH.

2016-10-03  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dpxfile.c: Sync with MikTeX.

2016-06-25  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	Modify to make PDF/A generation a bit easier.
	* pdfobj.c: Do not compress XMP Metadata.
	* cidtype2.c, type1.c, type1c.c: Always write CIDSet for CIDType2 and
	CharSet for Type1 font. Check consistency of glyph width.

2016-06-19  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* dvipdfmx.c: Disable overriding "D" option setting from
	dvipdfmx:config special.
	* configure.ac: Change version from 20160307 to 20160619 in order to
	distinguish the new one from that in TeX Live 2016.

2016-05-20  Karl Berry  <karl@tug.org>

	* Version 20160307 for TeX Live 2016.

2016-05-10  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* cidtype2.c: Fix bugs in horizontal-vertical mixed scripts by
	TrueType fonts.

2016-05-08  Masamichi HOSODA  <trueroad@trueroad.jp>

	* dvi.c, dvipdfmx.c, dvipdfmx.h, special.c: Add new specials to handle
	command line options.
	* spc_dvipdfmx.c, spc_dvipdfmx.h: Add for the new specials.
	* Makefile.am, Makefile.in: Change for the added spc_dvipdfmx.c,
	and spc_dvipdfmx.h.

2016-05-06  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* pdffont.c: Avoid to crash for too large a value of SOURCE_DATE_EPOCH.
	(w32 only).

2016-05-04  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* pdfdoc.c, pdfencrypt.c, pdffont.c, pdfobj.h, xbb.c: Improve the
	support of SOURCE_DATE_EPOCH.

2016-05-02  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* pdfdoc.c, xbb.c: Apply the patch by Alexis,
	http://tug.org/pipermail/tex-live/2016-May/038339.html
	for the support of SOURCE_DATE_EPOCH.
	* pdfencrypt.c: Use gmtime instead of localtime if SOURCE_DATE_EPOCH
	is given, to be consistent with the patch by Alexis.

2016-03-07  Karl Berry  <karl@tug.org>

	* man/dvipdfmx.1: .B not .b.
	Report on tex-k from esr, 29 Feb 2016 12:30:31.

2016-03-07  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* configure.ac, tests/*.[bb,xbb]: Update version number to 20160307
	for TeX Live 2016.

2016-03-01  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dvipdfmx.c, dvipdfmx.h, mpost.c: Introduce a new option --mvorigin.
	The translation of the origin in MP inclusion by using dvipdfmx.def
	or xdvipdfmx.def is enabled only if the option --mvorigin is set.

2016-02-25  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dvipdfmx.c: Change the default value of pdfdecimaldigits from 2
	to 3, to be consistent with pdfTeX.

2016-02-24  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* pdfdoc.c, pdfencrypt.c, pdffont.c, pdfobj.h, xbb.c: Support to output
	a unique pdf file from a unique xdv/dvi file. If an environment
	variable SOURCE_DATE_EPOCH is defined correctly like
	SOURCE_DATE_EPOCH=1456304783, the value is used as the current time,
	and if the name of the output pdf file is the same, its content is
	exactly unique.

2016-02-23  Masamichi HOSODA  <trueroad@trueroad.jp>

	* pdfdoc.c: Support UTF-16 with null bytes as labels.

2016-02-23  Jonathan Kew  <jfkthame@gmail.com>

	* dvicodes.h, dvi.c, pdfdev.[ch]: Support xetex 0.99995 output
	(dvi format 7) that includes ActualText content.

2016-02-17  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* spc_pdfm.c: Remaining fix for that on 2016-02-13.

2016-02-13  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* spc_pdfm.c: Remove maybe-redundant code to obtain consistency
	between dvi (dvipdfmx) and xdv (xdvipdfmx) with respect to
	\special{pdf:dest...}.

2016-02-09  Jiang Jiang  <gzjjgod@gmail.com>

	* dvi.c: Tweak skip_native_font_def() to make it handle more
	flags.
	* dpxutil.c: Remove a redundant check found by -Wall.

2016-02-09  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dvi.c: disable check_postamble() introduced by Peter, because
	features embolden != 0, slant != 0, and extend != 1 do not work.

2016-01-30  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* tt_post.c: Check post->glyphNamePtr[gid] before an access
	in tt_get_glyphname(). Reported by Werner LEMBERG:
	http://tug.org/pipermail/tex-live/2016-January/037696.html.

2016-01-19  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dpxfile.c: Remove trailing directory separators if any in
	dpx_get_tmpdir().

2016-01-11  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfobj.c, mfileio.[ch]: Modification on handling of xref table.
	More permissive on treating white-spaces but more strict on
	handling tokens.

2016-01-07  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* epdf.c: A typo in a message.
	* xbb.c: Change copyright year.
	* tests/: Change test data.

2016-01-06  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* t1_load.c: Avoid to crash for unsupported type1 fonts as native fonts.
	* configure.ac: version 20160106.
	* almost all files: change Copyright year.

2016-01-04  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dvi.c: Symplify support of native type1 fonts in XeTeX.

2016-01-03  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dpxfile.c: Change \ to / for WIN32 also in the case where
	HAVE_MKSTEMP is defined (win32 only).
	* cff.h, dvi.c, t1_load.c: Improve the change made on 2015-08-05.
	The static function static int is_notdef_notzero() in dvi.c is removed.

2015-12-30  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* epdf.[ch], pdfdoc.[ch], pdfximage.[ch],
	spc_{dvips,html,misc,pdfm,util}.c, spc_util.h: Don't use global variables
	for selecting boundary box. Cleanups.

2015-12-29  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* dvipdfmx.c, dvi.c: Allow empty password in pdf:encrypt special.
	* dvipdfmx.c, pdfdoc.[ch], pdfobj.[ch]: Add option to disable Xref
	stream and object stream.

2015-12-28  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* bmpimage.c, dvipdfmx.c, pdfobj.[ch], pngimage.c: Support for predictor
	functions for FlateDecode filter. PNG optimal and TIFF2 predictor functions
	are currently implemented. It solves the preblem that PNG images become
	sometimes larger in size when embedded in PDF file.

2015-12-26  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pngimage.c: Workaround for Adobe Potoshop generated PNGs which have
	cHRM chunk but not gAMA chunk.
	* agl.c, spc_pdfm.c, unicode.c, unicode.h: Addition of some
	Unicode related functions. Try conversion to UTF16BE only for string
	objects which can be considered as a valid Unicode text.

2015-12-24  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* t1_load.c: Support for get/putinterval and get/put in encoding
	definition found in some Type1 fonts such as cmctt10.pfb.

2015-11-05  Karl Berry  <karl@tug.org>

	* data/dvipdfmx.cfg (D): add -dAutoRotatePages=/None.
	Suggestion/request from Akira, 4 Nov 2015 22:41:14.

2015-09-27  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dvipdfmx.c: Remove conditional error message in kpathsea_debug,
	since there should be no errors.

2015-08-25  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* Most .c and .h files: Update Copyright years.
	Replace '(unsigned) long' by '(unsigned) int' or '(u)int32_t'
	except when needed with for ftell() and fseek().

2015-08-23  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* agl.[ch], cid.[ch], cidtype0.[ch], cidtype2.[ch], cmap_p.h,
	cs_type2.[ch], dpxcrypt.[ch], dpxutil.[ch], dvi.c, fontmap.[ch],
	otl_conf.c, pdfcolor..[ch], pdfdev.h, pdfdoc.c, pdfencoding.c,
	pdfencrypt.[ch], pdfnames.[ch], pdfobj.[ch], sfnt.h, spc_pdfm.c,
	spc_xtx.c, truetype.c, t1_char.[ch], tt_cmap.[ch], unicode.[ch]:
	No reason to use 'long' for 32-bit integers.

	* system.h: Moved #undef's for Win32 symbols from here ...
	* error.h, mpost.c: ... to here.

2015-08-21  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* dvipdfmx.c (main): Drop CDECL.
	* agl.c, otl_opt.c, pdfencoding.c, pdfnames.c, pdfobj.c,
	t1_char.c, tt_cmap.c, tt_glyf.c:
	Replace 'static <TYPE> CDECL' => 'static inline <TYPE>'.
	* system.h: Drop __cdecl and CDECL.

2015-08-14  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdfcolor.[ch]: Drop unused pdf_color_set_default().

	* pdfdev.h: Drop pdf_dev_setfont() and pdf_dev_set_colormode().

	* pdfdoc.[ch]: Drop unused pdf_doc_{end,make}_article().
	Declare pdf_doc_get_mediabox() as static.

	* pdfdraw.h: Drop pdf_dev_{fill,eofill,stroke,fillstroke}(), and
	pdf_dev_grestoreall().

	* pdfnames.[ch]: Declare printable_key() as static.

	* pdfximage.h: Drop pdf_ximage_disable_ebb().

	* tfm.[ch]: Drop tfm_get_space(). Skip tfm_string_{depth,height}.

	* tt_table.[ch]: Declare tt_get_name() as static.

2015-08-14  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* cff.[ch]: Declare cff_match_string() as static.
	* cff.h: Drop unused '#define cff_is_stdstr(s)'.

	* cid.[ch]: Declare CIDFont_new(), CIDFont_release(),
	CIDFont_flush(), and CIDFont_cache_init() as static.

	* cmap.[ch]: Declare CMap_match_codespace() as static.
	* cmap_write.h: Put '#if 0...#endif' around Map_ToCode_stream().

2015-08-13  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* agl.[ch]: Declare agl_load_listfile() as static.

	* cff_types.h: Drop unused type l_size.

	* dpxutil.[ch]: Extern sputx(), getxpair(), putxpair(),
	ostrtouc(), and esctouc() moved from here ...
	* cmap_write.c: ... to here or ...
	* pst_obj.c: ... to here as static.

2015-08-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* mpost.[ch]: Extern check_for_mp() moved from here ...
	* pdfximage.c: ... to here as static.

2015-08-05  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dvi.c: Introduce a new static function static int is_notdef_notzero()
	to fix the support of native type1 fonts. The t1disasm is required.
	The fix is intended as an intermediate one until more fine fix is given.

2015-08-03  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* dvi.c: Better detection of bad (inconsistent) DVI files.
	* xdvipdfm-bad.test: New shell script to test bad DVI files.
	* tests/ids_2_6.dvi, tests/ids_3_2.dvi, tests/ids_a_b.dvi,
	tests/opc_fe.dvi, tests/ptx_2_2.dvi, tests/ptx_6_6.dvi,
	tests/rev_2_2.dvi, tests/rev_2_3.dvi, tests/void.dvi: New test
	input data (bad DVI files).
	* Makefile.am: Add the new test and input data.

2015-07-31  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* dvipdfmx.c, xbb.c: Use getopt_long() for option parsing.

2015-07-30  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* xdvipdfm-ptx.test: New shell script to test Ascii pTeX output.
	* xdvipdfm-rev.test: New shell script to test TeX-XeT output.
	* tests/ptex.dvi, tests/reverse.dvi: New test input data.
	* Makefile.am: Add the new tests and input data.

2015-07-29  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* Makefile.am, ac/withenable.ac, configure.ac, dvipdfmx.c,
	xbb.c: Only one binary and a symlink dvipdfmx->xdvipdfmx.
	* ac/dvipdfm-x.ac (removed): Obsolete configure options.
	* dvipdfm*.test (removed): Obsolete tests.
	* tests/img*.{bb,bbx} (removed): Obsolete test data.

2015-07-29  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Make dvipdfmx and xdvipdfmx essentially the same.
	* dvicodes.h: Slightly reformat.
	* dvi.c: Run-time decision to hanlde XeTeX extensions only for
	id_byte 6 and Ascii pTeX extension only for post_id_byte 3.
	* pdfdev.c: Remove '#ifdef XETEX' (one probably a mistake).
	* pdfdoc.c: New artbox handling only for XDV files (from XeTeX).
	* system.h: Drop redundant #include <kpathsea/c-auto.h>.

2015-07-28  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdfdoc.c: Somewhat simplify to avoid compiler warnings.

2015-07-22  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* epdf.c. pdfdoc.c, pdfobj.h, pdfximage.c, spc_pdfm.c, spc_util.c, xbb.c:
	Support pagebox=artbox etc. in PDF inclusion. It works with a new
	dvipdfmx.def. Thanks Y. Terada.

2015-07-18  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* epdf.c, pdfobj.c: Try to embed a PDF image, even if the PDF version
	is newer than the setting.

2015-07-08  Simon Cozens  <simon@simon-cozens.org>

	* pngimage.c: Fixed a typo "XObjcect" => "XObject".

2015-07-07  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* Makefile.am: Better dependencies for 'make check'.
	* ac/dvipdfm-x.ac: Fixed a typo.
	* xdvipdfmx.test: Fixed a typo.

2015-07-06  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* dpxcrypt.c: Bugfix: Replace byte => uint8_t.
	* dpxcrypt.[ch]: Replace u{8,32,64} => uint{8,32,64}_t.
	* pdfencrypt.c: Declare pdf_enc_init() as static.
	drop useless cast (const char *) => (char *).
	* unicode.h: Drop unnecessary #include <inttypes.h>.

2015-07-04  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* jpegimage.c: Use size_t, uint32_t,... instead of short/long int.
	* dpxcrypt.c/h, dvi.c/h, pdfencrypt.c/h, dvipdfmx.c, pdfobj.c:
	Add AES encryption support in PDF ecryption.
	* pngimage.c : Support images with 16 bit depth.
	* unicode.c/h: Add UTF-8 decoding function.

2015-05-23  Jiang Jiang  <gzjjgod@gmail.com>

	* dvi.c: Fix Type1 font encoding and metrics.

2015-05-21  Karl Berry  <karl@tug.org>

	* version 20150515 for TL'15.

2015-05-06  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dvi.c: Do not identify Type1 fonts as TrueType or OpenType.

2015-05-04  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* cidtype0.c: Avoid compiler warnings:
	(CIDFont_type0_get_used_chars, CIDType0Error_Show,
	CIDFontInfo_init, CIDFontInfo_close, -CIDType0Error,
	CIDFont_type0_add_CIDSet): Declare as static.
	(CIDFont_type0_add_CIDSet): Initialize num_glyphs, last_cid.
	(CIDFont_type0_open): Always initialize sfont, drop unused.

2015-05-01  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* cidtype0.c: Support old compilers.

2015-05-01  Jiang Jiang  <gzjjgod@gmail.com>

	* cidtype0.c, cidtype0.h, cid.c: Combine all Type 0 open functions
	into one. Simplify some implementations.

2015-04-27  Jiang Jiang  <gzjjgod@gmail.com>

	* cidtype0.c: Fix TTC support for Type 1 Composite and Type 0 fonts.

2015-04-27  Jiang Jiang  <gzjjgod@gmail.com>

	* dpxfile.c: Ignore empty file in filetype checking.

2015-04-26  Jiang Jiang  <gzjjgod@gmail.com>

	* cidtype0.c, cidtype2.c: Support loading CID type 0 font from
	TrueType Collection.

	* truetype.c: Fix offset in offset for TrueType loading.

2015-04-25  Jiang Jiang  <gzjjgod@gmail.com>

	* cff_dict.c: Be more permissive in CFF dict parsing, fix Yuppy SC
	and Yuppy TC fonts support.

2015-04-25  Jiang Jiang  <gzjjgod@gmail.com>

	* sfnt.c: Fix Mac TrueType font support.
	  bug found by Richard Koch <richardmoncriefkoch@icloud.com>.

2015-04-21  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* dvi.c, tt_cmap.c: Fixed a dfont bug, from Akira,
	  bug found by Dohyun Kim <nomosnomos@gmail.com>.

2015-04-19  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pngimage.c: Ask libpng to do gamma correction with assumed
	screen gamma 2.2.

2015-04-12  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfobj.c:  Fix some problems in reading cross-reference streams.
	* pngimage.c: Support PNG gAMA chunk.
	* jpegimage.c: Various fixes in handling JPEG Exif data
	(possible overflow and buffer overrun), adjusting indent and spaces.
	* jp2image.c: JPEG2000 opacity channel support.
	* pdfcolor.c: Update for PDF 1.7 in pdfcolor.c.

2015-04-05  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pngimage.c: XMP Metadata support for PNG images.

2015-03-27  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* mfileio.[ch]: Use mfgets() parameters as for fgets().

2015-03-24  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* bmpimage.c, dpxcrypt.c, dvi.c, fontmap.[ch], jpegimage.c,
	pdfcolor.[ch], pdfdev.[ch], pdfdoc.c, pdfdraw.c, spc_tpic.c,
	spc_util.c, spc_xtx.c, xbb.c: Copyright "2014" => "2015".

2015-03-24  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dvipdfmx.c: Change "Copyright (C) 2002-2014" to
	"Copyright (C) 2002-2015".

2015-03-17  Khaled Hosny  <khaledhosny@eglug.org>

	* pdfcolor.c, pdfcolor.h, pdfdoc.c, pdfdraw.c, spc_util.c: Add spot
	colors support, based on patch by Apostolos Syropoulos.

2015-03-15  Khaled Hosny  <khaledhosny@eglug.org>

	* tests/*.{bb,xbb}: Update version number.

2015-03-15  Karl Berry  <karl@tug.org>

	* configure.ac: version 20150315 for TL'15.

2015-03-12  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* jpegimage.c: Fix a bug introduced by me on 2015-02-16.

2015-03-01  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* spc_tpic.c: Make tpic "ar" command dvips compatible to fix the problem
	that an excess line is drawn when "ar" command is used along
	with dvips transformation commands.

2015-02-25  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* fontmap.h (pdf_insert_native_fontmap_record): Declare also
	without '#ifdef XETEX'.
	* fontmap.c (pdf_insert_native_fontmap_record): Define also
	without '#ifdef XETEX'; drop redundant test for path==NULL.

2015-02-24  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* dvi.c (dvi_locate_native_font): Avoid sprintf() buffer overrun.

	* dvi.c (dvi_locate_native_font): Fix a small memory leak.

2015-02-21  Khaled Hosny  <khaledhosny@eglug.org>

	* dvi.c (dvi_locate_font, dvi_locate_native_font): make sure the
	all members of loaded font struct are initialized, avoid crash in
	dvi_close for simple fonts because hvmt member is not initialized.
	Fixes the xdvipdfmx-bkm test.
	* dvi.c (dvi_locate_native_font): fix loading files without absolute
	paths.
	* dvi.c (dvi_locate_native_font): fix loading TTC fonts.
	* xdvipdfm-ttc.test, tests/ttc.dvi, tests/ttc.tex, tests/test.ttc,
	Makefile.am: new test.
	* dvi.c (dvi_locate_native_font): correctly load vertical glyph
	metrics.
	* configure.ac, Makefile.am: drop FreeType dependency.
	* dvi.c, fontmap.c, fontmap.h: remove the nonop pdf_load_native_font.
	* fontmap.c, fontmap.h (pdf_insert_{native_}fontmap_record): return
	the newly inserted record.
	* dvi.c: adapt.

2015-02-21  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dvi.c: Read glyph advances without the need for FreeType, based on
	patch by Clerk Ma.
	* fontmap.c, fontmap.h: Stop loading FreeType fonts.

2015-02-16  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* jpegimage.c: Fix jpeg_get_density().

2015-01-07  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* bmpimage.c, dpxcrypt.c, dvi.c: Avoid compiler warnings.

2015-01-07  Khaled Hosny  <khaledhosny@eglug.org>

	* pdfdev.c (pdf_dev_reset_fonts): don't reset text_state.bold_param
	unless called for a new page, otherwise we "forget" that the last font
	was a fake bold font and don't reset text stroke when this function
	gets called immediatly after a fake bold font is used
	(https://sourceforge.net/p/xetex/bugs/105/).
	* pdfdev.h, pdfdoc.c, pdfdraw.c, spc_xtx.c: adapt.

2014-12-03  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* xbb.c: Support to specify a page in a multi-page PDF to extract
	bounding box, usage: extractbb -p page foo.pdf.

2014-12-01  Karl Berry  <karl@tug.org>

	* data/dvipdfmx.cfg (D): add back -sPAPERSIZE=a0, needed for
	pstricks under xetex; retain -dEPSCROP, needed for negative llx/lly.
	From Akira, thread at
        http://tug.org/pipermail/xetex/2014-November/025664.html.

2014-11-29  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* dvipdfmx.test, xdvipdfmx.test: Also test --showpaper option.	

2014-11-29  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dvipdfmx.c, dpxconf.c, dpxconf.h: Add an option --showpaper which
	shows available paper formats and exits.

2014-11-29  Karl Berry  <karl@tug.org>

	* dvipdfmx.c (show_usage): use [all pages] instead of (-).
	From peb.

2014-11-28  Karl Berry  <karl@tug.org>

	* dvipdfmx.c (main): accept --extractbb per help message.
	(show_usage): one line of description.
	* xbb.c (show_usage): likewise.
	Suggestion from Tom Schneider, texhax 22 Nov 2014 08:53:19.

2014-11-19  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* dvipdfmx.c: Modified support to make DLL(s) in W32TeX.

2014-11-15  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dvipdfmx.c: Support to make DLL in W32TeX.

2014-11-05  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dpxfile.c: Check if fqpn == NULL in dpx_open_file(), because
	MESG (fqpn) crashes if fqpn == NULL.

2014-11-04  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pkfont.c: Fix the messed up formatting codes.
	* pdfparse.c: Avoid undefined behaviour when char is signed.

2014-11-03  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pdfdev.c: Do not convert integer part of real numbers to long int
	when printing a real number.
	* pdfparse.c: Do not use temporary integer values for storing
	parsed numbers.
	* pkfont.c: Remove debugging codes, additional fixes in formatting
	integer values.

2014-10-29  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* pkfont.c: Cast unsigned integers when they appear in subtractions
	to obtain results in double.

2014-10-05  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* spc_dvips.c: Add " showpage\n" to a temporary file gs_in because
	Ghostscript 9.15 gives an empty pdf without it
	in dpx_file_apply_filter().

2014-10-03  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* spc_dvips.c: Fix a bug in spc_dvips_at_end_page (void), that is
	change "if (!temporary_defs)" to "if (temporary_defs)".

2014-09-29  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* spc_pdfm.c: Minor cleanup.

2014-09-25  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* {bmp,jp2,jpeg,png}image.[ch], xbb.c: More cleanup (whitespace
	and long => int or uint32_t).

2014-09-24  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* jp2image.c: Add newline at end of file.
	(read_box_hdr): Correctly handle 8byte lbox value.
	(read_res__data): Change result type 'unsigned long' => 'void'.
	(scan_res_): Reindent.

	No reason to use 'long' for 32-bit integers.
	* bmpimage.[ch], jp2image.[ch], xbb.c: Change bmp_get_bbox() and
	jp2_get_bbox() args 'long *' => 'int *'.

2014-09-20  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* spc_pdfm.c: If input string is UTF16BE with BOM, do nothing in
	maybe_reencode_utf8().

2014-09-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	No reason to use 'long' for 32-bit integers.
	* dvi.[ch], pkfont.c, specials.[ch], tfm.[ch]: Use (u)int32_t
	instead of long, UNSIGNED_QUAD, etc.
	* dvipdfmx.c: Replace long => int.
	* jp2image.c, otl_conf.c: Drop rewind() after file_size().
	* mfileio.[ch]: New functions xfile_size(), xseek_absolute(),
	xseek_relative(), xseek_end(), and xtell_position().
	* numbers.[ch]: Replace (UN)SIGNED_BYTE => (un)signed char,
	(UN)SIGNED_PAIR => (un)signed short, (UN)SIGNED_TRIPLE =>
	un)signed int, (UN)SIGNED_QUAD => (u)int32_t.
	New functions get_unsigned_num() and get_positive_quad().
	* vf.c: Use get_positive_quad() and get_unsigned_num().

2014-09-01  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* vf.c: Add missing break in case X1: case X2: case X3: case X4:
	in void vf_set_char(int32_t ch, int vf_font).

2014-08-24  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* t1_char.c: Fix a bug in type1 handling reported by Bob Tennent
	(http://tug.org/pipermail/tex-live/2014-June/035580.html).

2014-08-22  TANAKA Takuji  <KXD02663@nifty.ne.jp>

	* error.h: Allow Unicode messages on Windows console.

2014-08-22  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* vf.c (get_pkt_unsigned_num): Fixed a stupid bug/typo.

2014-08-21  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* numbers.[ch]: New function skip_bytes().
	* vf.[ch]: Simplify VF reading. Replace, e.g., long => int32_t.

2014-08-20  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* configure.ac: Add AC_TYPE_INT32_T for int32_t.
	* numbers.c: Drop unused code.
	* numbers.h: Drop unused code.
	Include <inttypes.h> and <stdint.h> for int32_t and uint32_t.
	Clarify signed vs unsigned four byte numbers from binary files.
	* dvi.c: Simplify handling of DVI commands.
	* vf.c: Replace 'Ubyte' => 'unsigned char'.

2014-08-19  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pngimage.c: Avoid PNG warnings.

2014-08-16  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* dvi.c: Drop unused variable. Use "%lu" for unsigned long vars.

2014-08-16  Khaled Hosny  <khaledhosny@eglug.org>

	* dvi.c, dvicodes.h, fontmap.c, fontmap.h: Switch to XDV version 6
	used by latest XeTeX.

2014-08-16  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dvipdfmx.c, pdflimits.h: Set PDF_VERSION_DEFAULT = 5 to be
	consistent with dvipdfmx.cfg.

2014-08-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdfobj.c: Avoid unconstifying casts. Drop unused variable.
	Avoid possibly uninitialized use of variable filter_name.

2014-08-14  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* pdfobj.c: Return 1 even if the PDF version of included file is
	newer than the assumed version in check_for_pdf(), because
	load_image() in pdfximage.c needs very long time if format ==
	IMAGE_TYPE_UNKNOWN and the file size is very large.
	Anyway the inclusion of the PDF file fails.

2014-08-14  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* epdf.c, pdfobj.c: Support streams with DecodeParms.

2014-08-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* dvipdfm-bb.test, xdvipdfm-bb.test: Also test .bmp and .jp2.
	* tests/image.{bmp,dvi,jp2,tex}: Additional test input.
	* tests/{img,pic}{bmp,jp2}.{bb,xbb}: Expected test output.
	* Makefile.am (EXTRA_DIST): Add the new files.

2014-08-11  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* jp2image.c: Declare scan_file() as static. Drop variables
	that are set but not used [-Wunused-but-set-variable].

2014-08-11  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* bmpimage.[ch], jp2image.[ch] (new), pdfximage.c, xbb.c:
	Add support for JPEG 2000 (JP2 and JPX baseline subset) and
	BMP support for extractbb.

2014-08-11  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* Makefile.am: Drop libutil.a, i.e., compile all files once for
	dvipdfmx and once for xdvipdfmx.

2014-08-05  Jiang Jiang  <gzjjgod@gmail.com>

	* tt_cmap.c (otf_create_ToUnicode_stream, create_ToUnicode_cmap):
	Only load CMAP_TYPE_CODE_TO_CID cmap to do reverse lookup when
	constructing ToUnicode streams for PDF.

	* type0.c, type0.h, pdffont.c: Remove redundant pdf_font_findfont()
	function.

2014-08-05  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pst_obj.c, t1_char.c: ANSI C function protos and definitions,
	i.e., FOO(void) instead of FOO().

2014-08-04  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* tt_cmap.c (create_ToUnicode_cmap): Drop unused variables.

2014-08-04  Jiang Jiang  <gzjjgod@gmail.com>

	* cff.c (cff_get_glyphname): Remove duplicated cff_read_charsets()
	call.

	* tt_cmap.c (sfnt_get_glyphname, create_ToUnicode_cmap): Make sure
	we only do glyph name lookup for CFF fonts when they are not CID
	fonts.

	* cmap_read.c: Fix warnings when comparing size_t with negative
	value (< 0).

2014-08-03  Jiang Jiang  <gzjjgod@gmail.com>

	* tt_cmap.c (sfnt_get_glyphname, handle_subst_glyphs): Fix error on
	glyph name lookup.

	* cff.c (cff_glyph_lookup), pdfdev.c (pdf_dev_set_string): Correctly
	handles the dvi file when Unicode to CID mapping file is specified,
	where pdf_dev_set_string() got string of cids instead of glyphs.

	* cmap.c: Add reverse lookup from CID to Unicode codepoints.

	* tt_cmap.c, type0.c: Refactor create_ToUnicode_cmap{4, 12}(), use
	  reverse CMap lookup to construct ToUnicode streams.

2014-08-03  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* pdfobj.c: Fix a typo in check_for_pdf().

2014-08-02  Shunsaku Hirata  <shunsaku.hirata74@gmail.com>

	* tt_cmap.c: Fix a bug in unicode encoding in CFF/OpenType fonts.

2014-08-01  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* type0.c: Fix a bug in Type0Font_clean (Type0Font *font).

2014-07-30  Khaled Hosny  <khaledhosny@eglug.org>

	* dvi.c, dvicodes.h: Support TeX-XeT's begin_reflect and end_reclect
	opcodes in dvipdfmx.

	* dvi.c (dvi_set, do_glyph_array): Use dvi_right to ensure
	consistency.

2014-07-29  Khaled Hosny  <khaledhosny@eglug.org>

	* spc_pdfm.c: remove the #ifdef ENABLE_TOUNICODE as it is always true.
	* spc_pdfm.c: rename my_parse_pdf_dict to
	parse_pdf_dict_with_tounicode.

	* dvipdfmx.c, dvi.c: Always accept .xdv file extension.
	* dvipdfmx.c: Remove some unnecessary is_xetex checks.
	* dvipdfmx.c: Allow DVIPDFM emulation mode even with xdvipdfmx, there
	is no much gain from not doing so.
	* pdfnames.c: Remove wrong is_xetex check.

	* dvi.c, dvipdfmx.c, dvipdfmx.h, spc_pdfm.c: Rename is_xetex to is_xdv
	and set it to 1 when DVI id equals XDV_ID.

	* pdfdev.c (pdf_dev_locate_font): Don't crash if mrec is None.
	* dvipdfm.test, xdvipdfm.test, Makefile.am: Test the above bug.
	* tests/xbmc.{dvi,tex}, tests/xbmc10.{600pk,tfm}: New test data.

2014-07-28  Jiang Jiang  <gzjjgod@gmail.com>

	* dpxfile.c (qcheck_filetype): Skip opening non-existent file.

	* tt_cmap.c (lookup_cmap12): Fix a compiler warning when trying to
	  compare unsigned value with 0.

2014-07-28  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* type0.c (Type0Font_*_ToUnicode_stream): Declare once as static
	(once again!).

2014-07-28  Khaled Hosny  <khaledhosny@eglug.org>

	* dvi.c (do_pic_file): Don't insert the pic file while skimming
	reflected segments.

	* tt_cmap.c (handle_subst_glyphs): Don't try to added invalid CMap
	entries (regression from r34718).

	* cff.c, cff.h: Add cff_get_glyphname convenience function.
	* tt_cmap.c (sfnt_get_glyphname): Support getting glyph names from
	OpenType/CFF fonts (regression from r34718).

2014-07-28  Jiang Jiang  <gzjjgod@gmail.com>

	* cid.c, pdfdev.c: Correct release of retained cff_charsets.

2014-07-27  Jiang Jiang  <gzjjgod@gmail.com>

	* cff.c, cff.h, cid.c, cid_p.h, cidtype0.c, fontmap.c, fontmap.h,
	pdfdev.c: Fix CID-keyed fonts glyph lookup with XeTeX.

	* pdfdev.c, pdffont.c, pdffont.h, tt_cmap.c, type0.c, type0.h: Fix
	reverse CMap lookup for ToUnicode map generation.

	* cff.c: Avoid read past 65536 glyphs.

2014-07-26  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* dpxfile.c: Add a default case to avoid compiler warnings.

2014-07-25  Khaled Hosny  <khaledhosny@eglug.org>

	* dpxfile.c, dpxfile.h: Use an enum for resource type instead of
	preprocessor macros (easier to view in a debugger).

	* dvi.c, vf.c: Remove unnecessary is_xetex checks; there is no reason
	not to support SET3 and PUT3 in xdvipdfmx (XeTeX does not use them
	anyway).

2014-07-24  Khaled Hosny  <khaledhosny@eglug.org>

	* cff.c. cff.h, cid.c, cid.h, cid_p.h, cidtype0.c, cidtype2.c,
	pdffont.c, pdffont.h, sfnt.c, sfnt.h, t1_load.c, truetype.c, tt_aux.c,
	tt_cmap.c, tt_cmap.h, tt_glyf.c, tt_gsub.c, tt_post.c, tt_post.h,
	tt_table.c, type0.c, type1c.c: These files are now identical for
	dvipdfmx and xdvipdfmx and are part of libutil.a.
	* type0.h (Type0Font_get_ft_to_gid): Removed.
	* Makefile.am: Adapted.

	* pdfdev.c: Reduced dvipdfmx/xdvipdfmx diffs.

	* dvi.c: Use dvi_is_tracking_boxes when applicable.

2014-07-22  Khaled Hosny  <khaledhosny@eglug.org>

	 * src/dvi.c, src/dvicodes.h: Support DVI-IVD inspired text reflection
	 for XeTeX.
	 * src/vf.c: Adapt

2014-07-22  Karl Berry  <karl@tug.org>

	* Makefile.am (check-libutil-source-list): new target for manual
	checking of #ifdef XETEX list.
	(libutil_a_SOURCES): move type1c.c (containing #ifdef XETEX) from here
	(dvipdfmx_SOURCES): to here.

	* cidtype0,
	* type1c.c: add disambiguating numbers to the repeated
	"Not a CFF/OpenType font?" message.  (Many other repeated msgs remain.)

2014-07-21  Karl Berry  <karl@tug.org>

	* fontmap.c (fontmap_parse_mapdef_dps): ignore the second <
	in << in a map file line (just like the [ in <[ has always been
	ignored).
	* Makefile.am (EXTRA_DIST): add fullmap.tex and .dvi,
        just for documentation/future purposes, not executed as a new test.
       Report from Ulrike Fischer, 4 Jun 2014 11:15:06 +0200,
       http://tug.org/pipermail/tex-live/2014-June/035486.html

2014-07-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* cmap_read.c: Avoid cast from pointer to integer of different
	size on 64-bit Windows.

2014-06-22  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* spc_dvips.c: Use rungs instead of gswin32c in order to support
	both of gswin32c and gswin64c (Windows only).

2014-06-21  Khaled Hosny  <khaledhosny@eglug.org>

	* pdfdoc.c: Set PDF Docinfo's /Producer string from pdf:docinfo if
	supplied (http://sourceforge.net/p/xetex/bugs/93/).

2014-06-20  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* agl.c, cid.c, dpxfile.c, dpxutil.c, dvipdfmx.c, epdf.c,
	fontmap.c, mpost.c, otl_conf.c, otl_opt.c, pdfnames.c,
	pdfparse.c, spc_dvips.c, spc_html.c, spc_misc.c, specials.c,
	subfont.c: Avoid undefined behaviour when char is signed.

2014-06-20  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* xbb.c: Check kpse_in_name_ok and kpse_out_name_ok in extractbb.

2014-06-16  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* Makefile.am: Drop the obsolete ACLOCAL_AMFLAGS.

2014-05-22  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dvipdfmx.c: disable warnings in the case of -q option.

2014-05-13  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdfobj.[ch] (pdf_unshift_array): Bug fix: correctly copy array
	elements, using memmove().  Declare pdf_unshift_array as static.
	Bug reported by Richard M Kreuter <kreuter@progn.net>.

2014-05-10  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* bmpimage.c: Error exit instead of crashing for unsupported
	bmp inclusion in bmp_include_image().

2014-05-04  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dvipdfmx.c: Move special-case single option --help or --version
	after determination of program name (from Heiko).
	Change my_name for extractbb and ebb.
	xbb.c: Move '++flag' from inside 'if()' to 'then' part of the
	'if' statement (from Heiko).

2014-04-30  Khaled Hosny  <khaledhosny@eglug.org>

	* tt_cmap.c: [XDVIPDFMX] prefere glyph name for glyph with PUA or
	alphabetic presentation forms entries in font cmap.

2014-04-24  Karl Berry  <karl@tug.org>

	* man/dvipdfm.1,
	* Makefile.am (dist_man1_MANS): rename man page to dvipdfmx.1.
	(man1_links): make a dvipdfm.1 link.
	[XDVIPDFMX]: make an xdvipdfmx.1 link.

2014-04-17  Karl Berry  <karl@tug.org>

	* dvipdfmx.c (show_usage): default map in practice is pdftex.map.
	* man/dvipdfm.1: major update to something closer to current
	reality, from Bob Tennent and me.

2014-03-31  Karl Berry  <karl@tug.org>

	* dvipdfmx.c (show_usage): avoid long lines in help msg,
	include bug reporting address, and
	(show_version): use printf instead of fprintf(stdout.

2014-03-24  Karl Berry  <karl@tug.org>

	* error.c (WARN, ERROR): use my_name, not loud stars.
	#include "dvipdfmx.h" for decl.
	* tt_table.c: use WARN for warnings, not fprintf.

2014-03-20  Karl Berry  <karl@tug.org>

	* dvipdfmx.c (show_version): eliminate useless leading blank line.
	(main): special-case --help and --version on their own to avoid
	possible diagnostics.

2014-03-18  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* xbb.c: Update one more Copyright year.
	* tests/{img,pic}{jpeg,png,pdf}.{bb,xbb}: Update Creator.

2014-03-17  Karl Berry  <karl@tug.org>

	* configure.ac: version 20140317 for TeX Live 2014.
	* all files: update copyright years.

2014-03-17  Bob Tennent  <rdt@cs.queensu.ca>

	* dpxfile.c (dpx_open_file),
	* fontmap.c (pdf_load_fontmap_file): show fontmap file found,
	if verbose.

2014-03-06  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* dvi.c, dvipdfmx.c: Remove unused code.
	* pdfdraw.c: Remove unused arg1 of pdf_dev__rectshape() and
	pdf_dev__flushpath().

2014-01-27  TANAKA Takuji  <KXD02663@nifty.ne.jp>

	* dvipdfmx.c: Revise procedure of reading command line arguments.
	(Windows only)

2014-01-20  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dpxfile.c: Fix a bug in dpx_file_apply_filter(), report from
	Michael Rutter <http://tug.org/pipermail/tex-live/2014-January/034771.html>

2014-01-13  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* Makefile.am, /ac/withenable.ac, configure.ac:
	Replace libs/paper => libs/libpaper.

2014-01-13  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* dbxfile.c [WIN32]: Include <wchar.h>.  Avoid use of
	uninitialized variables cmdvw and qvw.

2014-01-12  TANAKA Takuji  <KXD02663@nifty.ne.jp>

	* dvipdfmx.c: Add '--kpathsea-debug' option and
	fix a bug in '--dvipdfm' option.
	* dvipdfmx.c, mfileio.[ch], dbxfile.c: Allow Unicode file name
	on Windows.

2014-01-02  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pngimage.c: Allow libpng >= 1.6.3 to read images with
	incorrect CMF bytes.

2013-12-16  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* Makefile.am (dvipdfmx_SOURCES): Move cidtype0.c to here.
	From Alexey Kryukov <anagnost@yandex.ru>

2013-12-14  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* spc_xtx.c: Guarantee that mline in is_pdfm_mapline(mline) is a
	zero-ended string when called by spc_handler_xtx_fontmapline().

2013-12-13  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* spc_pdfm.c: Guarantee that mline in is_pdfm_mapline(mline) is a
	zero-ended string when called by spc_handler_pdfm_mapline().

2013-11-28  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* xbb.c: Add suffixes ".ai", ".AI" for the Illustrator files.
	In recent illustrators, their default format is PDF.

2013-11-23  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* mpost.c: Fix a bug which I introduced in MetaPost mode (-M option).
	Note that the definition of x, and y in
	pdf_doc_begin_page (scale, x, y) is the negative of those in
	pdf_doc_begin_grabbing (ident, x, y, ...).

2013-11-23  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* mpost.c: Set the origin at (llx, lly) to match the new xetex.def
	and dvipdfmx.def.

2013-11-06  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* xbb.c: Set pdf_version in extractbb to be PDF_VERSION_MAX.

2013-11-04  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* pdfobj.c: Correct %c to %d since pdf_version is unsigned int.
	Fix a typo.

2013-10-24  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* Makefile.am, /ac/withenable.ac, configure.ac: Use libs/paper.

2013-10-12  Khaled Hosny  <khaledhosny@eglug.org>

	* dvi.c, dvicodes.h: Rename XDVI_ID to XDV_ID.

2013-09-30  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* configure.ac: Drop the useless KPSE_LT_HACK.
	Drop the redundant AC_HEADER_STDC and check for mkstemp.

2013-09-26  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* epdf.c, pdfdraw.c, pdfobj.c, pdfximage.c, spc_color.c,
	spc_color.c, specials.c: These files are now identical for dvipdfmx
	and xdvipdfmx and are part of libutil.a.
	* Makefile.am: Adapted.

	* spc_pdfm.c: Reduced dvipdfmx/xdvipdfmx diffs.

2013-09-26  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* bmpimage.c, dpxfile.c, pdfparse.c, spc_html.c, spc_tpic.c:
	These files are now identical for dvipdfmx and xdvipdfmx and are
	part of libutil.a.
	* Makefile.am: Adapted.

	* cff_dict.c, pdfdraw.c, pdfobj.[ch], pdfximage.[ch],
	tt_table.c, type1.c: Reduced dvipdfmx/xdvipdfmx diffs.

2013-09-25  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdfnames.c: Fix (x)dvipdfm-bkm.test (notjump).

2013-09-24  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdfnames.[ch], pdfobj.c, specials.c: Fix (x)dvipdfm-res.test
	(tikz-bug).

	* tests/annot.{dvi,tex}: Test a broken link annotation.

2013-09-20  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dpxcrypt.h, dpxcrypt.c: Use uint32_t instead of unsigned long to
	calculate MD5, because it leads to an error if compiled with clang
	on 64bit OS X, reported by T. Yamamoto.

2013-09-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* (x)dvipdfm-bkm.test: Additional tests with bookmarks.
	* tests/bookm.{dvi,tex}: Additional test input files.
	* Makefile.am: Adapted.

2013-09-01  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* spc_util.c: This file is identical for dvipdfmx and xdvipdfmx,
	now part of libutil.a.

2013-08-18  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* epdf.c (add_stream_flate): Use z_const.
	* pdfobj.c (pdf_add_stream_flate): Use z_const.

2013-08-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* dvipdfmx.c (show_usage): Adapt to modified program (stdin).
	* xdvipdfm-psz.test: Fixed a typo (found by Mojca Miklavec).

2013-08-11  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dvipdfmx.c: pdf_filename should not be NULL to compare it with
	a string.

2013-08-10  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* dvipdfmx.[ch]: Declare and define 'char *my_name' as
	"dvipdfmx" or "xdvipdfmx" and use it instead of PROGNAME.
	* pdfdoc.c, pdfencrypt.c: Use my_name instead of PACKAGE.

	* dvipdfmx.c, pdfobj.c: Use option '-o -' for output to stdout.

	* dvipdfmx.c, dvi.c: Allow dvipdfmx to read from stdin.

	* pdfobj.c (write_dict): Drop '\n' saving a few kb.

	* pdfcolor.[ch], pdfdev.c, pdfdraw.[ch], spc_pdfm.c: Always use
	dvipdfmx type color handling.

	* agl.c, cmap_write.c, dpxutil.c, jpegimage.c, otl_conf.c,
	pdfcolor.c, pdfresource.c, pngimage.c, pst.c, pst_obj.c,
	spc_misc.c, tfm.c, vf.c, xbb.c: These files are identical for
	dvipdfmx and xdvipdfmx, now part of libutil.a.

	* configure.ac: Define PACKAGE again via AC_INIT.
	* dpxfile.c: Use "dvipdfmx" for kpse_reset_program_name().

	* (x)dvipdfm-psz.test: Test (x)dvipdfmx with stdin and stdout.

2013-08-09  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* dvi.c: Bug fix: handle papersize specials, suggested by Akira
	(from Hironori Kitagawa <h_kitagawa2001@yahoo.co.jp>).

	* (x)dvipdfm-psz.test: Additional tests with papersize specials.
	* tests/paper.{dvi,tex}: Additional test input files.
	* Makefile.am: Adapted.

	* *.test: Sanitize environment variables (from Akira).

2013-08-08  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdfdoc.[ch], pdfnames.c, spc_pdfm.c: Bug fix: handle pdf:bann,
	pdf:eann, and pdf:ann specials.

2013-08-07  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* configure.ac: Avoid that config.h depends on $enable_build.
	Replace CHO_CHECK_{ZLIB,LIBPNG} => AC_LINK_IFELSE and
	CHO_CHECK_LIBPAPER => KPSE_LIBPAPER.
	Makefile.am: Use $(PAPER_INCLUDES) and (PAPER_LIBS).

2013-08-06  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* (x)dvipdfm-ann.test: Additional tests.
	* tests/cmr10.{pfb,tfm}, tests/annot.{dvi,tex},
	tests/psfonts.map: Additional test input files.
	* Makefile.am, dvipdfmx.cfg: Adapted.

	Bugfix from Akira:
	* dvi.c, xdvipdfmx.c: May need to append ".dvi" to dvi_filename.
	* xdvipdfmx.c: At the moment dvipdfmx can not read stdin.

2013-08-02  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdfobj.c (pdf_open): Bugfix: Always set pf->catalog.
	* xbb.c: Use same code to get the .pdf bounding box in dvipdfmx
	and xdvipdfmx.
	* dvi.c: Avoid duplicate page number output, e.g., "[1[1]]".
	* (x)dvipdfmx.test: Add test with image files.
	* tests/image.tex, tests/image.tex: Additional test input files.
	* Makefile.am (EXTRA_DIST, DISTCLEANFILES): More test IO files.
	Define PACKAGE as "dvipdfmx" for kpse_reset_program_name().

2013-07-29  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* Removed diffs between src/ and xsrc/ version of the remaining
	files and moved them to the top-level: cidtype0.c, dvi.c,
	dvipdfmx.c, epdf.c, jpegimage.c, pdfcolor.c, pdfdev.c, pdfdoc.c,
	pdfdraw.c, pdfobj.c, pdfximage.c, spc_pdfm.c, spc_tpic.c,
	tt_cmap.c, type1c.c, xbb.c.
	* Makefile.am: Adapted.

	* jpegimage.c (jpeg_get_density): Bugfix (from xdvipdfmx r108).

2013-07-22  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* tt_aux.c, tt_post.c: Try to avoid a segfault for some broken
	TrueType fonts with 'post' table Version 0x00000000UL or other.

	* unicode.[ch]: Drop '#include "agl.h"' and others.
	* pdffont.c: Add '#include "agl.h"'.

	* Removed diffs between src/ and xsrc/ version of these files
	and moved them to the top-level: cff_dict.c, pdfencrypt.c,
	pdfnames.h, spc_dvips.c, specials.c, tfm.c, truetype.c, type1.c.

	* Makefile.am (libutil.a): Build a library from files that do
	not depend on '-DXETEX': cs_type2.c, dpxconf.c, dpxcrypt.c,
	error.c, mem.c, mfileio.c, numbers.c, otl_opt.c, pdfencoding.c,
	pdfencrypt.c, subfont.c, unicode.c.

	* Reduced dvipdfmx/xdvipdfmx diffs in these files:
	dvipdfmx.c, jpegimage.c, pdfdoc.c, pdfdraw.c, pdfnames.c,
	pdfobj.c, pdfximage.c, spc_pdfm.c, spc_tpic.c, tt_cmap.c, xbb.c.

2013-07-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* xsrc/jpegimage.c: Added jpeg_get_bbox() and jpeg_get_density()
	from src/jpegimage.c.
	* xsrc/pdfdoc.c: Added pdf_doc_get_page() from src/pdfdoc.c.
	* xsrc/pngimage.c: Added png_get_bbox() from src/pngimage.c.
	* xbb.h (removed): Merged ...
	* dvipdfmx.h: ... into here.

	* Removed diffs between src/ and xsrc/ version of these files
	and moved them to the top-level: pdfobj.h, pngimage.c.

	* Reduced dvipdfmx/xdvipdfmx diffs in these files:
	dvipdfmx.c, epdf.c, pdfdoc.c, pdfobj.c, pdfximage.c, xbb.c.

	* src/dvipdfmx.c, xsrc/dvipdfmx.c: Add '--xbb', '--ebb' options.

	* (x)dvipdfmx.test: Correctly set the environment variables.
	* (x)dvipdfm-bb.test: New shell scripts to test bounding box
	extraction.
	* tests/dvipdfmx.cfg, tests/image.* (new): Test input files.
	* tests/img*.*, tests/pic*.* (new): Expected output files.
	input and expected output files.

2013-07-10  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* Removed diffs between src/ and xsrc/ version of these files
	and moved them to the top-level: cff.c, dvi.h, mpost.c,
	pdfdev.h, pdfdoc.h, pdfdraw.h.

	* Reduced dvipdfmx/xdvipdfmx diffs in these files:
	dvi.c, dvipdfmx.c, epdf.c, xbb.c.

	* *src/dvipdfmx.c: Use FILESTRCASEEQ instead of !STRN_CMP.

2013-07-08  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* Removed diffs between src/ and xsrc/ version of these files
	and moved them to the top-level: bmpimage.c, cidtype2.c, epdf.h,
	fontmap.c, pdfcolor.h, pdfparse.c, pdfximage.h, sfnt.[ch],
	tt_aux.[ch], tt_post.c, tt_table.c.

	* Reduced dvipdfmx/xdvipdfmx diffs in these files:
	cidtype0.c, epdf.c, pdfcolor.c, pdfdev.[ch], pdfximage.c.

2013-07-06  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* xsrc/dvi.c: Use !FILESTRCASEEQ instead of STR_CMP.

2013-07-05  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* Removed diffs between src/ and xsrc/ version of these files
	and moved them to the top-level: cff.h, spc_color.c, 
	spc_html.c, spc_util.[ch], tt_glyf.c, type0.c.

	* Reduced dvipdfmx/xdvipdfmx diffs in these files:
	cff.c, dvi.[ch], cidtype0.c, cidtype2.c, dvipdfmx.c, fontmap.c,
	pdfcolor.[ch], truetype.c, tt_aux.[ch], type1c.c.

	* Makefile.am: Moved Makefile fragments to ../../am/.

2013-07-03  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* Removed diffs between src/ and xsrc/ version of these files
	and moved them to the top-level: dpxfile.[ch], fontmap.h,
	jpegimage.h, pngimage.h, tt_cmap.h, type0.h, vf.c, xbb.h.

	* Reduced dvipdfmx/xdvipdfmx diffs in these files:
	src/cff_dict.c, (x)src/cidtype0.c, (x)src/cidtype2.c,
	(x)src/dvipdfmx.c, (x)src/jpegimage.c, src/pdfencrypt.c,
	src/pdfparse.c, src/pngimage.c, src/spc_html.c,
	(x)src/tt_cmap.c, (x)src/tt_table.c, src/xbb.c.

2013-07-01  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* data/Makefile.am, man/Makefile.am (removed): Merged into ...
	* Makefile.am: ... here.
	* configure.ac: Adapted.

2013-06-30  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* First '#include <config.h>' in all C files and not in headers.

2013-06-29  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* src/dvipdfmx.h, xsrc/spc_xtx.[ch]: Moved to the top-level.
	* Moved these files (identical in src/ and xsrc/) to the
	top-level: agl.[ch], bmpimage.h, cff_dict.h, cff_limits.h,
	cff_stdstr.h, cff_types.h, cid.[ch], cid_basefont.h, cid_p.h,
	cidtype0.h, cidtype2.h, cmap.[ch], cmap_p.h, cmap_read.[ch],
	cmap_write.[ch], cs_type2.[ch], dpxconf.[ch], dpxcrypt.[ch],
	dvicodes.h, mem.[ch], mfileio.[ch], mpost.h, numbers.[ch],
	otl_conf.[ch], otl_opt.[ch], pdfencoding.[ch], pdfencrypt.h,
	pdffont.[ch], pdflimits.h, pdfparse.h, pdfresource.[ch],
	pkfont.[ch], pst.[ch], pst_obj.[ch], sfnt.h, spc_color.h,
	spc_dvips.h, spc_html.h, spc_misc.[ch], spc_pdfm.h, spc_tpic.h,
	specials.h, subfont.[ch], system.h, t1_char.[ch], t1_load.[ch],
	tfm.h, truetype.h, tt_glyf.h, tt_gsub.[ch], tt_post.h,
	tt_table.h, type1.h, type1c.h, unicode.[ch], vf.h.

	* Removed diffs between src/ and xsrc/ version of these files
	and moved them to the top-level: dpxutil.[ch], error.[ch]. 

	* Makefile.am: Adjust.

2013-06-28  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* (x)src/Makefile.am (removed): Merged into Makefile.am.
	* src/dvipdfmx.test, src/dvipdft, xsrc/xdvipdfmx.test: Moved ...
	* dvipdfmx.test, dvipdft, xdvipdfmx.test: ... to here.
	* Makefile.am, configure.ac: Adapted.

2013-06-26  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* src/dvipdfmx.test: Invoke ./dvipdfmx instead of dvipdfmx.
	* xsrc/xdvipdfmx.test: Invoke ./xdvipdfmx instead of xdvipdfmx.

	Reduce dvipdfmx/xdvipdfmx diffs.

	* xsrc/spc_color.[ch], xsrc/spc_misc.[ch], xsrc/spc_pdfm.[ch],
	xsrc/spc_xtx.[ch], xspc/specials.c: Drop no-op functions
	spc_*_at_{begin,end}_{document,page}().
	* (x)spc/spc_dvips.[ch], (x)spc/specials.c: Use '#ifdef XETEX'
	to avoid most diffs.

2013-06-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Merge dvipdfmx and xdvipdfmx into dvipdfm-x.

	* README, ChangeLog: Merged and consolidated the files from
	dvipdfmx and xdvipdfmx.

2013-05-30  Karl Berry  <karl@tug.org>
	
	* version 20130405 for TeX Live 2013.

2013-04-30  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* src/dpxfile.c, src/pdfximage.c, src/dvipdfmx.c, data/dvipdfmx.cfg:
	Add a compatible mode with the old behavior per Karl, where
	image cache is ignored.

2013-04-30  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* (x)dvipdfmx.test: New shell scripts for a simple test.
	* Makefile.am: Adapted.

2013-04-30  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* src/dvipdfmx.c: Default is not to cache image files.
	Must not cast command line value to 'unsigned'.

2013-04-30  Karl Berry  <karl@tug.org>

	* data/dvipdfmx.cfg (D): back to using -dEPSCrop instead of
	-sPAPERSIZE=a0, in conjunction with changes to dvipdfmx.def
	and xetex.def.
	(I): set to -1 for the safest default.

2013-04-05  Karl Berry  <karl@tug.org>

	* configure.ac: version 20130405 for TL'13.

2013-03-28  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* src/dpxfile.c, src/spc_dvips.c: Recover dpx_create_temp_file()
	for PSTricks.

2013-03-26  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* src/dpxfile.[ch]: Avoid gcc warnings.

2013-03-26  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* src/dvi.c: Correct my mistake to delete RELEASE(q).

2013-03-25  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Patch from Tsuchimura Nobuyuki <tutimura@nn.iij4u.or.jp> to
	speed up inclusion of eps figures.
	* data/dvipdfmx.cfg, src/dpxfile.[ch], src/dvi.c,
	src/dvicodes.h, src/dvipdfmx.c, src/pdfximage.c, src/vf.c:
	Applied with small modifications to avoid compiler warnings,
	adapted for WIN32 by Akira Kakuto.

2013-03-24  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* src/dpxfile.c: Change dpx_create_temp_file() because tmpnam()
	sometimes fails on Windows.

2013-03-20  Khaled Hosny  <khaledhosny@eglug.org> 

	Only for xdvipdfmx:
	* spc_dvips.c (spc_handler_ps_tricks_pdef, spc_handler_ps_tricks_tdef,
	spc_handler_ps_tricks_bput, spc_dvips_at_begin_document, calculate_PS):
	Don't crash when temporary file creation fail.

2013-03-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for xdvipdfmx:
	* dvi.c (dvi_locate_native_font): Drop unused variable.

2013-03-14  Khaled Hosny  <khaledhosny@eglug.org>

	Only for xdvipdfmx:
	* src/dvi.c, src/dvicodes.h, vf.c: Revert "Support DVI-IVD inspired text
	reflection for XeTeX".
	* src/fontmap.c: Remove commented out old Mac code.
	* src/fontmap.c (pdf_load_native_font_from_path, pdf_load_native_font):
	Merge.
	* src/dvi.c, src/fontmap.c, src/fontmap.h: Ignore native font family and
	style names that we no longer use.
	* src/dvi.c (read_native_font_record, do_native_font_def): Don't check
	for XDV_FLAG_FONTTYPE_* flags as they do nothing.
	* src/dvi.c (do_glyph_array): Use FT_Get_Advance() instead of the slower
	FT_Load_Glyph().
	* src/dvi.c, src/fontmap.c, src/fontmap.h: Drop no longer needed
	glyph_widths cache.
	* dvi.c: Drop unneeded includes.

2013-02-25  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* src/dpxutil.[ch]: Reduce dvipdfmx/xdvipdfmx diffs.
	* src/fontmap.[ch]: Copied from xdvipdfmx to dvipdfmx.
	* src/agl.c: Copied from dvipdfmx to xdvipdfmx.

	Only for xdvipdfmx:
	* src/fontmap.c, src/pdfnames.c, src/pdfobj.c, src/spc_pdfm.c,
	src/tt_cmap.c: Adapt to modified definition of ht_*_table().

2013-02-22  Khaled Hosny  <khaledhosny@eglug.org>

	Only for xdvipdfmx:
	* src/fontmap.c (pdf_load_native_font_from_path): Fix loading font files
	without an extension (e.g. Mac suitcase fonts).

2013-02-21  Khaled Hosny  <khaledhosny@eglug.org>

	Only for xdvipdfmx:
	* src/tt_cmap.c (handle_subst_glyphs): Use FT_Get_Glyph_Name() instead of
	reading 'post' table directly, to handle CFF fonts where the 'post' table
	has no glyph names.
	* rc/tt_cmap.c (create_ToUnicode_cmap4, create_ToUnicode_cmap12,
	otf_create_ToUnicode_stream): Adapt.

2013-02-15  Khaled Hosny  <khaledhosny@eglug.org>

	Only for xdvipdfmx:
	* src/cidtype2.c: Fix loading *.dfont files on non-Mac platforms.
	* src/fontmap.c: Don't include unused ApplicationServices headers
	* configure.ac src/Makefile.am: Don't check for now unused Apple
	ApplicationServices.

2013-02-12  Khaled Hosny  <khaledhosny@eglug.org>

	Only for xdvipdfmx:
	* src/dpxfile.c, src/dpxfile.h (dpx_find_dfont_file): Make public.
	* src/fontmap.c (pdf_load_native_font_from_path): Fix loading *.dfont files.
	* src/fontmap.c (pdf_load_native_font): Drop use of deprecated ATS API, all
	native fonts should be given as file names.
	* src/fontmap.c (pdf_load_native_font): Show failed font name in error
	message.

2013-02-08  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* data/Makefile.am (configdatadir, mapdatadir, cmapdatadir):
	Change texmf => texmf-dist.

2013-01-29  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for dvipdfmx:
	* configure.ac, src/Makefile.am: Allow subdir-objects.

2013-01-21  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for xdvipdfmx:
	* src/dvi.c: Avoid unused variables sbuf and slen.

2013-01-19  Khaled Hosny  <khaledhosny@eglug.org>

	Only xdvipdfmx:
	 * src/dvi.c, src/dvicodes.h: Support DVI-IVD inspired text reflection
	 for XeTeX.
	 * src/vf.c: Adapt
	 * src/dvi.c: Drop code for ancient FreeType 2.2.0
	 * src/fontmap.c, src/fontmap.h: Drop no longer use FreeType version
	 variables.

2013-01-11  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Reduce dvipdfmx/xdvipdfmx diffs.

	Only for dvipdfmx:
	src/Makefile.am: Use AM_CPPFLAGS instead of dvipdfmx_CPPFLAGS.
	src/cid.[ch], src/cid_p.h, src/cid_p.h, src/dvicodes.h,
	src/fontmap.h, src/pdffont.[ch], src/sfnt.[ch], src/t1_load.c,
	src/tt_glyf.c, src/tt_gsub.c: Copied from ../xdvipdfmx.

	Only for xdvipdfmx:
	* src/agl.c: Definition of hval_free() moved up.
	* src/pdffont.h: Added #ifdef XETEX ... #endif.
	* src/t1_load.c: Added #ifdef XETEX ... #else ... #endif.
	* src/dpxconf.[ch], src/dpxcrypt.[ch]: Copied from ../dvipdfmx.
	* src/sfnt.c: '#if HAVE_CONFIG_H' => '#ifdef HAVE_CONFIG_H'.

2013-01-10  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* read_v2_post_names() in tt_post.c: Change calculation of post->count
	for special fonts with unused index.

2013-01-10  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* src/cid.c: Avoid casts (const char *) -> (char *).

2013-01-09  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Avoid various gcc-4.6 warnings.
	* src/cidtype2.c, src/dvipdfmx.c, src/fontmap.c, src/otl_conf.c,
	src/pdfencoding.c, src/spc_pdfm.c, src/tt_cmap.c: Do not use
	unsafe casts (char **) -> (const char **).
	* src/bmpimage.c, src/cidtype0.c, src/cidtype2.c, src/dvi.c,
	src/jpegimage.c, src/pdffont.c, src/pkfont.c, src/spc_pdfm.c,
	src/tt_aux.c, src/tt_cmap.c, src/tt_glyf.c, src/tt_post.c,
	src/type1.c, src/type1c.c: Drop set but unused variables.
	src/pdfdraw.c: Do not test '(&v) != NULL', this is always true.

2012-12-12  Khaled Hosny  <khaledhosny@eglug.org>

	* src/tt_cmap.c: Make sure CMapName of embedded CMaps does not contain
	slashes.

2012-12-11  Khaled Hosny  <khaledhosny@eglug.org>

	Only for xdvipdfmx:
	* src/tt_cmap.c: Fix crash with fonts that has some glyphs without name
	entries in 'post' table.

2012-11-20  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for xdvipdfmx:
	* src/Makefile.am: Avoid use of deprecated INCLUDES.

2012-09-24  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for dvipdfmx:
	* version.ac (removed): We now maintain dvipdfmx here.
	* configure.ac: Adapted.

2012-09-21  Karl Berry  <karl@tug.org>

	* many files: remove useless $Header$ from old repo,
	do not point to dvipdfmx@ email address any more.

2012-09-19  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ChangeLog.TL (removed): Now merged ...
	* ChangeLog: ... into this.

2012-09-07  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	Only for xdvipdfmx:
	* fontmap.c: unused function pdf_clear_fontmaps
	* fontmap.h: unused function pdf_clear_fontmaps
	* pdfcolor.c: unused functions pdf_get_colorspace_num_components,
	pdf_get_colorspace_subtype
	* pdfcolor.h: unused functions pdf_get_colorspace_num_components,
	pdf_get_colorspace_subtype
	* pdfdev.c: unused functions pdf_dev_currentfont, pdf_dev_get_font_ptsize
	* pdfdev.h: unused functions pdf_dev_currentfont, pdf_dev_get_font_ptsize
	* pdfdraw.c: unused functions static int pdf_coord__itransform,
	pdf_dev_setflat, pdf_dev_itransform, pdf_dev_rectstroke
	* pdfdraw.h: unused functions pdf_dev_setflat, pdf_dev_itransform,
	pdf_dev_rectstroke
	* pdffont.c: unused functions pdf_get_font_fontname, pdf_font_get_flags
	* pdffont.h: unused functions pdf_get_font_fontname, pdf_font_get_flags
	* pdfobj.c: unused functions pdf_put_array, pdf_shift_array,
	pdf_pop_array, pdf_put_dict, pdf_stream_set_flags, pdf_stream_get_flags
	* pdfobj.h: unused functions pdf_put_array, pdf_shift_array,
	pdf_pop_array, pdf_put_dict, pdf_stream_set_flags, pdf_stream_get_flags
	* type0.c: unused function Type0Font_get_encoding
	* type0.h: unused function Type0Font_get_encoding

2012-09-06  Khaled Hosny  <khaledhosny@eglug.org>

	Only for xdvipdfmx:
	* configure.ac, src/fontmap.c, src/Makefile.am: Remove FontConfig
	dependency, as it is not needed anymore with recent XeTeX.

2012-08-31  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Reduce TL/W32TeX diffs.
	* src/cidtype0.c, src/cidtype2.c, src/cmap_write.c, src/mpost.c,
	src/truetype.c, src/tt_cmap.c, src/tt_gsub.c, src/tt_post.c:
	Cast function args to avoid WIN32 (MSVC) warnings.
	* src/pdfobj.c (pdf_out_xchar): Reformulate to avoid MSVC warnings.
	* src/xbb.c (show_usage): Correctly report .bb or .xbb as default.

	Only for xdvipdfmx:
	* src/xbb.c: Always use binary mode for output file.

	Only for xdvipdfmx:
	* src/pdfencrypt.c (getpass) [WIN32]: Use "*" to `echo' password.
	* src/dvipdfmx.c (main) [WIN32]: Call texlive_gs_init().
	* src/dvi.c (dvi_init): Fix logic for appending ".dvi" or ".xdv".
	* spc_dvips.c: Use binary mode for all file io.
	[WIN32]: Use gswin32c; avoid memory leak.

2012-08-26  Akira Kakuto <kakuto@fuk.kindai.ac.jp>

	Only for dvipdfmx:
	* src/tt_table.c (tt_read_hhea_table),
	src/tt_post.c (read_v2_post_names),
	src/cc_tmap.c (otf_load_Unicode_CMap): typos.

2012-08-26  Khaled Hosny  <khaledhosny@eglug.org>

	Only for xdvipdfmx:
	* src/agl.c: Reduce differences with dvipdfmx.
	* BUGS, NEWS, TODO, contrib/*, doc/*, index.html, style_base.css,
	style_dflt.css, style_ie.css, style_plain.css: Remove files removed
	from dvipdfmx.
	* data/*: Sync with dvipdfmx.

2012-08-23  Khaled Hosny  <khaledhosny@eglug.org>

	Only for dvipdfmx:
	* src/Makefile.am: Remove mention of non-existent files.

	Only for xdvipdfmx:
	* src/dvipdfmx.c, src/mem.c, src/mem.h, src/xbb.c, src/dvipdfmx.c,
	src/mem.c, src/mem.h, src/xbb.c: Remove memory debugging code.
	* src/agl.c, src/agl.h: Remove the built-in AGL name list to minimize
	difference with dvipdfmx.
	* src/agl_standard.c, src/mk_agl_standard_c.pl: Removed.
	* src/asl_charset.h: Removed unused file.
	* src/Makefile.am: Adapted.

2012-08-21  Akira Kakuto <kakuto@fuk.kindai.ac.jp>

	* src/tt_post.c (read_v2_post_names): support large truetype fonts
	which are strictly speaking out of spec, idx > 32767.
	* src/dvipdfmx.c: support monocase filesystem.

2012-08-21  keiichirou shikano <k16.shikano@gmail.com>

	* src/cff.c, src/cff.h. src/type1.c: fix type1 SEAC bug.

2012-08-21  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for dvipdfmx:
	* src/dpxfile.c: Drop tests for __TDS_VERSION__.
	* configure.ac: Drop definition of __TDS_VERSION__.

	Only for xdvipdfmx:
	Try to avoid mem_debug_check warning.
	* spc_dvips.c (spc_dvips_at_end_document): Free ps_headers.

2012-08-20  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for dvipdfmx:
	Flatten, i.e., remove dvipdfmx-20120420/.
	* Makefile.am (EXTRA_DIST): Drop  $(DVIPDFMX_TREE){,-PATCHES}.
	* configure.ac: Drop DVIPDFMX_TREE.
	* version.ac (removed): Obsolete.

2012-08-20  Khaled Hosny  <khaledhosny@eglug.org>

	Only for dvipdfmx:
	* src/dvipdfmx.c, src/mem.c, src/mem.h, src/xbb.c, src/dvipdfmx.c,
	src/mem.c, src/mem.h, src/xbb.c: Remove memory debugging code.

2012-08-18  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	Only for xdvipdfmx:
	* dvi.c: Fix a bug in dvi_init(). The old one fails for dvi or xdv
	files of very short name. For example "xdvipdfmx t" fails for t.xdv.

2012-08-18  Khaled Hosny  <khaledhosny@eglug.org>

	Only for dvipdfmx:
	Move contents of dvipdfmx-20120420 to the top directory
	* Makefile.am, configure.ac, data/Makefile.am, man/Makefile.am,
	src/Makefile.am: Adapted.
	* configure.in, m4/cho-kpse.m4, m4/cho-libs.m4, m4/maw-time.m4:
	Removed.

2012-05-21  Norbert Preining  <preining@logic.at>

	Only for dvipdfmx:
	* patch-05-cid-x_map (new): add entries for rml-jis and gbm-jis

2012-05-06  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* fontmap.c: fix a typo. allow pdftex.map without PS name.

2012-04-27  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Reduce dvipdfmx/xdvipdfmx diffs.
	* cid.[ch], cidtype[02].c, dpxutil.[ch], pdfdoc.[ch],
	mem.[ch], truetype.c, tt_cmap.c, type1c.c: Trivial changes.

2012-04-25  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Try to avoid mem_debug_check warning.

	Only for dvipdfmx:
	* mem.c: Increase MEM_LINE, avoid C99-ism, add tex-k@tug.org.

	Only for xdvipdfmx:
	* mem.h: Enable use of MEM_DEBUG.
	* mem.c: Increase MEM_LINE, avoid C99-ism, add tex-k@tug.org.
	* dvipdfmx.c (main): Enable mem_debug_check().

	For both:
	* spc_pdfm.c (spc_handler_pdfm_stream_with_type): Free fullname.

2012-04-21  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for dvipdfmx:
	* dvipdfmx.c (show_version): Print "modified for TeX Live,".

2012-04-20  Alexander Grahn  <A.Grahn@hzdr.de>

	* src/spc_pdfm.c: use kpse to find media

2012-04-20  Norbert Preining  <preining@logic.at>

	* src/dvipdfmx.c: add a new directive "i" for reading subsidiary
	config files
	* data/dvipdfmx.cfg: document the new directive

	Only for dvipdfmx:
	Imported snapshot 20120420.
	* version.ac, man/dvipdfm.1: Adapted.

2012-04-14  Khaled Hosny  <khaledhosny@eglug.org>

	* src/spc_dvips.c: Fixed bug in "ps: plotfile" special.

2012-03-29  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Remove extern decls from *.c files.

	* dpxfile.c: Drop obsolete comment that mkstemp may not be
	declared in stdlib.h.
	* spc_color.c: Drop 'extern' from function definition.
	* error.h: ANSI C prototype for error_cleanup().
	* error.c: Drop extern decl, now in error.h.
	* dvipdfmx.c: Add '#include "error.h"' and drop extern decl.

	Only for xdvipdfmx:
	* dvi.c: Move extern decls from here ...
	* dvi.h: ... to here ...
	* fontmap.h: ... and here.
	* tt_aux.c: Move extern decl from here ...
	* tt_aux.h: ... to here ...
	* dvipdfmx.c: ... and #include "tt_aux.h".

2012-03-05  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdfdev.c (handle_multibyte_string): Handle UTP-16 surrogates
	for UCS-4 supplementary planes.
	Based on patch from Tanaka Takuji-san.

2012-03-04  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for xdvipdfmx:
	Avoid 'the address of XXX will always evaluate as true' warnings.
	* pdfdraw.c (m_stack_depth): Use '(s) != NULL' instead of '(s)'.
	Gcc >=4.3 produces identical code but -Wall yields no warning.

2012-02-28  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for xdvipdfmx:
	* configure.ac: Fixed a typo (no libpaper for TeX Live builds).

2012-01-17  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	Only for dvipdfmx:
	* dvi.c, pdfdev.c: Support for (e-)(u)pTeX dtou direction.

2011-12-06  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* data/Makefile.am:
	Replace ${prefix}/texmf => $(datarootdir)/texmf.

2011-11-06  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	Only for xdvipdfmx:
	* spc_pdfm.c: fix a typo in spc_handler_pdfm_dest().
	reencode also the destination in \special{pdf:dest ...} to UTF-16.

2011-11-05  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	Only for dvipdfmx:
	* dvi.c, spc-pdfm.c, tfm.c and vf.c: remove incompatible lines
	with the non-upTeX case and erase #ifdef upTeX.

2011-10-18  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for xdvipdfmx:
	* tt_cmap.c: Fix typo "featre" -> "feature".

2011-09-07  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	Only for xdvipdfmx:
	* dvi.c, spc-pdfm.c, tfm.c and vf.c: apply patches by Takuji Tanaka
	in order to support (e)-upTeX. The (e)-upTeX support is enabled by
	defining upTeX. In the case -DupTeX, the dvipdfmx must be compatible
	with the old one, which can be obtained without -DupTeX.

2011-06-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* configure.ac (AC_TYPE_UINT32_T): Portability fix for AIX.
	* dpxcrypt.c: Use headers as in configure test for uint32_t.

	Only for dvipdfmx:
	* patch-02-exec_spawn (new): Bug fix for exec_spawn() from
	Akira Kakuto  <kakuto@fuk.kindai.ac.jp> and Peter Breitenlohner.

2011-06-06  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* dpxfile.c (exec_spawn): Do not quote execvp() arguments.

2011-06-03  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* dpxfile.c (exec_spawn): Exit if execvp() fails, some clean up.

2011-06-03  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* dpxfile.c: fix a bug in exec_spawn().

2011-05-31  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for dvipdfmx:
	* man/extractbb.1: Update extractbb manpage.

2011-05-09  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for dvipdfmx:
	* ../dvipdfmx-20110311/data/dvipdfmx.cfg: Synched from Master.
	* patch-00-cfg: Adapted (by Karl Berry <karl@tug.org>).

2011-05-03  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for dvipdfmx:
	Imported snapshot 20110311.
	* configure.ac: Adapted.

2011-04-29  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for dvipdfmx:
	* patch-00-cfg (new): Change dvipdfmx.cfg to use rungs instead of
	the default ps2pdf -dSAFER, to avoid complete pstricks failure with
	xetex.

2011-04-18  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for xdvipdfmx:
	* src/fontmap.c [OS X]: #include FT_MAC_H to get prototype for
	FT_GetFilePath_From_Mac_ATS_Name().

2011-03-11  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* dpxcrypt.c:
          Applied the patch for 64bit systems; suggested by Akira Kakuto.

2011-03-10  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* src/*.[ch]: Remove trivial dvipdfmx/xdvipdfmx diffs.

	Only for xdvipdfmx:
	* src/Makefile.am: Mark asl_charset.h as unused.

2011-03-09  Jin-Hwan Cho <chofchof@ktug.or.kr>

	Only for dvipdfmx:
	* dpxfile.c, configure.in, man/extractbb.1:
          Applied the patches for TeX Live 2011 by Peter Breitenlohner.

2011-03-09  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	Only for xdvipdfmx:
	* src/dvipdfmx.c, src/pdfencrypt.c and src/pdfencrypt.h:
	recover compute_id_string() for the consistency with dvipdfmx
	as much as possible.

2011-03-09  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* configure.ac: Check for <sys/wait.h>, drop check for system().
	* src/pdfencrypt.c (compute_id_string): Drop unused function.

2011-03-09  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* src/dpxfile.c: Avoid to use system().

2011-03-07  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for dvipdfmx:
	* patch-01-dpxfile (new): Use concat3() instead of concatn().
	Avoid compiler warnings: add const's; cast `unsigned char' to
	`unsigned short' for printing.
	* patch-02-manpage (new): Add ebb to NAME; better formatting.

2011-03-07  Matthias Franz

	* dvi.c, dvi.h, dvipdfmx.c, pdfencrypt.c, pdfencrypt.h, spc_pdfm.c:
          Added special pdf:encrypt to turn on document encryption from
          within the DVI file (suggested by Michael Joyner). Format:
            \special{pdf:encrypt ownerpw (abc) userpw (xyz) length 128 perm 252}
          If a parameter is omitted, the default value / empty password
          is used. The special must appear at the beginning of the file.

2011-03-05  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* dpxfile.c:
          Applied the secutiry patch written by Akira Kakuto
          (suggested by Karl Berry).

2011-02-28  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* src/pngimage.c (create_cspace_ICCBased): Avoid libpng-1.5.x
	compiler warning.

2011-02-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for dvipdfmx:
	* src/Makefile.am [WIN32]: Add dvipdfmx.exe, ebb.exe, and
	extractbb.exe wrappers for MinGW.

2010-02-11  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for dvipdfmx:
	* man: New directory with manual pages (from Master).
	man/dvipdft.1 needs to be updated and man/dvipdfm.1 replaced by
	man/dvipdfmx.1 (with a link to dvipdfm.1).
	* Makefile.am, configure.ac: Adapted.

	* man/extractbb.1, man/dvipdfm.1, dvipdft.1: Formatting.

2010-12-30  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for dvipdfmx:
	* src/dvipdfmx.c: Check for argv[0] with .exe via strcasecmp().

2010-12-29  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Only for dvipdfmx:
	* configure.ac, src/Makefile.am: Ignore shell script for WIN32.

2010-10-11  Matthias Franz

	Only for dvipdfmx:
	* dvipdfmx.cfg:
          Added quotes around command line parameters %i and %o
          (suggested by Karl Berry).

2010-06-10  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Avoid using "%hu" with fscanf/sscanf, for older Solaris.
	* src/pdfobj.c (pdf_open, check_for_pdf_version): Declare minor
	as unsigned int for use with "%u".

2010-06-08  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Solaris9 doesn't support "%hhu".
	* src/dpxfile.c (dpx_file_apply_filter):
	Use (unsigned short) version with "%hu".
	* src/pdfobj.c (pdf_open, check_for_pdf_version): Declare minor
	as unsigned short for use with "%hu".

2010-05-29  Matthias Franz

	* dpxfile.c, dpxfile.h, pdfobj.c, pdfximage.c:
          Further changes to fix the "%hhu" problem on Solaris 9.

2010-05-26  Matthias Franz

	* pdfobj.c:
          Changed type of PDF minor number from char to short in
          check_for_pdf_version in order to fix a compilation problem with
          Solaris 9; reported by Ulrich Seidl.

2010-05-24  Matthias Franz

	* dvipdfmx.cfg:
          Generate PDF 1.5 as default (suggested by Karl Berry).

2010-03-29  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* configure.ac: Remove AC_TYPE_SIZE_T, now part of KPSE_COMMON.

2010-03-28 Jin-Hwan Cho <chofchof@ktug.or.kr>

	* dvi.c, dvi.h, dvipdfmx.c, spc_pdfm.c:
          Implemented a new special \special{pdf: minorversion num} which
          will override the value given either by the configuration file
          or by the command line option; requested by Karl Berry.

2010-03-21 Jin-Hwan Cho <chofchof@ktug.or.kr>

	* cidtype2.c:
          Assume that the output encoding of CMap files is UTF-16, not UCS2
          as the recent Adobe-Japan1-UCS2 shows; reported by Haruhiko Okumura
          and the patch were prepared by Akira Kakuto.

2010-02-22  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* src/pngimage.c (check_for_png), src/xbb.c (check_for_png):
	Replace png_check_sig() by png_sig_cmp() for libpng-1.4.
	From Hanno Boeck <hanno@hboeck,de>.

2010-02-20  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* src/sfnt.h: #define CHAR as SFNT_CHAR to avoid conflict with
	CHAR from <winnt.h>.

2010-02-07 Matthias Franz

	* type1.c:
          Fixed bug caused by fonts without data for private dictionary.
          (The private dictionary was omitted instead of inserting an
          empty dictionary.) This caused problems with Acrobat Reader, for
          example with the dsrom10 font. Bug reported by Vladimir Vlasov.

2010-02-07 Jin-Hwan Cho <chofchof@ktug.or.kr>

	* dvipdfmx.c, pdfdoc.c, pdfobj.h, pdfobj.c, pdfencrypt.h, pdfenctypr.c:
          Now the trailer always contains ID array to work Screen annotations
          under Adobe Reader 9.

2009-12-14 Matthias Franz

	* dvipdfmx.c:
          Turn on quiet mode earlier if "-q" option is given.

2009-11-28 Matthias Franz

	* spc_dvips.c:
          Fixed bug in "ps: plotfile" special, found by Alexander Bostroem.

2009-11-18 Matthias Franz

	* man/extractbb.1, man/Makefile.am, Makefile.am, configure.in:
          Added man page for extractbb in new directory man. This
          addresses Debian bug #512357 and a request by Karl Berry.

2009-11-07  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* configure.ac, src/dpxfile.c: Require recent kpathsea version.

2009-10-10  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* dvipdfmx.c, xbb.c:
          Change usage() as suggested by Matthias Franz and Karl Berry.

2009-10-09  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* dvipdfmx.c:
          Implemented the usual options --version and --help
          (suggested by Karl Berry.)

2009-09-19  Matthias Franz

	* epdf.c, pdfdoc.c, pdfdoc.h, xbb.c:
          Bug fix: The number of pages in a PDF document as reported by
          extractbb was always 0. (The code for reporting the number of
          pages of a PDF file was accidentally removed during a previous
          modification.)

2009-09-18  Matthias Franz

	* dpxutil.c, dpxutil.h and all calls to the changed functions:
          Polished code for hash tables. Now the function for freeing
          values is defined with ht_init_table. ht_append_table now
          produces an error if the key is already in use (but this
          could be changed easily). A new insert mode where a value
          does _not_ replace an existing value for the same key has
          been introduced, but there is no short name for it yet.

2009-09-02  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Avoid more maximal compiler warnings:
	* src/pst_obj.c (pst_new_mark, pst_release_obj, pst_parse_null):
	Instead of casting a const string to non-const, make a copy and
	later free the copy.

2009-08-31  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Avoid almost all maximal compiler warnings:
	* src/*.[ch]: Constify start/end pointer args and local vars.
	Rewrite all parsing routines to operate on const strings.
	Constify struct member strings.  Drop or adjust casts.
	Cast a few non-const start pointers to 'const char **'.
	Use a few non-const local vars, not to modify const strings.

2009-08-30  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Avoid some more maximal compiler warnings.

	* src/tt_post.[ch] (tt_post_table): Constify struct member
	strings and drop casts.
	(macglyphorder): Declare 'const char**' not 'const char*const*'.

	* src/truetype.c (selectglyph): Use additional const string local
	var and drop cast.

	* src/dpxcrypt.[ch] (transform, MD5_write): Constify args.
	* src/pdfencrypt.c (compute_user_password): Drop cast.

	* src/fontmap.c (chop_sfd_name): Drop useless cast.
	(substr): Constify string arg and local var.
	(strip_options): Constify local var and drop cast.

	* src/cmap_write.c (CMap_create_stream): Constify cast.
	* src/pdfcolor.c (str2iccSig, iccp_check_colorspace,
	iccp_get_rendering_intent, iccp_unpack_header,
	iccp_get_checksum): Constify local vars and casts.
	* src/pdfencoding.[ch] (pdf_encoding_new_encoding,
	pdf_encoding_findresource): Constify args.
	* src/pdfobj.c (pdf_out): Constify cast.
	* src/specials.c (spc_exec_special): Drop useless casts.

	Only for dvipdfmx:
	* src/pdfdoc.c (pdf_doc_add_goto): Constify local vars.

	Only for xdvipdfmx:
	* src/fontmap.c (pdf_load_native_font): Constify local var and
	drop cast.
	* src/spc_dvips.c (spc_handler_ps_tricks_brotate,
	spc_handler_ps_tricks_transform): Constify local vars.
	(pstricks_key): Constify string members.

2009-08-30  Matthias Franz

	* dvipdfmx.cfg:
          Turned on optimization of PDF destinations by default.

2009-08-28  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Avoid some more compiler warnings.

	Only for dvipdfmx:
	* src/pdfobj.c (parse_xref_stream): Drop inner declaration of
	size and use size_obj, not to shadow previous local (diff type).
	Rename local index=>index_obj, not to shadow string function.

	Only for xdvipdfmx:
	Avoid zillions of 'initialization discards' warnings.
	src/agl.h, src/agl_standard.c, src/mk_agl_standard_c.pl:
	Constify string array 'agl_standard_names'.
	src/agl.c (agl_load_standard_names): Adjust.

	Some "declaration of 'xxx' shadows ...".  Among the remaining
	ones, those for 'distiller_template' in src/spc_dvips.c (local
	vs. global) should be looked at (FIXME).
	* src/pdfobj.c (parse_xref_stream): Drop inner declaration of
	size and use size_obj, not to shadow previous local (diff type).
	* src/epdf.c (pdf_get_page_content): Drop unnecessary inner
	declaration of content_new, not to shadow previous local.

2009-08-27  Matthias Franz

	* truetype.c, type1.c, type1c.c:
          Changed precision in font widths arrays from 1.0 to 0.1.
          (Applies only to Type 1, Type 1C and TrueType, not PK fonts.)

2009-08-27  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Avoid some more maximal compiler warnings.

	* src/cff.[ch] (cff_get_sid, cff_add_string): Constify string arg.
	* src/cidtype2.c (find_tocode_cmap), src/cmap.c (CMap_decode_char),
	src/dpxfile.c (dpx_create_temp_file, dpx_file_apply_filter):
	Constify local vars and drop casts.
	* src/dpxutil.c (get_hash): Constify cast.
	* src/pdfnames.c (cmp_key), src/t1_char.c (stem_compare),
	tt_glyf.c (glyf_cmp): Constify local vars and adjust casts.
	* src/t1_load.[ch] (t1_get_standard_glyph): Constify return
	type and drop cast.
	* src/type1.c (pdf_font_load_type1): Constify local vars.
	* src/cidtype0.c (CIDFont_type0_t1cdofont,
	CIDFont_type0_t1dofont): Drop casts.

2009-08-26  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Avoid some maximal compiler warnings.

	* src/*.c: ANSI C function definitions, i.e., '()'=>'(void)'.

	* src/agl.c (skip_capital, skip_modifier): Constify string args.
	(is_smallcap, agl_name_convert_unicode, put_unicode_glyph,
	agl_sput_UTF16BE, agl_get_unicodes): Constify local strings
	and drop casts.
	* src/xbb.c: Constify global strings.

2009-08-23  Matthias Franz

	* epdf.c, pdfdoc.c, pdfdoc.h, pdfximage.c, pdfximage.h, xbb.c:
          Removed the feature of negative page numbers for PDF inclusion.
          It was never used and made the code more complicated.

	* dvipdfmx.c, pdfximage.c:
          Changed the code for PS and PDF page inclusion:
          The function mkstemp on NetBSD may return the same name twice
          if the file has been deleted after the first call. (Reported
          by Jukka Salmi.) This interfered with our file name caching.
          Now we don't delete the temporary file after PS->PDF conversion,
          but cache the temporary file name instead. An advantage is that
          we don't have to convert the same file multiple times if several
          pages are imported.

2009-08-17  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* tt_post.c:
          Fixed the crashing bug with Mona font found by Alexis Ballier.

2009-07-17  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* src/pdfximage.h: add prototype for pdf_ximage_get_subtype.

2009-07-08  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* dvipdfmx.c:
          Add -E option that enables DVIPDFM emulation mode in DVIPDFMx.

2009-07-07  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* pdfximage.c, pdfximage.h, spc_pdfm.c:
          Add pdf_ximage_set_attr() and pdf_ximage_get_subtype()
          to resolve the conflict with bmpsize package in dvipdfm
          emulation mode; reported by Heiko Oberdiek.

2009-06-20  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* Makefile.am (AM_CFLAGS): enable compiler warnings.
	* src/pdfobj.c (pdf_file_new): declare as static.

2009-06-05  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* configure.ac: replace '--enable-tetex-build' by
	'--enable-texlive-build' (automatic if configured as part of the
	TeXLive tree).

2009-06-04  Karl Berry  <karl@tug.org>

	Only for dvipdfmx:
	* src/Makefile.am (dist_bin_SCRIPTS): dvipdft.
	* src/dvipdft: revised script from Matthias to replace
	version in dvipdfm.

2009-05-27  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Adapt to TL2009 build system.

2009-05-25  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* configure.ac, src/Makefile.am: Do not use CPPFLAGS for
	required -I flags, leave it for the user.

2009-05-22  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* generic/pgf-doc-diff.version2cvs, generic/pgf-generic-diff.version2cvs:
          Removed the patches for the CVS version of pgf,
          because they are applied to the main stream.

2009-05-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdfdoc.c (pdf_doc_get_page): Avoid C99isms
	(variable declaration not at the beginning of a block).

	From  Vladimir Volovich <vvv@vsu.ru>

2009-05-10  Matthias Franz

	* epdf.c:
          Don't try to convert included PDF files whose version number
          is higher than output file version. (If run as dvipdfm,
          conversion still occurs.)

	* Makefile.am, Makefile.in, dvipdfmx.c, dvipdfmx.h, jpegimage.c, pngimage.c, xbb.c, xbb.h:
          Added dvipdfm compatibility mode. This mode is triggered
          if dvipdfmx is called as "dvipdfm", and likewise extractbb
          as "ebb". (The latter mode was already present.)

	* dpxconf.c:
          Made predefined paper sizes match values given by libpaper.

2009-05-06  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* dvipdfmx.c, pdflimits.h, pdfobj.c:
          Improved PDF version handling.

	* cmap_read.c:
          Fixed a silly bug; reported by Fumihito YOSHIDA.

2009-05-06  Matthias Franz

	* cid.c, dvipdfmx.c, pdflimits.h, pdfobj.c:
          Fixed minor issues with PDF version handling, following
          a question by Akira Kakuto. The minimal and maximal
          PDF versions allowed are now defined in pdflimits.h.

2009-05-03  Matthias Franz

	* dvipdfmx.c, epdf.c, epdf.h, pdfdoc.c, pdfdoc.h, pdfobj.c, pdfobj.h, pdfximage.c, pdfximage.h, xbb.c:
          Improved PDF version handling. A "Version" entry in the
          document catalog is now honored. Moreover, dvipdfmx accepts
          to write PDF 1.7, and extractbb doesn't complain about PDF
          versions any more. Encryption keys too long for PDF 1.3 now
          lead to an error instead of a silent change of PDF version.

2009-05-02  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* tt_table.c:
          Fixed a bug of reading numOfExSideBearings; reported by
          Tomas Janousek.

2009-04-30  Matthias Franz

	* dvipdfmx.cfg:
          Use ps2pdf for PS-to-PDF conversion on all platforms.

2009-04-29  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* spc_color.c, spc_pdfm.c, spc_util.c, spc_util.h:
          Allow changing strokecolor or fillcolor only; for example,
          "pdf:scolor Red []" changes fillcolor only and
          "pdf:scolor [] Red" changes strokecolor only, but
          "pdf:scolor Red" changes both fillcolor and strokecolor.

	* pdfparse.c:
          Parse stream objects in a strict way as DVIPDFM because
          DVIPDFMx already has another specials for stream objects.

2009-04-26  Matthias Franz

	* pdfobj.c:
          Don't print unnecessary newlines in PDF dictionaries.

	* pdfobj.c, pdfobj.h, xbb.c:
          Added "%%HiResBoundingBox" and "%%PDFVersion" lines to
          extractbb output.

	* dpxutil.c, dpxutil.h, dvipdfmx.c, pdfdoc.c,pdfdoc.h, pdfnames.c, pdfnames.h, pdfobj.c, pdfobj.h, spc_pdfm.c, specials.c, dvipdfmx.cfg:
          Rename PDF destinations to shorter names (in order to save
          space). Together with the removal of unused PDF destinations
          implemented previously, this is more or less equivalent to
          Heiko Oberdiek's LaTeX package "hypdestopt".

2009-04-20  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* pdfdoc.c:
          Bug fix: \special{pdf:bann} ... \special{pdf:eann} (e.g., \hyperlink)
	  cause a problem when it was surrounded by the pair
	  \special{pdf:bcontent} ... \special{\special{pdf:econtent}.

2009-04-19  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* generic/pgf-doc-diff.texlive2008, generic/pgf-generic-diff.texlive2008:
          Patches and a new dvipdfmx driver for PGF, Version 2.00
	  included in texlive 2008.

	* generic/pgfsys-dvipdfmx.def.version2, generic/pgfsys-dvipdfmx-patch.tex.version2:
          Removed contributed files because of new patch files
	  pgf-doc-diff.texlive2008 and pgf-generic-diff.texlive2008.

2009-04-18  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* generic/pgf-doc-diff.version2cvs, generic/pgf-generic-diff.version2cvs:
          Patches and a new dvipdfmx driver for PGF, Version 2.00-cvs 20090418.

	* contrib/context/spec-dpx.tex, contrib/latex/animate.sty.sample, color.sty.sample, dvipdfmx.def.sample, graphics.sty.sample, movie15.sty.sample, sample-imagemask.tex:
          Removed contributed files already applied to texlive 2008.

2009-04-08  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* t1_load.c:
          Ignores the second /Subrs dicts and /CharStrings not followed
          by dict; Adobe's OPO_____.PFB and OPBO____.PFB had those problems.

2009-04-07  Matthias Franz

	* xbb.c:
          Removed binary mode option "-b". In ebb, just ignore it.

2009-03-30  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* pdfdoc.c:
          Fixed the bug: bbox->llx is not extracted for PDF images.

2009-03-29  Matthias Franz

	* xbb.c:
          Changed output-to-stdout option to "-O".

2009-03-24  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* cff.c, dpxutil.c, pdfencoding.c, pdfencrypt.c, mem.c:
          Revive system.h to work with TeXLive.

2009-03-23  Matthias Franz

	* dvipdfmx.c, jpegimage.c, jpegimage.h, pngimage.c, pngimage.h, xbb.c:
          Several changes related to xbb/extractbb:
	  Combined code with jpegimage.c and pngimage.c, added number
	  of pages to xbb output for PDF files, introduced quiet mode
	  (option "-q") and output to stdout (option "-s"), improved test
	  of filename check in dvipdfmx.c (now uses <libgen.h>), new
	  version numbering for xbb (same as dvipdfmx version)

2009-03-16  Matthias Franz

	* pdfdev.c, pdfdraw.c, spc_html.c, spc_pdfm.c, spc_tpic.c:
          Added comments to show the PDF operators inserted by each
          call of pdf_doc_add_page_content. This makes it easier to
          find out which part of the source is responsible for a PDF
          operator in the output. Example:

          pdf_doc_add_page_content(work_buffer, len);  /* op: q cm *

2009-03-16  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* src/cff.c, src/dpxutil.c, src/mem.c, src/pdfencoding.c,
	src/pdfencrypt.c: Must include Kpathsea headers (via `system.h')
	before including `mem.h'.

2009-03-15  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* data/Makefile.am, data/Makefile.in, data/EUC-UCS2:
          Revive the cmap EUC-UCS2; suggested by Nobuyuki Tsuchimura.

2009-03-12  Matthias Franz

	* dvipdfmx.c:
          Don't print messages in quiet mode.

	* dpxfile.c, dpxfile.h, pdfximage.c, data/dvipdfmx.cfg:
          Added conversion specifier "%v" (PDF version) to PS-to-PDF
          conversion template. Also changed default template for
          GhostScript to use the script ps2pdf instead of calling gs
          directly. (This works for all platforms.)

	* pdfobj.c:
          Fixed a bug concerning empty PDF strings: Empty PDF strings
          were reduced to NULL, which could lead to errors when calling
          string functions.

2009-01-15  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* specials.c:
          Apply Jonathan Kew's fix reported on August 7, 2008.
	  (Sorry that it was too late!)

2008-12-11  Matthias Franz

	* xbb.c:
          Fixed an off-by-one and an off-by-two error in the generation
          of output file names for extractbb.
          (Debian bug #506329, reported by G\'abor Braun.)

	* mpost.c, pdfcolor.c, pdfcolor.h, pdfdev.c, pdfdev.h, pdfdoc.c, pdfdraw.c, pdfdraw.h, spc_color.c, spc_pdfm.c:
          Polished the code for color support. PDF color operators will
          not be generated any more if old and new color coincide.

2008-11-30  Matthias Franz

	* spc_tpic.c:
          Polished code.

	* pdfdev.c, spc_html.c:
          Concatenated transformation matrices for images.

	* data/dvipdfmx.cfg, dvipdfmx.c, pdfdoc.c:
          Fixed two problems with removal of PDF destinations: Non-link
          annotations produced a warning, and broken links were not
          detected if no valid destination existed.
          Removing unused destinations is now default behaviour and can
          be prevented by using the flag "-C 0x10". Since the feature
          is still new, this flag is set in dvipdfmx.cfg.

	* spc_color.c, spc_color.h, spc_dvips.c, spc_dvips.h, spc_misc.c, spc_misc.h, spc_pdfm.c, spc_pdfm.h, specials.c:
          Removed unnecessary (no-op) handlers for specials.

	* cid.c, cid.h, dpxconf.c, dpxconf.h, dvi.c, dvi.h, fontmap.c, fontmap.h, numbers.c, numbers.h, pdfcolor.c, pdfcolor.h, pdfdev.c, pdfdev.h, pdfdoc.c, pdfdoc.h, pdfdraw.c, pdfdraw.h, pdffont.c, pdffont.h, pdfobj.c, pdfobj.h, pdfresource.c, pdfresource.h, pst_obj.c, pst_obj.h, tfm.c, tfm.h, tt_table.c, tt_table.h, type0.c, type0.h:
          Commented out unused functions.

2008-11-08  Matthias Franz

	* pdfcolor.c, pdfcolor.h, spc_tpic.c:
          Made tpic specials respect color settings. Before, they
          always used black for drawing commands.
          (Debian bug #485567, reported by Daniel Skorka.)

2008-11-03  Matthias Franz

	* dpxutil.c, dvipdfmx.c, mem.c, pdfdoc.c, pdfdoc.h, pdfnames.c, pdfnames.h:
          Remove unused PDF destinations.  (Packages like hyperref
          create destinations regardless of whether they are used
          or not.)  This option is currently turned off by default;
          it can be enabled with "-C 0x10".

	* dvipdfmx.c:
          Improved parsing of "-v" command line option; contributed
          by Akira Kakuto. Note that there are still problems if an
          argument to an option (or the name of the DVI file) starts
          with a minus sign

	* pkfont.c:
          Corrected bounding box computation for PK fonts. Before,
          it was always [0, 0, 0, 0].  Also removed a redundant call
          to pdf_encoding_add_usedchars.

2008-10-13  Matthias Franz

	* cff.c, cff.h, cff_dict.c, cidtype0.c, pdfdev.c, t1_load.c, type1.c, type1c.c:
          Various speed improvements:
          cff.c: cff_add_string now has an option to avoid checking for
          duplicate strings.
          pdfdev.c: p_dtoa does not call library functions any more.
          t1_load.c: t1_decrypt is not called for each byte seperately
          any more. (Well, this does not make a big difference.)

2008-09-29  Matthias Franz

	* epdf.c, pdfdoc.c, pdfdoc.h, pdfobj.c, pdfobj.h, xbb.c:
          Made PDF parsing more robust. In particular, we can now
          detect (illegal) loops in a PDF document hierarchy.
          Also, much of the PDF parsing code in epdf.c and xbb.c has
          been combined to the function pdf_doc_get_page in pdfdoc.c.
          Loops in PDF page trees are detected as well.
          Moreover, the various bounding boxes of a page are now
          handled correctly: MediaBox and CropBox are inherited,
          but not the others.

2008-08-31  Matthias Franz

	* type1.c:
          Fixed a bug when processing "seac" operators in Type 1
          fonts.  If the base or accent char were not used otherwise,
          an "Invalid SID" error could occur.

2008-08-05  Matthias Franz

	* type1c.c:
          Fixed a buffer overflow when using 256 glyphs of a CFF font
          (plus ".notdef").

2008-08-04  Matthias Franz

	* type1c.c:
          Fixed a segfault when processing CFF fonts.

2008-07-16  Matthias Franz

	* pdfnames.c, pdfobj.c, pdfobj.h:
          Replaced pdf_copy_object by the (almost) equivalent,
          but simpler function pdf_transfer_label. Simplified
          pdf_compare_reference.

	* pdfnames.c:
          Reintroduced warning about duplicate object keys.

2008-06-20  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* spc_pdfm.c:
          Fixed a bug on beads with nonzero depth; reported by
          Alexander Grahn.

2008-06-13  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* spc_pdfm.c:
          Fixed a bug on annotations with nonzero depth; reported by
          Alexander Grahn.

2008-06-07  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* contrib/latex/movie15.sty.sample:
          Support movie15.sty, version 2008/01/16.

	* pdfobj.c, pdfobj.h, pdfparse.c, spc_pdfm.c, pdfnames.c:
          Allow PDF stream of length zero and suppress some warning messages.

2008-06-06  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* contrib/latex/animate.sty.sample:
          Support animate.sty, version 2008/06/03.

2008-06-05  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* mpost.c, pdfdev.c, pdfdev.h, pdfdoc.c, pdfdoc.h, spc_pdfm.c:
          DVIPDFMx supports PGF version 2.00.
          New specials "pdf:bcontent", "pdf:econtent", and "pdf:code".
          Moreover, "pdf:exobj << additional_dict >>" merges additional
          dictionaries into the XObject dictionary, not resources.

	* pgfsys-dvipdfmx.def.version2, pgfsys-dvipdfmx-patch.tex.version2:
          A sample DVIPDFMx driver for PGF version 2.00. Note that
          pgfsys-dvipdfmx-patch.tex must be loaded after loading the 
          basiclayers of PGF. Otherwise image mask and transparency
          group do not work.

2008-06-01  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* pdfdev.h, spc_pdfm.c, spc_util.c, dvipdfmx.def.sample:
          Changed the option "mask" to "hide" in "pdf:image" special.
          New "pdf:stream" special for a string given externally.

	* pgf-generic.diff, pgfsys-dvipdfmx.def, xcolor.sty.sample:
          Renamed and moved pgf patches for version 1 to contrib/generic.
          Removed "xcolor.sty.sample".

2008-05-29  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* spc_dvips.c, pdfdoc.c, spc_html.c, spc_misc.c, pdfximage.c, pdfximage.h, spc_pdfm.c, spc_util.c, pdfdev.h:
          Support PGF image masking; support additional attribute dictionary
          for included images as pdfTeX.

	* xcolor.sty.sample, pgf-generic.diff, pgfsys-dvipdfmx.def, sample-imagemask.tex, dvipdfmx.def.sample:
          Sample files for image masking and xcolor, pgf patches.

2008-05-28  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* spc_pdfm.c:
          Remove an warning message which occurs with the PGF
          transparent model.

	* spc_util.c:
          Support dvips color names defined in dvipsname.def with
          "pdf:bcolor" special, e.g. "pdf: bcolor JungleGreen".

2008-05-23  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* data/Makefile.am, data/Makefile.in:
          Removed the obsolete CMap files in the data directory.

	* data/Makefile.in, src/Makefile.am, src/Makefile.in:
          Apply Karl Berry's symlink patch.

2008-05-22  Matthias Franz

	* cff_dict.c, dpxconf.c, dpxfile.c, dvipdfmx.c, epdf.c, fontmap.c, pdfdoc.c, pdfdraw.h, pdfencoding.c, pdfobj.c, pst_obj.c, sfnt.c, spc_pdfm.c, xbb.c, truetype.c, pdfencoding.c, pdfdraw.c:
          Fixed some compiler warnings issued by "gcc -Wall".

2008-05-21  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* pdfdoc.c:
	  Fix the timezone bug in asn_data() based on the dvipdfm-0.13.2d
	  code; this patch was suggested by Nobuyuki Tsuchimura.

2008-05-20  Matthias Franz

	* dvipdfmx.c, pdfdoc.c, pdfdoc.h, pdfobj.c, pdfobj.h:
	  Polished object stream code; removed command line option flag
	  0x10 (no object streams).

2008-05-20  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* contrib/latex/dvipdfmx.def.sample:
	  Fix ithe problem when including a PDF image with bounding box
	  having nonzero llx or nonzero lly.

2008-05-18  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* pdffont.c, pdffont.h, type1.c, type1c.c, truetype.c:
	  Fix the problem with MusiXTeX's Type1 fonts. Some characters
	  of these fonts have different widths from the corresponding
	  TFM files; reported by Yasuhiro Okazaki and Jean-Pierre Coulon.
	  DVIPDFMx now reads character width from TFM if found.
	  Otherwise, the information comes from the font file.
	  However, Type0 fonts (not simple fonts) do not refer to TFM.

2008-05-18  Matthias Franz

	* epdf.c, pdfobj.c, pdfobj.h, xbb.c:
	  Added PDF 1.5 parsing. Note that many PDF 1.5 files have
	  compressed xref streams with DecodeParms entry. Since we
	  don't support this, we cannot read these files.

	* epdf.c:
	  Allow page import from tagged PDF files. Tags are ignored.

2008-05-18  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* dvipdfmx.c, dpxfile.c, dpxfile.h, otl_conf.c, spc_pdfm.c, system.h:
	  Arranged MiKTeX related codes according to MiKTeX SVN repository.

	* fontmap.c, fontmap.h, pdfdev.c, pdffont.c:
	  Ignore obsolete remap option -r in DVIPDFM fontmaps.

2008-05-17  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* dvipdfmx.c, xbb.c, xbb.h, src/Makefile.am, src/Makefile.in, contrib/latex/dvipdfmx.def.sample:
	  DVIPDFMx now extracts bounding box information.
	  The binary dvipdfmx can be linked as extractbb, ebb, xbb, and
	  it works as same as the linked name. (extractbb == xbb)
	  This idea was suggested by Karl Berry.

2008-05-17  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Makefile.in, aclocal.m4:
	  Remove acinclude.m4. Give a new tag DVIPDFMX-20080517.

	* cid.c, cidtype0.c, cid_p.h, truetype.c, cidtype2.c, fontmap.c, fontmap.h, tt_aux.c, tt_aux.h, type1c.c:
	  New fontmap option '-v' to give StemV value explicitly;
	  especially for Chinese truetype fonts, e.g., Simsun;
	  this feature was suggested by Yue Wang.

	* dvipdfmx.def:
	  Support automatic generation of .xbb if -shell-escape is given.
	  Don't forget to replace $TEXMF/tex/latex/dvipdfmx/dvipdfmx.def
	  to contrib/latex/dvipdfmx.def.sample.

	* mpost.c:
	  Support MPS files generated by MetaFun.

	* pdfximage.c:
	  Try distiller specified in the configuration file
	  if interpreting MPS file fails.

2008-05-16  Matthias Franz

	* pdfobj.c:
	  Fixed incorrect size entry in xref stream dictionary.

	* pdfparse.c:
	  Fixed a bug in hex string parsing.

2008-05-16  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* dvipdfmx.c, spc_pdfm.c, dpxfile.c, otl_conf.c:
	  Restore the application name from "dvipdfm" to "dvidpfmx".
	  Notice that "dvipdfmx.cfg" must be located in "$TEXMF/dvipdfmx".

	* dvipdfmx.c, fontmap.c, fontmap.h, spc_pdfm.c:
	  Support font mapping files with DVIPS/pdfTeX format.

2008-05-13  Matthias Franz

	* cid.c, dvipdfmx.c, epdf.c, mpost.c, pdfencoding.c, pdfobj.c, pdfobj.h, pdfparse.c, pdfparse.h, pdfximage.c, pdfximage.h, spc_pdfm.c, xbb.c:
	  Changed code for PDF import so that objects are not duplicated
	  if they are imported through several pages of the same file.
	  Some PDF parsing functions now take an additional argument
	  of type pdf_file. If this is NULL, them indirect references
	  are not accepted.

2008-05-10  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* dpxfile.c, pdffont.c:
	  Support Mac OS X Resource Fork Font (/rsrc) with TrueType outlines.

2008-05-09  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* truetype.c, cidtype0.c, cidtype2.c, pdffont.c, pdffont.h, sfnt.c, sfnt.h, tt_glyf.c, tt_cmap.c, tt_table.c, tt_aux.c, dpxfile.c, dpxfile.h:
	  Support Mac OS X Data Fork Font (.dfont) with TrueType outlines.

2008-05-08  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* cidtype0.c, cidtype2.c, tt_aux.c, tt_table.c:
	  Support Mac TrueType fonts without OS/2 table.

2008-04-28  Matthias Franz

	* src/pdfencoding.c, src/pdfobj.c:
	  No declarations after statements allowed in C89.
	  (contributed by Vladimir Volovich <vvv at vsu.ru> via Karl Berry)

	* src/Makefile.am:
	  xbb needs zlib too.
	  (contributed by Karl Berry <karl at tug.org>)

	* m4/maw-kpse.m4, maw-libs.m4 (removed):
	  Renamed ...
	* m4/chi-kpse.m4, cho-libs.m4 (new):
	  ... into these.
	* Makefile.am:
	  Added `ACLOCAL_AMFLAGS -I m4'.
	* configure.in:
	  Use new names; respect library dependencies; moved macro
	  definitions ...
	* m4/maw-time.m4 (new):
	  ... to here.
	* acinclude.m4 (removed):
	  Moved macro definitions ...
	* m4/maw-kpse.m4, maw-libs.m4 (both new):
	  ... to here.
	  (all contributed by Peter Breitenlohner <peb at mppmu.mpg.de>
	  via Karl Berry)

2008-04-06  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* configure.in: respect library dependencies.

2008-03-04  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* Makefile.am: added `ACLOCAL_AMFLAGS -I m4'
	* configure.in: moved macro definitions ...
	* m4/maw-time.m4 (new): ... to here
	* acinclude.m4 (removed): moved macro definitions ...
	* m4/maw-kpse.m4, maw-libs.m4 (both new): ... to here.

2008-03-01  Matthias Franz

	* dvipdfmx.def:
	  Write bounding box information only if necessary.

	* dvipdfmx.def, spc_util.c:
	  New 'clip' parameter for 'pdf:epdf' and 'pdf:image'
	  specials. 'clip 1' enables clipping (default),
	  'clip 0' disables it.

2008-02-21  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Allow maintainer mode to regenerate files.
	* configure.in, acinclude.m4: added AC_DEFINES's third arg to
	provide autoheader templates.
	* configure.in: use AC_DEFINES for XETEX and XETEX_MAC.

2008-02-13  Matthias Franz

	* dvipdfmx.def, epdf.c, pdfdoc.c, pdfximage.c, pdfximage.h, spc_dvips.c, spc_html.c, spc_misc.c, spc_pdfm.c, spc_util.c, spc_util.h:
	  Added new 'page' parameter to PDF and PS inclusion. This
	  can be used with the graphicx package and the (experimental)
	  graphics driver dvipdfmx.def (see contrib/latex). Example:

	  \includegraphics[page=4]{a.pdf}

	  Page numbers can also be negative; the last page is -1.

	  Remarks:
	  1) Currently PDF objects may be duplicated in the output
	     if several pages are included from the same file.
	     -- done (2008-05-13)
	  2) The graphicx package currently uses the same bounding
	     box information (that of the first page) for all pages.

2008-02-13  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* acinclude.m4, aclocal.m4, configure.in, configure:
	  Karl Berry reports configure fixes for TeXLive.

	* pdfencoding.c, pdffont.c:
	  Fix an encoding bug by the MinionPro package;
	  reported by Juho Lee.

2008-02-12  Matthias Franz

	* pdfencrypt.c:
	  Encrypted PDF files with key lengths strictly between
	  40 and 128 bits could not be opened. Changed code to
	  meet Adobe Reader's behaviour for revision 3 (PDF 1.4)
	  encryption.

2008-02-08  Matthias Franz

	* epdf.c, pdfobj.c:
	  Improved PDF document parsing: pages without contents,
	  undefined indirect references and media boxes with
	  indirect references are now allowed. (Undefined
	  indirect references are needed for documents with
	  several cross-reference tables if the trailer contains
	  a reference to an object outside the part of the
	  xref table seen so far.)

2008-01-11  Matthias Franz

	* dvipdfmx.c:
	  Fixed a bug in processing DVI comments.

	* cmap_read.c, pst.c, pst_obj.c , t1_load.c:
	  Fixed a bug in postscript number parsing; reported
	  by Ulrike Fischer.

2008-01-06  Matthias Franz

	* type1.c, type1c.c:
	  Fixed a bug in the computation of glyph width arrays
	  for Type1 and Type1C font dictionaries; reported by
	  Ulrike Fischer.

2007-12-05  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* spc_pdfm.c:
	  Fixed a memory deallocation problem in the ConTeXt sample of
	  Francesco Pretto.

2007-12-03  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* cmap.c:
	  Code mappings in CMap may overlap, but succeeding maps
	  superceded preceding maps; reported and patched by Luo Jie.

2007-11-27  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* pdfdev.c:
	  Restored the DVIPDFM code for calculation of kerns;
	  reported by Keiichirou Shikano.

2007-11-22  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* pdfdev.c:
	  Fixed a bug related to calculate kern; reported by
	  Keiichirou Shikano.

	* spc_util.c:
	  Fixed a memory deallocation bug.

2007-11-18  Matthias Franz

	* vf.c:
	  Fixed small memory leak.

2007-11-17  Matthias Franz

	* pdfobj.c:
	  Suppress unnecessary white-space in PDF arrays.

	* dpxfile.c, dvipdfmx.c, mem.c, mem.h, tfm.c, xbb.c:
	  Fixed some small memory leaks.

2007-11-15  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* cid_basefont.h:
	  Add a predefined simplified Chinese font, AdobeHeitiStd-Regular.otf.

	* pdffont.c:
	  Fixed a bug causing problems with Type0 fonts;
	  reported by Akira Kakuto.

2007-11-13  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* dpxutil.c, dpxutil.h, dvipdfmx.c, mem.c, mem.h, fontmap.c, pdfdoc.c, pdfdoc.h, pdfobj.c, pdfobj.h, subfont.c, subfont.h, vf.c, dpxfile.c, xbb.c:
	  Applied the memory leak patch by Matthias Franz.

	* pdfencoding.c, pdfencoding.h, pdffont.c, type1.c, type1c.c, truetype.c, pkfont.c:
	  Applied the encoding patch by Matthias Franz.

	* agl.c, agl.h:
	  Introduced new predefined glyphlist.txt; contributed by
	  Matthias Franz.

2007-11-03  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* mpost.c:
	  Fixed a bug in skip_prolog(), which is unable to skip prolog.
	  Now work with "prologues:=3" mode in metapost 1.000.

2007-07-03  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* cff_dict.c:
	  Fixed a bug in pack_real() using work_buffer twice;
	  found by Takanori Uchiyama and reported by Akira Kakuto.

2007-06-30  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* cidtype0.c, cff_dict.h:
	  Fixed a bug checking cid >= CIDCount, which causes a problem
	  with some CJK otf fonts without having the CIDCount value.

2007-06-28  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* cff_dict.c:
	  Modified pack_real() to support musix20.pfb in Mac OS X 10.4 Quartz.
	  It seems that Mac OS X 10.4 Quartz has a bug on reading real numbers
	  in CFF font format. Since Mac OS X 10.4.10 the problem was solved.

2007-05-18  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* jpegimage.c, pngimage.c, pdfximage.c, pdfximage.h, dvipdfmx.c, xbb.c:
	  Updated "xbb" to generate ".xbb" not ".bb". There is a big
	  difference between "xbb" and "ebb" in handling bitmap images.
	  In the case of bitmap images not having density information,
	  there is no way to know the density (or DPI) of the image.
	  "ebb" always assume that the image has 100 DPI so that
	  100 pixels = 1 in = 72 bp. However, in this case, screen
	  capture image does not look clear. Thus, "xbb" follows pdfTeX,
	  which uses density information if exists, otherwise 72 DPI,
	  i.e., 72 pixels = 1 in = 72 bp, is used. With the modified
	  "dvipdfmx.def" driver for the LaTeX graphics package, you can
	  get the same result as pdfTeX.

2007-05-04  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* xbb.c:
	  New program "xbb" extending "ebb".

2007-05-03  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* pdfximage.c, pdfximage.h, dvipdfmx.c:
	  Support bbox for "pdf:image" special (experimental).
	  The program "ebb" extracting the bounding box of image files
	  always multiply 72/100 for bitmap images (png and jpg).
	  It causes some trouble with LaTeX graphicx package which read
	  the bounding box from ".bb" file usually generated by "ebb".
	  New experimantal option "-C 0x0020" is introduced. With this
	  option, dvipdfmx no longer multiply 72/100 for bitmap images
	  so that users can get the same result as pdftex.

2007-04-25  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* spc_pdfm.c:
	  Extended pdf:outline special to support open/close bookmark.
	  The previous version 20070409 had problem because toclevel
	  of part is -1 in some class files.

2007-04-24  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* spc_util.c:
	  Predefined colors, Black, White, and Gray caused some problem
	  in Adobe Reader 7 and 8; but not in other PDF viewers, e.g.,
	  Previewer.app. It was solved by changing cmyk value to gray value.

2007-04-17  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* dvipdfmx.c, pdfobj.c:
	  The default of the PDF minor version was changed from 3 to 4.

	* type1.c:
	  A bug was reported from Werner Lemberg (run nfssfont.tex for
	  the font ptmr8y). It happened when any character is used more
	  than one in one encoding file (e.g., texnansi.enc). To fix it,
	  Encoding resource was revived (but Hirata noted that there was
	  some problem with Ghostscript, not confirmed yet) and Widths
	  resource was changed to look up correct glyphs according to the
	  given encoding.

	* vf.c:
	  Suppress an annoying warning message if no verbose option is given.

2007-04-13  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* tt_cmap.c:
	  Support OpenType with PID=0, EID=3

2007-04-09  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* dvipdfmx.c:
	  Updated the usage as suggested by Matthias Franz

2007-04-03  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* pdfobj.c, pdfdoc.h, pdfencrypt.c, pdfencrypt.h, pdfobj.c, pdfobj.h, pdfparse.c, dvipdfmx.c:
	  Support object stream for PDF v1.5 or higher; contributed by
	  Matthias Franz. Previewer.app in Mac OS X did not work with
	  encryption under v1.5, but no problem with Adobe Reader 8

2007-03-26  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* pdfobj.c:
	  Support xref stream for PDF v1.5 or higher; contributed by Matthias Franz

2007-03-17  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* dpxfile.c:
	  Fixed a bug in reading .enc file; reported by Matthias Franz


2007-02-28  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* epdf.c:
	  Fixed a problem in handling Cropbox

2007-02-14  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* cidtype0.c tt_glyf.c tt_table.h, tt_table.c:
	  Fixed a bug in reading htmx and vtmx tables; reported by
	  Jjgod Jiang based on the solution by Jonathan Kew

2007-01-21  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* fontmap.c:
	  Fixed typos found by Jonathan Kew

2007-01-20  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* specials.h:
	  Fixed warning message in the IRIX compilation,
	  reported by Karl Berry and found by Olaf Weber

2007-01-19  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* fontmap.c:
	  Fixed a bug reported by Shigeru Miyata on Dec 28, 2005

	* spc_html.c:
	  Fixed a bug reported by Nobuyuki Tsuchimura on Jan 19, 2007

2006-12-20  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* configure:
	  Remake using autoconf-2.59

	* configure.in config.h.in src/pdfdoc.c:
	  Apply tm_gmtoff related modifications by Karl Berry

2006-12-15  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* configure aclocal.m4 Makefile.in src/Makefile.in data/Makefile.in:
	  Remake using aclocal-1.6, automake-1.6, and autoconf-2.59

	* configure.in src/Makefile.am data/Makefile.am:
	  Apply configure related modifications by Karl Berry

2006-12-11  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* mpost.c, pdfdev.c, pdfdev.h, spc_pdfm.c, pdfcolor.c, pdfcolor.h,
	  pdfdraw.c, pdfdraw.h:
	  Temporary implementation for mps files generated by mptopdf.

2006-12-11  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* pdfcolor.c:
	  Fixed the color bug reported by H. J. Lee and Pablo Rodriguez.

2006-12-07  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* pdfobj.c:
	  Fixed a bug with xref, reported by Paul Guyot.

2006-12-06  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* t1_load.c:
	  Modified to work with broken fonts, e.g. belleek/blsy.pfb.

	* dvipdfmx.c, dvi.c, dvi.h:
	  Add xoffset and yoffset specials.

2005-12-18  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* dpxfile.c:
	  Fixed a bug found by Karnes Kim.

2005-10-14  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* spc_tpic.c:
	  Fix a bug on spc_handler_tpic_bk() and spc_handler_tpic_wh();
	  reported by Akira Kakuto.

2005-08-31  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* pdfdoc.c, pdfdraw.c:
	  Stroke and fill color controls with gsave and grestore.

2005-08-30  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* pdfdraw.h, pdfdraw.c, mpost.c:
	  Fix a bug on MetaPost manipulation.

	* pdfobj.c:
	  Allow PDF images generated from Mac OS X.

	* truetype.c:
	  Fix a bug on PK Type3 font.

2005-08-24  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* spc_pdfm.c:
	  Fix a bug on finding XObject.

2005-08-23  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* pdfdraw.h, pdfdraw.c:
	  Fix a bug on matrix concatenation and inverse matrix.

	* spc_pdfm.c:
	  Fix a bug on giving object name in image.

2005-08-15  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* pdfdoc.c, spc_pdfm.c, specials.c:
	  Fix a bug on article|bead|thread specials.

2005-08-14  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* spc_html.c, spc_pdfm.c, specials.c:
	  Fix a bug causing memory leak, and correct a typo.

2005-08-12  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* pdfdev.c, pdfdev.h, spc_dvips.c, spc_pdfm.c, spc_util.c:
	  Modified transform_info structure using pdf_tmatrix.

2005-08-11  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* pdfdoc.c, pdfdraw.c, pdfdraw.h, spc_pdfm.c:
	  Optimization of changing transform matrices.
	  The "pdf:literal" special works almost same as pdfTeX's
	  "\pdfliteral" primitive. But "pdf:literal direct" is slightly
	  different from pdfTeX's "\pdfliteral direct". It does not
	  affected by "pdf:literal".

2005-08-08  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* spc_pdfm.c:
	  Test implementation of \special{pdf:literal ...}.

	* spc_misc.c:
	  Ignores \special{pos: ...} too.

	* spec-dpx.tex:
	  Modified to fit the changes introduced in 2005-08-08.

2005-08-02  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* dvi.c, spc_pdfm.c:
	  Fixed a few bugs introduced by changes in 2005-08-01.

	* dvipdfmx.def, spec-dpx.tex:
	  Modified to fit the changes introduced in 2005-08-01.
	  ConTeXt module still has a bug, e.g., \handleMPfshow.

2005-08-01  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* specials.c, spc_html.c, spc_pdfm.c:
	  Various minor changes to specials.
	  Rewriting HTML special support.

2005-07-31  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* specials.c:
	  Fixed a bug introduced by changes in 2005-07-30.
	  (@page1 not handled correctly)

2005-07-30  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* colors.h: removed
	  Color definitions placed into spc_util.c.

	* pdfdev.c, pdfdraw:
	  Various changes.

	* pdfcolor, pdfdoc:
	  set_bgcolor pdfcolor --> pdfdoc.

	* cid.c:
	  Force fixedpitch option for printer/acro fonts.

	* spc_*, specials.c:

	* And many others....

2005-07-28  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* pdfdev.c:
	  Simply use sprintf for printing numbers.................
	  Fixed an ancient bug causing very frequent (unnecessary)
	  font selection.

2005-07-21  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* pdfencoding.c: Fixed bugs.

	* truetype.c: Update and various changes.
	  Apply ligature GSUB for glyph name "a_b" and glyph names
	  with AGL mapping to multiple Unicode character sequence.
	  Suffixes "liga", "dlig", "frac" ... are always recognized
	  as feature tag for glyph composition. But for "a_b.vert",
	  dvipdfmx first compose glyph "a_b" (by some way) and then
	  apply "vert" substitution to composed glyph. It may often
	  behaves unexpectedly. Suffixes like "aalt1" is treated as
	  alternate substitution; e.g., "a.salt1" is interpreted as
	  first stylistic alternate of default glyph for "a". Those
	  features are just for completeness. (esp. alternate GSUB)
	  Reorganized various process of finding glyphs, but still
	  complicated. TTC is supported (but index is always 0).

2005-07-20  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* pdffont.c:
	  Minor changes.

	* pkfont.c:
	  Mostly rewritten. Allow .enc file to be specified
	  in fontmap. But it is not for reencoding but to get
	  glyph names for ToUnicode creation.

	* dpxfile.c:
	  Check file type.

	* pdfcolor.c, vf.c: Don't use strcasecmp, strncmp.

2005-07-18  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* pdfximage.c:
	  Set image format conversion filter to NULL if empty
	  string "" is given. Put various system dependent things
	  into dpxfile.c.

	* dpxfile.c:
	  Creation of temporary files, call other program
	  via system() to apply filter to file.

	* dpxconf.c, dpxconf.h: new files
	  Currently paper format related codes.

	* dvipdfmx.c: cleanup
	  Papersize handling --> dpxconf.c
	  Removed undocumented extension for page label.

	* dvipdfmx.c:
	  's' option for MPS-to-PDF conversion mode.  Treat page
	  numbers as suffix. For "dvipdfmx -M -s 1-3 foo",
	  dvipdfmx first tries to open "foo". If "foo" exists,
	  it then start conversion of "foo" (ignore 's'), if not, 
	  "foo.1", "foo.2", and "foo.3" is searched and multi-page
	  PDF file is generated.

2005-07-17  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* spc_dvips.c:
	  Fixes in psfile special.

2005-07-17  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* dpxutil.c, dpxutil.h:
	  Added few functions to make fontmap.c independent
	  from pdfparse.c. Various parse_xxx from pdfparse.c.
	  mangle_name() removed.

	* pdfparse.c, pdfparse.h, dpxutil.c, dpxutil.h, ...:
	  Several parsing routine moved to dpxutil.c.
	  parse_c_ident() is not really for "C" ident.
	  parse_c_string() is not really for "C" string.
	  And there are too many unclear parse_xxx routines
	  unrelated to PDF in "pdfparse". 
	  There are many uncertainty in parsing \special too.

	* spc_xxx:
	  skip_white() wrongly used in many places.
	  skip_white() skips from '%' to newline...

	* pdf:tounicode, pdf:mapfile, and pdf:mapline
	  using very different syntax than other pdf:
	  prefix specials.

	* dvi.c, pdffont.c:
	  Minor changes in debug and error message.

	* psimage.c, psimage.h, t1crypt.c, t1crypt.h: Removed.

	* t1_load.c: Merge t1crypt

	* pdfximage.c, pdfximage.h: Merge psimage
	  psimage.c is not really for PostScript support.
	  It just call external program to do conversion form
	  PS to PDF. There are no reason to restrict this to
	  from-PS conversion.

	* fontmap.c:
	  Do not use pdfparse.c. Added 'u' option to specify
	  "ToUnicode". This is for testing. Don't use this.

	* pdffont.c:
	  Read ToUnicode CMap specified in fontmap.

	* spc_util.c: HSB color...
	  Converted to RGB.

	* cidtype0.c, cidtype2.c:
	  Do not use mangle_name in dpxutil.c.

	* Various fixes related to pdflimits.h:
	  This only contains PDF_NAME_LEN_MAX.

2005-07-16  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* fontmap.c, fontmap.h
	  Create fontmap entries for each subfont, containing
	  SFD mapping information and "link" to fontmap entry
	  "foo@SFD@". Removed pdf_lookup_fontmap_record2().

	* dvi.c, mpost.c, pdfdev.c:
	  Modification needed by changes in fontmap handling.

	* spc_pdfm.c:
	  Minor changes in fontmap specials. Fixed leak in
	  "append" fontmap.

	* subfont.c, subfont.h:
	  Minor fixes and changes.

	* mpost.c: Bug fix.
	  Fixed a bug (typo) in mp_setfont.

2005-07-14  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* subfont.c, subfont.h:
	  xxx_sfd_yyy -> sfd_xxx_yyy
	  Added code for testing SFD file handling.
	  Added various comments.

	* fontmap.c:
	  Check if subfont ID is valid before loading
	  SFD mapping table for subfonts.
	  Changes related to the above changes in subfont.c.

2005-07-13  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* dvipdfmx.c: minor fix
	  agl_set_verbose() called in pdffont.c too.

	* fontmap.c:
	  Workaround for problems in subfont fontmap lookup.
	  Delete all conflicting explicit fontmap entries for
	  subfonts in pdf_insert_fontmap_record() when adding
	  fontmap entry with @SFD@ extension.

	* subfont.c, subfont.h:
	  Scan SFD file for valid subfont IDs. (Required by
	  changes made to fontmap.c mentioned above.)
	  Removed unnecessary file static variables.
	  Simplified file reading and parsing.

	* dvi.c: set_verbose() for subfont.c

	* fontmap.c:
	  Correctly handle fontmap entry like "dmj@DNP@12".

2005-07-11  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* agl.c: Fixed various small bugs

2005-07-09  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* fontmap.c, fontmap.h, pdfdev.c: Fake-bold again
	  'b' option. This is experimental feature.

	* pdfdev.c:
	  Graphics state is not properly managed yet.
	  Fake-bold and set_rule changes linewidth without
	  using pdf_dev_setlinewidth().
	  Enclose set_rule with q and Q.

	* agl.c: Removed unused variable

2005-07-08  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* tt_cmap.c: Bug fix
	  Format 12 cmap subtable support not working...

	* fontmap.c: Test for UCS-4
	  'p' option to specify UCS plane.
	  This is just for testing purpose. Don't use that.

2005-07-08  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* tt_cmap.c: Bug fix in ToUnicode creation
	  ToUnicode CMap creation (inversion of TrueType cmap) was
	  not working for format 12 cmap subtable.

2005-06-27  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* cid_basefont.h:
	  Add missing font definitions.

	* data/config/dvipdfmx.cfg:
	  Forgot to mention that 'D "..."' line is commented.
	  Now there are no default setting for image converter,
	  so PS inclusion will always fail unless you modify
	  dvipdfmx.cfg.

2005-06-26  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* data/config/cid-x.map: empty
	  Contained examples for fonts with unclear license.
	  Not maintained for a long time.

	* data/CMap/Adobe-Identity-UCS2: removed
	  Wrongly named file. Content of this file is
	  actually identity mapping.

	* type0.c:
	  Create dummy ToUnicode CMap "Adobe-Identity-UCS2".

	* specials.c:
	  spc_push_object() always create label for objects.
	  Objects created with pdf:obj should always be written
	  to output.

	* ainclude.m4, configure.in:
	  Define __TDS_VERSION__, require xbasename in kpathsea,
	  removed unused macros, simplified.

	* dpxfile.c:
	  Use __TDS_VERSION__ instead of HAVE_KPSE_ENC_FORMAT
	  and others.

	* dvipdfmx.c:
	  Alwyas use xbasename().

	* fontmap.c, fontmap.h:
	  Fake bold and OTL options removed.

	* otl_conf.c:
	  Deactivated.

	* pdfdev.c:
	  Fake bold option removed. (undocumented)

	* configure.in, acinclude.m4:
	  Various changes. Error if kpathsea library doesn't
	  have xbasename().
	  Define __TDS_VERSION__, removed HAVE_KPSE_XXX_FORMAT.

	* configure and others: recreated

2005-06-20  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* tt_gsub.c, tt_gsub.h: Alternate substitution
	  LookupType 3 (Alternate Substitution) GSUB lookup.
	  Unused.

2005-06-13  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* tt_gsub.c:
	  Added support for LookupType 7 (Extension Substitution).
	  Large CJK fonts may want them. Not tested well.

2005-06-09  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* tt_glyf.c:
	  Set top-side bearing to (sTypoAscender - bbox.ury) for
	  fonts without vmtx table (vertOriginY = sTypoAscender).

2005-06-09  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* dpxfile.c:
	  Fixes for old kpathsea library.

2005-06-08  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* dpxfile.c, dpxfile.h:
	  Fallback to old path searching behaviour.
	  Warn about files found in old location.

	* dvipdfmx.c:
	  set_verbose() for dpxfile.

2005-06-08  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* cid_basefont.h: Update for Adobe Reader 7

	* cid.c, pdfobj.c: Accept version tag 1.6

2005-06-06  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* acconfig.h: removed

	* data/CMap/glyphlist.txt: --> data/config/
	  No appropriate place yet.

	* cmap_read.c:
	  Fixed a bug in reading CIDSystemInfo dict.

	* pdfencoding.c, pdfencoding.h:
	  pdf_load_ToUnicode_stream(). Load ToUnicode CMap from file and
	  then create ToUnicode stream object. 
	  See also changes in truetype, type1, type1c, and pdffont.

	* pdffont.c:
	  First try to load ToUnicode CMap with file name 'tfm_name'.
	  See also changes in truetype, type1, type1c, and pdfencoding.

	* truetype.c, type1.c, type1c.c
	  Don't create ToUnicode if fontdict already have them.
	  See also changes in pdffont and pdfencoding.

	* Makefile.am, data/Makefile.am, src/Makefile.am:
	  Fixes, simplified, updated...
	  There are problems in data/Makefile.am yet. Installation
	  directory for .map and .cmap is not correctly set.

	* Makefile.in and others: recreated

	* configure.in:

2005-05-07  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* spc_color.c:
	  Color special without push/pop allowed?

	* spc_pdfm.c:
	  pdf:literal broken for more than 2 years?
	  Fixed a bug in creating annot.

	* data/config/dvipdfmx.cfg:
	  Comments...

2005-05-04  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* README: update

	* pdfparse.c:
	  There were several problems in handling broken PDF files.

	* pdfobj.c:
	  There were several problems in handling broken PDF files.
	  Stream dict is freed twice when parsing stream object failed.

	* tfm.c:
	  PK font creation was not working due to incorrect design size
	  value returned by tfm_get_desing_size().

	* index.html:
	  Update and fixes for links. Many sentences doesn't make sense
	  when the document is printed. Stylesheet default to "plain"
	  style. Encoding set to "utf-8".

	* style.css: renamed to style_dflt.css

	* style_plain.css:
	  Plain style stylesheet.

2005-03-07  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* pdfcolor.c:
	  Color not correctly reset at page break?
	  Maybe more bugs...

	* pdfdoc.c:
	  Encapsulating docxxx within single struct pdf_doc.

2005-03-05  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* mpost.c:
	  Text handling was not correct for subfonts.

	* pdfencoding.c:
	  Increased verbose level for ToUnicode warning.

2005-02-03  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* otl_conf.c, spc_pdfm.c:
	  Fixed remaining bugs related to MiKTeX file searching.

	* cvs tag: DVIPDFMX-20050201 (revised)

2005-02-01  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* cidtype2.c:
	  Fixed a critical bug on the DW entry for CIDType2 fonts.

	* cvs tag: DVIPDFMX-20050201

2005-01-06  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* dvi.c: Fixed a bug on converting subfont character numbers.

	* snapshot: two snapshots
	  DVIPDFMX-20040824 (release): before full update
	  DVIPDFMX-20040912 (current): with the bug fix on 2005-01-06

2004-09-12  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* specials: rewriting...
	  All \special related files renamed to spc_xxxx and specials.
	  Use function pointer table rather than doing everything with
	  if-else or switch-case.

	* pdfparse.c:
	  Few functions are expelled from pdfparse.c since they are not
	  related to PDF parse at all. pdfparse still contains dvipdfmx
	  only extension and they might be enabled even when parsing
	  ordinary PDF files.

	* spc_pdfm, pdfparse:
	  tounicode special moved to spc_pdfm.

2004-09-08  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* ttf, tt_*:
	  ttf.[ch] -> truetype.[ch], renamed few files, added tt_post.

	* unicode, pdfencoding:
	  ToUnicode support migrated to pdfencoding.

2004-09-05  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* pdfencoding: encodings -> pdfencoding

	* bug fixes.

	* pdflimits: This was not pdflimits nor implementation limit
	  of PDF viewers at all.

2004-09-02  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* pngimage, jpegimage:
	  Improvement on embedded ICC profile support.
	  Profiles with same MD5 checksum are shared among images.

	* pdfcolor:
	  Added something for managing color space resources. 

	* pkfont.c:
	  Depends on tfm.c again.

2004-08-30  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* pdfdoc, pdfdev:
	  Mostly independent from dvi interpreter.
	  pdfparse still depend on dvi.c through pdfspecial.c due to
	  pdf: special @xpos and @ypos.

	* pdfdraw:
	  Primitive graphics drawing functions and graphics state
	  management: pdf_dev_moveto, pdf_dev_gsave, pdf_dev_lineto,
	  pdf_dev_flushpath, and so on (migrated from mpost.c).
	  PostScript, tpic, and all other graphics specials should not
	  directly access page content stream but must use those
	  functions instead. Text state and colors are still managed
	  completely differently.

	* Added many comments in source and headers...

	* Rearranged initialization process again.
	  pdf_init_fontmap:   Initialize fontmapping database.
	  pdf_open_document:  Open output file, initialize various
	    document resource handler, and set default media size...
	  pdf_init_device:    Unit conversion, precision and others.
	  pdf_doc_begin_page: Initialize graphics state, etc.

2004-08-27  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* cidtype0.c:
	  Fixed several bugs in Type1 and CFF -> CID CFF converison.
	  There might be more bugs...

	* doc/dpxunicode.pdf: Update.

2004-08-24  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* cid_basefont.h: Bug fix
	  Added missing '['.

	* doc/dpxunicode.pdf: Update

	* tt_cmap.c:

2004-08-22  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* otl_conf.[ch]: New file
	  OTL feature is managed by configuration file.

	* fontmap.c:
	  -S and -L option removed. Added option -l. 

	* doc/dpxunicode.pdf: Update.

2004-08-16  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* Unicode support for CID OpenType.

2004-08-15  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* fontmap.c:
	  -f option changed to -S. Added -L for ligature substitution.

	* tt_gsub.c and others: New fontmap option -L
	  Map ligatures not in Unicode to PUA.
	  ToUnicode support handle substituted glyphs.
	  See, doc/dpxunicode.pdf for details.

2004-08-14  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* otl_opt.[ch]: New file
	  Handle fontmap options for OTL features.

2004-08-11  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* type1.c: Bug fix.
	  The seac operator support was broken since 2004-8-02.

	* fontmap.c: New fontmap option "-f tag" and "-b number".
	  Specify OpenType layout feature with -f option for "unicode"
	  endoding font. Glyph substituion specified by -f option is not
	  reflected in ToUnicode CMap yet. Only single substitution GSUB
	  subtable is supported.
	  The "-b" option specifies "boldness" parameter for fake-bold
	  (stroke line width of fill-then-stroke text).

	* ...:
	  Changes for new features mentioned above.

2004-08-08  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* tt_cmap.c, cidtype0.c: Bug fixes

2004-08-08  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* Makefile.in, Makefile.am:
	  cmap_parse --> cmap_read.

	* cmap_parse.[ch]: Remaned to cmap_read.[ch]

	* cmap_write.[ch]: New file
	  Create CMap PDF stream object. Output is not efficient yet.

	* dvi.c: Bug fix
	  Multiply pdf:pagesize special page height and page width by DVI
	  magnification factor.

	* agl.[ch], unicode.[ch], ....:
	  Use cmap_write.

	* dpxfile.[ch]: New file
	  .....

2004-08-07  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* Type1 font accept "unicode" encoding.
	  Converted to CIDFontType 0 CIDFont.

2004-08-02  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* New files: t1_load.[ch], t1_char.[ch]
	  type1.c --> type1.c, t1_load.c, t1_char.c.
	  t1_load: load Type1 font (PFB) into cff_font structure.
	  t1_char: type 1 charstring interpreter and type 1 to type 2
	  charstring converter (type 2 encoder). There are many duplicated
	  code in cs_type2 and t1_char.

2004-07-31  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* New files: pdfdraw.[ch], pdfcolor.[ch]

	* mpost.c, tpic.c:
	  Use pdfdraw and pdfcolor.

	* pdfdev.c:
	  CTM affects box calculation in dev_expand_box(). Special
	  bann/eann set correct bounding box for rotated text.

	* New keyword "unicode" in fontmap:
	  The keyword "unicode" can be specified as encoding in fontmap.
	  With this option dvipdfmx creates Unicode-to-GID mapping CMap
	  and GID to Unicode (ToUnicode) CMap from TrueType cmap table
	  (format 4 Windows-UCS2 and format 12 Windows-UCS4 subtable is
	  supported) for TrueType font. All font with encoding "unicode"
	  is treated as Type0 font.
	  Currently supported only for Unicode TrueType font.


2004-07-27  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* Many bug fixes.

	* fontmap.c: Bug fix.
	  Do not increment num_fontmap when replacing duplicate
	  entries.

	* mpost.c:
	  Support PS operator findfont etc. Not compatible with dvips.

2004-07-18  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* fontmap.c:
	  Add/replace/remove fontmap entries.
	  Added fontmap_add_map_record(). Scan single mapfile line.

	* fontmap.c, pdfdev.c:
	  fontmap_tex_name(), ... abort if invalid value is passed.

	* psspecial.c: bmpfile special
	  This is not PS special...

	* pdfobj.[ch], pdfspecial.c: 
	  Added pdf_copy_object(): Copy object data without changing
	  object label. Dvipdfmx now can handle pdf specials like:

	   \special{pdf:obj @foo << /Bar @bar >>}
	   \special{pdf:obj @bar << /Foo @foo >>}

	  Object reference can appear before definition of object.

2004-07-15  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* cidtype2.c, type0.c:
	  Write CID glyph metrics for non-embedded TrueType fonts.

	* dvipdfmx.c, cidtype0.[ch], cidtype2.[ch], cid.[ch]:
	  Treat all CIDFont as fixed pitch font if bit 0x0004 is set
	  in "-C" option. (for backward compatibility)

2004-07-14  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* New files: bmpimage.c, bmpimage.h
	  Windows BMP image format support. (not tested well...)
	  1/4/8/24-bits per pixel images, uncompressed or 4-bit/8-bit RLE
	  compressed images are supported.

	* pdfparse.c:
	  Added dictionary key "T" to the list of strings to be
	  converted to Unicode...

2004-07-12  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* dvipdfmx.c:
	  Added new option "-C".
	  Thumbnail support available again.

	* tpic.c, tpic.h:
	  Spline path ("sp" command) was not handled correctly.
	  Use (semi-)transparent color for shading, enabled by option
	  -C 2. (not enabled by default since it requires PDF version
	  1.4+) Apply shading only to closed paths.

	* psspecial.c:
	  epsbox support was broken.

	* pdfdoc.c: Thumbnail supported again

2004-07-04  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* configure, ...:
	  HAVE_KPSE_OPENTYPE_FORMAT and HAVE_KPSE_ENC_FORMAT is not
	  correctly set when compiled with gcc3.

2004-06-28  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* pdfximage.c:
	  Do not clip PDF images when "clip" option is not given. 

2004-06-27  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* Workaround for "three dot leader" problem.

2004-06-16  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* Do not adjust refernece point of included images if users do
	  not supply bounding box.

	* Look for .ofm first.
	  Workaround for incompatibility introduced on change 2004-01-20.

	* pdfdoc.c: Fixed bug that dvipdfmx crushes with null string key in
	  name tree.

2004-06-02  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* pdfspecial.c: Bug fix on cropbox in do_bxobj().

2004-05-03  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* jpegimage.c: Uninitialized variable.

2004-04-09  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* README, index.html: update

	* contrib/patches/glyphlist-cm-add.txt: new file
	  Additional glyphlist for Computer Modern font.

	* NEWS: new file
	  Empty.

	* pdfdev.c:
	  Do not increase line width.

2004-04-03  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* README: update

2004-03-25  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* jpegimage.c: ICC profile
	  Added APP2 ICC_PROFILE support.
	  ICC profile is not deleted from JPEG stream.

	* Embedded ICC profile support for JPEG and PNG enabled.
	  ICC profiles are not cached. Alternate color space?

2004-03-24  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* Thumbnail support removed.

	* index.html:
	  Quick check against WCAG 1.0. Lowercasified all HTML tags for
	  migration to XHTML.

	* pdfdoc.c:
	  Dvipdfm/dvipdfmx copyright notice remved from PDF Docinfo's
	  /Producer string, simplified to "dvipdfmx (VERSION)".

	* configure.in, configure:
	  Minor change.

2004-03-22  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* pngimage.c: Minor changes.

	  Remaining things for complete PNG 1.1 support is:
	  Complete iCCP support. Support tEXt and other metadata chunks
	  using XML Metadata stream. pHYS (and oFFs) support (in ebb).
	  Preserve filter (PNG predictor) if possible, but some softwares
	  using filters very inefficiently. 16-bit RGB/Gray (PDF-1.5).

	  JPEG (JFIF) can also store ICC profile with APP2. Implementing
	  very basic ICC profile support might be useful.

2004-03-21  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* README: updated

	* data/config/cid-x.map:
	  "slant" option -s supported in vertical mode.

	* pngimage.c: Fixed a serious bug, more chunks supported.

	  Gamma obtained by png_get_gAMA() is inverse of screen gamma
	  that the image is prepared. Gamma is sometimes inverted...

	  Approximated CalRGB color space used along with /Intent if
	  sRGB chunk is found (not sure how to treat it).

	  Experimental iCCP support --enable-iccp.
	  Doesn't validate ICC profile embedded in PNG.
	  Range? Rendering Intent?

	* pdfdev.c:
	  A line width of zero means thinnest line drawable in target
	  device. dev_rule() was wrongly changed to increase line width
	  if the width is too thin.

2004-03-20  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* unicode.c, agl.c, type0.c: ToUnicode CMap support

	  Always create ToUnicode CMap for simple fonts regardless of
	  the existence of glyph list file. If 10% of glyph names can
	  not be converted to Unicode, ToUnicode CMap is not embedded.
	  The reason for the (non-zero) limit 10% is; ToUnicode CMap
	  is shared among fonts using same .enc file. In this case,
	  Unicode mapping is created for all glyphs in the .enc file
	  where non-standard glyph names like "visiblespace" is often
	  expected. But those glyphs are usually not used in the TeX's
	  output and hence it should be simply ignored if mapping is
	  not available.
	  Sharing ToUnicode CMap is not so efficient as expected for
	  simple fonts, "subsetted" ToUnicode CMap might be better. 

	  type0.c search ToUnicode CMap named as REGISTRY-ORDERING-UCS2
	  or FONTNAME-UCS2, the latter case is for CIDFontType 2 font
	  using font's internal glyph ordering. It does not care about
	  the content of CMap at all, especially usecmap is not checked.
	  Don't use it.

	* README, data/config/cid-x.map:

	  Description about -m option removed from README.
	  This option is no longer necessary for usual cases, and use
	  of it is not recommended as the original dvipdfm fails to read
	  fontmap file with this option.

	* cmap.c:

	  Increment n-1 th byte if n-th byte overflow in bfrange like:

	   <00> <01> <00 FF>

	  The dstCode string is treated like an integer, but the number
	  of bytes required for that character code is not increased.
	  Acrobat's "ToUnicode" CMap contains such bfrange entries and
	  causing a serious problem in Korean TrueType fonts.

2004-03-18  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* pdfspecial.c:
	  pdf:literal direct should not translate origin.

2004-03-17  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* type1.c, type1c.c, cmap.c, ...: Memory leak.

2004-03-16  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* mpost.c, psspecialc.: Fixed bugs.

2004-03-14  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* dvipdfmx.c:
	  Scan first page's paper size special first.

	* pdfparse.c: \x in PDF string - broken

	  This (undocumented) extension to the PDF string object disturbs
	  and interrupts PDF object parsing and subsequent text re-encoding
	  specified by tounicode special (another extension). And it makes
	  impossible to separate parsing and re-encoding process ("x" after
	  backslash representing Unicode hex value...).
	  
	  Support for this extension was removed since it is desirable to
	  move (or isolate) tounicode special to the appropriate place, not
	  pdfparse but pdfspecial, if possible.

	  Note that this kind of extension might be incompatible with all
	  other PDF applications, "\x" should be treated as a single "x" in
	  literal strings (like PostScript).

	* pdfspecial.c: Special image/uxobj is partially broken.

	  Special uxobj doesn't work for external images after the change
	  made on 2003-08-12. It only works for the grabbed page contents
	  created by special bxobj/exobj.

	  Access to XObject reference (but can't be placed in the document)
	  is now available again. Supporting uxobj is usually not necessary
	  for external images because they are always reused as a document
	  resource but allowing access to the (form) XObject's indirect
	  reference by name like @foo is usefull for using them as an entry
	  of appearance dictionary in annotations.

	* pdfspecial.c, pdfdev.c:

	  Special bann/eann does not take account of current transformation
	  matrix correctly. It result in incorrect /Rect for all annotations
	  created by special bann/eann if transformation is applied.

	  Not fixed yet.

	* pdfparse.c: "ToUnicode" special

	  Illegal PDF string is expected within pdf: specials.  Many users
	  try to use raw Shift-JIS text without properly escaping backslash
	  appears in the 2nd byte of double-byte character. The same problem
	  occurs in many other encodings.

	  As a workaround for this problem, backslashes are not treated as
	  "escape" in some situation when the current "ToUnicode" CMap name
	  contains a substring RKSJ, B5, GBK, or KSC.

	* cmap.c, ...:


2004-03-12  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* mpost.c:
	  Skip until %%EndProlog.

	* pdfspecial.c, pdfdev.c, pdfdoc.c:
	  pdf_doc_set_mediasize()/pdf_doc_get_mediasize().

	* tfm.c
	  tfm.c was highly wasteful and inflexible.
	  Preparing for 31-bits character code support.

2004-03-11  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* dvipdfmx.c, dvi.[ch], pdfdev.[ch], pdfdoc.[ch],...: 
	  An effort to eliminate complicated initilization chain...

	* pdfximage.c, pdfximage.h: New file.
	  An effort to make image support more flexible.
	  Included images and grabbed page contents (forms) should be managed by
	  pdf_ximage as document resource (like font).

	* pdfspecial.c, psspecial.c:
	  Image support moved to pdfximage. (might be broken)

	* mpost.[ch], epdf.[ch], pngimage.[ch], jpegimage.[ch], psimage.[ch]:
	  Image support moved to pdfximage.

	* dvipdfmx.c, mpost.[ch]:
	  Experimental "mpspdfmx" mode -M.

	* pdfspecial.c, pdfdev.c, pdfdoc.c:
	  Hard to explain... There are many misleading/illogical things.

	* dvipdfmx.c, dvi.[ch]:
	  DVI specials related to page/paper size is pre-scanned.

	* dvipdfmx.c:
	  Page selection option "-s" accept page labels.
	  For example, command line option "-s 1-10/r,11-12/D:2:empty-page-,13-"
	  set page labels for page 1-10 to lowercase roman numerals, page 11-12
	  to arabic numerals starting with 2 and with prefix "empty-page-",...

	* dvipdfmx.c:
	  An option for "bookmark open lavel" -O.

	* pdfdoc.c:
	  Undocumented watermark/page decoration feature. Not completed yet.

	* thumbnail.c:
	  I can hardly think that thumbnail support is useful. Acrobat Reader
	  can create thumbnail image and other PDF viewers like gs* and Xpdf
	  doesn't support it. Currently broken due to changes in pngimage.c.

	* dvipdfmx.c, pdfdev.c:
	  The default precision set back to 2 fractional digits. Most sensitive
	  part is dev_set_string() but the accuracy of this part is essentially
	  limited to 0.01 point in the most cases. Increasing precision above 2
	  does not give good result (except DVI rules) but merely increases file
	  size.

2004-03-05  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* pdfdoc.c:
	  Fixed a critical bug introduced on change 2004-02-29:
	  Consistency check was done after pages are free-ed.

	* pdfdoc.c, pdfspecial.c:
	  special pdf:names. Add name tree entry.

	* pdfobj.c, pdfparse.c:
	  Few functions added for manipulating PDF array.

2004-03-04  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* pdfparse.c: Added missing () in macro PDF_TOKEN_END()

	* pdffont.c: Compiler warning on uninitialized variable.

2004-03-02  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* Groff support:
	  Groff support was essentially broken. Dvipdfm(x) generated
	  very inaccurate result due to incorrect choice of scale/unit.
	  It should be fixed now. 

2004-02-29  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* pdfspecial, pdfdoc, pdfobj, pdfparse:
	  Partially rewrote...

	* pdfdoc.c:
	  Moved static ... to static struct { ... } docXXX.
	  Removed (strange) optimization.
	  Outline item open/close.

	* tfm.c:
	  Partially rewote...

2004-02-25  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* Too many warnings when compiled with -Wshadow...
	  pdfdoc.c need to be fixed.

	* -Wmissing-prototypes, -Wmissing-declarations
	  
2004-02-21  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* type0.c:
	  Changes for New TDS/kpathsea.
	  Fixed a bug in get_tounicode_cmap()...

2004-02-19  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* cidtype0.c, type0.c:
	  Write CID glyph metrics for non-embedded CFF/OpenType fonts.

2004-02-18  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* tpic.c:
	  Ignore unpainted path in flush_path().
	  show_path() output 'n' operator for path without stroking nor filling
	  to avoid Acrobat error (bug?) "Illegal operation inside a path.".

2004-02-17  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* pkfont.c, pkfont.h, pdfdev.c:
	  Removed dependency to TFM in pkfont.

	* type1.[ch], type1c.[ch], type0.[ch], ttf.[ch]:
	  No longer need to know font resource name and remap.

	* pdffont.c, pdffont.h:
	  Added new file.

	* type1.[ch], type1c.[ch], ttf.[ch], pkfont.[ch], pdfdev.c, dvipdfmx.c:
	  Simple font support will be unified to pdffont.c

2004-02-16  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* type1.c, type1c.c, cidtype0.c:
	  Remove UniqueID and XUID from CFF Top dict.

	* type1.c:
	  Keep original FontBBox instead of replacing it with tight one obtained
	  from glyph's charstrings to prevent Acrobat 4 from greeking text.
	  Acrobat 4 may display text drawn with fonts which only contain small
	  glyphs like period and minus-sign with greeked text.

	* tt_build.c:
	  TrueType output slightly optimized.

	* ttf.c, cidtype2.c:
	  Preserve 'name' table when embedding TrueType font.

2004-02-15  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* type1c.c, cs_type2.c, cs_type2.h, cidtype0.c:
	  Dependency to TFM removed. Widths are obtained from font file.

	* type1c.c:
	  Delete unused strings from CFF string index.

	* tfm.c, tfm.h:
	  Added tfm_get_codingscheme(). CODINGSCHEME from TFM header.

	* agl.c, agl.h, unicode.c, unicode.h, ttf.c:
	  Handle decomposed (in Unicode) glyphs in AGL and glyph names of a form
	  XXX_YYY_ZZZ in ToUnicode CMap. The glyph name with suffix, like "x.y",
	  is sotred as a glyph "x" with a suffix that implies a variant "y" of
	  "x" in AGL table, not as "x.y" glyph. (for future use)

2004-02-13  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* type1.c:
	  Bug fix. Skip first four bytes of encrypted PFB section.
	  Not warn about "dotsection" operator which exist only for
	  compatibility to Type 1 font rasterizer that can't do hint
	  replacement.

	* tfm.c, tfm.h:
	  Fixed a bug that calculation of tfm_string_height() was incorrect.
	  ASCII pTeX specific things are put within #ifndef WITHOUT_ASCII_PTEX.

2004-02-12  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* type1.c:
	  Another bug in flex handling. hmoveto and vmoveto allowed.

	* type1c.c, cmap.c, cidtype0.c, encodings.c, fontmap.c:
	  Changes for new TDS and teTeX/kpathsea.

	* encodings.c, encodings.h, pdfdev.c:
	  Removed get_encoding().

2004-02-10  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* type1.c:
	  Bug fix. Compression of vhcurveto-hvcurveto was not actually done.
	  One more bug in flex handling.

2004-02-08  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* dvipdfmx.c:
	  paperinit() and paperdone().

	* tfm.c:
	  Bug fix. Read OFM level 1 header, required by get_design_size().

	* dvi.c, dvi.h, vf.c:
	  DVI specials in virtual fonts (patch by P. TJ MacPhee).

2004-02-05  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* cid.c, cidtype2.c:
	  Use font's internal glyph ordering if CSI Adobe-Identity is
	  specified for TrueType font. This feature is intended to be
	  used with Identity CMap and /I option in fontmap.

	* configure, acinclude.m4, acconfig.h, config.h.in,...:
	  Check kpse_{enc,cmap,sfd,opentype}_format.

	* type1.c:
	  Fixed a bug in flex handling.

2004-02-04  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* dvipdfmx.c:
	  libpaper support. 

	* configure, acinclude.m4, acconfig.h, config.h.in:
	  --with-paper added for configure option. HAVE_LIBPAPER in config.h.

	* pdfspecial.c: Added "bp" and "truebp" in units[].

	* Accept w<unit>,h<unit> for papersize option.

2004-02-03  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* type1.c:
	  Counter control (othersubr #12 and #13) supported.

2004-02-01  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* tt_build.c, tt_build.h, cidtype2.c, ttf.c:
	  Workaround for Ghostscript's bug.
	  Ghostscript doesn't handle CIDToGIDMap correctly.
	  Use Identity CIDToGIDMap. 

	* ttf.c:
	  Removed dependency to TFM. Glyph metric is obtained from font file.

	* type1.c:
	  Warn about "seac" operator.

2004-01-31  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* type1.c: Bug fix.

	* Added many 'const'.

2004-01-29  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* type1.c: Type 1 -> Type 1C conversion
	  PostScript Type 1 font is converted to Type 1C (CFF).
	  There are few limitations: Ghost hint is not converted to edge
	  hint. The Type 1 charstring operator "dotsection" is ignored.
	  The ExpertEncoding is not supported. The "seac" operator is not
	  supported. Counter control is not supported.

	* Makefile.in, Makefile.am, standardenc.h: standardenc.h removed.

	* pst.c:
	  Fixed a bug in skip_comments() that cause infinite loop.

2004-01-27  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* cff.c, cff.h, cff_dict.c, cff_dict.h:
	  Added few functions for Type 1 -> Type 1C conversion.

2004-01-24  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* pkfont.c:
	  Acrobat and MacOS X's Preview have some problem with Type 3 font.
	  Acrobat cannot handle non-invertible transformation matrix which
	  happens when PK glyph with width and/or height equals to zero is
	  embedded as Type 3 font. The preview app. of MacOS X 10.3 cannot
	  display few glyphs generated by dvipdfm with unknown reasons.

2004-01-21  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* cs_type2.c: Don't use rint().

2004-01-21  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* psimage.c, configure.in, config.h.in:
	  Use mkstemp() if available.

2004-01-20  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* tt_table.[ch], tt_build.[ch], cidtype[02].c:
	  CIDFont glyph metrics for embedded font.

2004-01-17  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* pdfobj.[ch], pdfparse.[ch], mpost.c, pdfencrypt.c, pngimage.c:
	  Removed pdf_*_stringx().

	* pdfobj.c, pdfparse.c: Changes for PDF-1.3 compliance.

2004-01-14  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* ToUnicode support for CFF/OpenType + built-in encoding.

	* Bug fix in cff.c, type1c.c

	* Workaround for Shift-JIS string parsing in pdfparse.c.

	* pngimage.c don't require PNG-write/MNG-feature/progressive-read.

	* Unicode: unsigned short --> long.

	* Removed winansi.h

2004-01-07  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* IMPORTANT CHANGE:
	  Searching order is reversed in fontmap.c.
	  Last match takes precedence in font mapping now.

	* Fixed bug in cff.c, cmap.c, and type1c.c.

2003-12-28  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* Bug fixes in pdfparse.c and cid_basefont.h.

2003-12-15  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* Minor fixes.

	* Added PDF special "fstream" - create PDF stream object from file.
	  This allows users to attach files in PDF.

2003-12-07  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* JPEG moved to jpegimage.c.

	* Bug fixes.

2003-12-06  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* Changes in pdfspecail.c.

	* Fixed a bug in mpost.c.

2003-12-02  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* Added a patch for dvipdfm's ebb.c. (PDF ArtBox support)

2003-11-29  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* Bug fixes.

	* CFF/OpenType support for single-byte font.

2003-11-26  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* Little enhancement to epdf.c.

	* Merged epsbox.sty patch by Noda.

2003-11-25  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* Many part of font/encoding related code rewrote.

	* Unicode support for single-byte font.

2003-11-10  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Fixed a bug on the algorithm converting arc to cubic bezier
	  curves in arc() (tpic.c), which is reported by Werner Lemberg.

2003-11-04  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* PNG support completely rewritten. Color pallete images are
	  now not converted to 24-bit RGB, colorspace Indexed is used
	  instead. Added tRNS and alpha chunnel (transparency) support.
	  Experimental gAMA, cHRM and sRGB support.

2003-11-03  Shunsaku Hirata <hirata@project.ktug.or.kr>

	* Fixed bug that dvipdfmx stops with error "Invalid Subr Index"
	  when embedding CFF OpenType font.

2003-10-09  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Add a missing line including pdfparse.h in dvi.c, which is
	  reported by Akira Kakuto.

	* Changed the default font map files for teTeX 2.x as suggested
	  by Haruhiko Okumura.

2003-10-08  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* A bug on the paper size checking routine of dvi_paper_size()
	  in dvi.c is fixed, which is reported by Haruhiko Okumura.

2003-10-06  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* A bug on the kerning routine of dev_set_string() in pdfdev.c is
	  fixed, which is reported by Edward G.J. Lee.

2003-08-12  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Changed to embed images only one time.

	* Updated configure.in and config.h.in to support WORDS_BIGENDIAN
	  and SIZEOF_SHORT, SIZEOF_INT, SIZEOF_LONG.

2003-08-11  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* A faked font name was used for TrueType fonts without any PS
	  font name as suggested by Hin-Tak Leung.

2003-08-05  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Built-in codes (originally from libgcrypt-1.1.42) was used
	  for PDF encryption instead of the OpenSSL library as suggested
	  by Thomas Esser. 

2003-07-28  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* A significant bug reported from Haruhiko Okumura is fixed.
	  The bug occurs only if compiled with gcc 3.x, not gcc 2.x.

2003-03-26  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* New feature, hexadecimal Unicode, suggested by iNOUE Koich!
	  and Akira Kakuto is implemented.

2003-03-13  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Fixed bugs on reading and writing OpenType fonts.

2003-03-12  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Applied changes for MiKTeX in ps_include() (psimage.c).

2003-03-11  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Fixed a bug in cff_charsets_lookup() (cff.c).

2003-02-06  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Fixed a bug in string_mode() (pdfdev.c) reported by iNOUE Koich!.

2002-12-30  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Fixed a bug in writing null array.

	* Fixed a bug in reading CMap and encoding files in MiKTeX.

2002-11-28  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Support color shading feature in ConTeXt.

2002-11-25  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* New feature pdfdecimaldigits (default=3) is implemented.

	* Fixed a missing line in dvipdfmx.c.

	* Fixed a bug in page attribute boxes, e.g., CropBox, TrimBox.

2002-11-11  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* The "pdf: dest" special reads pdf_object not pdf_array.

	* Fixed a bug in finding encoding files with extension.

	* Look up the entries in miktex.ini while finding files.

2002-10-31  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Fixed a bug in finding files with the kpathsea library 3.3.7.

2002-10-28  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* The project name was changed to dvipdfmx from dvipdfm-cjk.

	* Changed the way of finding files (MiKTeX and KPATHSEA)
	  (contributed by Akira Kakuto).

	* Support embedded MetaPost graphics in ConTeXt using new PDF
	  special \special{pdf:literal [direct|reverse] ...}.

2002-10-25  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Removed all files related to the original dvipdfm,
	  and all CMap files from Adobe.

	* Changed the executable file dvipdfm to dvipdfmx,
	  the configuration file config to dvipdfmx.cfg,
	  the Type0 map file cid.map to cid-x.map.

2002-10-24  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* It is possible to change the size of each page with the
	  special command \special{pdf:pagesize ...}. Override the
	  previous changes if there are two such commands in a page.

2002-10-17  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Fixed a bug in parsing an array in two lines. (mpost.c)

	* Changed not to lookup the header to find fonts. (mpost.c)

2002-10-09  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Duplication is allowed for named_references[]. (pdfspecial.c)

2002-06-05  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Fixed a bug in parse_key_val() found by Yasuhiro Okazaki.

2002-05-31  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Bug fixed for ToUnicode conversion in PDF outlines(bookmarks),
	  docinfo, and text annotations (contributed by Akira Kakuto).

	* Included the ToUnicode CMap, EUC-UCS2.

2002-05-22  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Support CJK characters in PDF outlines(bookmarks), docinfo, and
	  text annotations (contributed by Akira Kakuto).

2002-05-15  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* PDF encryption support with the OpenSSL library.

2002-04-30  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* ToUnicode CMap (only Unicode) support for Identity-H(V).

	* Included the ToUnicode CMap, Adobe-Identity-UCS2.

2002-04-22  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Included two CMaps, UniKSCms-UCS2-H(V) which fix a bug in
	  UniKS-UCS-H(V).

2002-04-17  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Changed xxx_set_debug() to #ifdef DEBUG.

2002-04-16  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Improved reading PNG image files.

	* Rearranged all files to work with GNU autotools.

	* Removed HAVE_TTF_FORMATS and HAVE_OFM_FORMATS.

2002-04-09  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Minor fix on 'source/pkfont.c'.

2002-04-07  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Fixed all warning messages generated with MSVC++.

	* Rewrote the functions 'xxx_locate_font()' again.

2002-04-04  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Changed the order of loading virtual and physical fonts as
	  suggested by Akira Kakuto <kakuto@fsci.fuk.kindai.ac.jp>.
	  If map entries are found, virtual fonts will not be used anymore.

2002-04-02  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Implemented no-embedding and stylistic variants for CIDFontType0.

2002-03-31  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Added two CMaps, ETenms-B5-H and ETenms-B5-V.

2002-03-30  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Minor fix on the patch by Takanori Uchiyama.

2002-03-29  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Applied the patch by Takanori Uchiyama <uchiyama@appi.keio.ac.jp>,
	  supporting the direction command of ASCII pTeX's extension in
	  virtual fonts.

	* Two CMaps, Identity-H and Identity-V are hard-coded in cmap.c.

2002-03-20  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Applied the patch by Jungshik Shin, not embedding the unnecessary
	  character /.notdef in type1 fonts. 

2002-03-20  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Modified cid_basefont.h.

2002-03-05  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Support for UTF8 encoding through Identity CMap.

2002-02-25  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Implemented no-embedding feature for CIDFontType2.

	* Implemented Bold, Italic, BoldItalic attributes for CIDFontType2
	  and CID predefined fonts.

2002-02-22  Jin-Hwan Cho <chofchof@ktug.or.kr>

	* Implemented subfont approach for CJK and HLaTeX.

2002-01-07  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Fixed bug introduced on 2002-01-05.

2002-01-05  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Workaround for some bad TrueType fonts that does not have US-English
	  PostScript font name.

2001-12-27  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Changed to parse all charstrings. Check for the SEAC character.

	* Minor changes in CFF related codes.

2001-12-26  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Merged cmap and cmap_parse.

2001-12-25  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Cleaned up TrueType and CFF related codes.

	* Minor bug fixes.

2001-12-23  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Fixed bug that always requires Private DICT(s) which may not exist.

	* Cleaned up TrueType and CFF related things.

2001-12-18  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Biased subroutine number is signed in cs_type2.c.

2001-12-14  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* macglyphs.h regenerated from apple's TTRefMan.

2001-12-13  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Minor cleanups.

	* Fixed typo (yacture -> yacute, Islash -> lslash) in macglyphs.h.

	* Fixed signedness of TureType cmap subtable format 0 data.

2001-12-11  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Minor fixes.

	* Fixed bug that interpretion of hmtx table is still wrong.

	* Fixed fixed().

	* More improved FontDescriptor for TrueType/OpenType fonts.

	* Support for PostScript glyph name in TrueType post table.
	  Full subsettting is also available for non-CJK TrueType fonts.
	  Cyrillic and other TrueType fonts can be used.
	  Requires post table with version 2.0.

2001-12-09  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Bug fixes.

2001-12-05  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Fixed bug that last entry of the loca table may not be read.

	* DW is set to that of missing glyph (CIDFontType 2).

	* Bug fixes.

2001-12-04  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Fixes.

2001-12-03  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Minor charnges, cleanups.

	* Write CIDSet.

2001-12-02  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Initial CFF CID-Keyed Font support.
	  Only Type 2 charstring is supported.

2001-11-27  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Minor fixes, cleanups.

2001-11-26  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Fixed (serious) bug that hmtx table is incorrectly interpreted.

	* Fixed bug that encoding ID of RPC and BIG5 are interchanged.

	* Added missing cast in cidtype2.c.

2001-11-25  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Bug fix.

2001-11-24  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Added missing free() (RELEASE) in cidtype2.c.

	* Minor fixes.

	* Fixed typos.

2001-11-22  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Clean up.

	* Allow `Preview & Print' licensed fonts to be embedded.
	  TrueType OS/2 table is preserved.

2001-11-20  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Minor cleanups. Fixed typos.

	* Strip out bad strings form PostScript names;
	  -WIN-RKSJ-H, -WINP-RKSJ-H, -WING-RKSJ-H, and -90pv-RKSJ-H.
	  Some font uses PostScript name one of above strings appended,
	  even if Shift-JIS encoding is not used.

2001-11-18  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Workaround for Omega: Omega uses setxxx (single-byte char) command
	  while double-byte font is in use. Pass character type to
	  dev_set_string() to distinguish single-byte and double-byte.
	  Maybe, it works with CJK-LaTeX by preparing set of CMaps.

	* Write double-byte strings as hex strings.
	  This makes bit faster and tend to generate smaller PDF in most cases.

	* CMap parser uses wrok_buffer in mfileio.

	* Reserved w_array and w2_array in struct cid_font for future use.

	* Now write /W array for TrueType, proportional latin and kana works
	  properly. The metric information are taken from font file, not from
	  TFM, to ensure we always have correct widths. The default width (DW)
	  is set to 1000.

	* Changed sizeof() appeared in sfnt_put_xxx() to expected values in
	  sfnt.h. I do not assume LONG to be exactly 32-bit long, ....

2001-11-17  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Added Chinese and Korean related stuff again. Chinese and Korean
	  languages are supported through Omega, or by achieving Ascii pTeX
	  compatibility.

	* Closing CMaps is missing. Added cmap_close_all(), which is invoked by
	  dev_close_all_fonts() in pdfdev.c.

	* Check length of output string for Type 0 font. It must be multiple of
	  2. Omega uses 8-bit and 16-bit mixed string even for double-byte
	  fonts. This causes problems.

	* Abort if missing/invalid character is used.

2001-11-15  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Bug fixes.

2001-11-12  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* (nearly) Completely rewritten.

	* Force Identity CMap. (double-byte character codes are mapped to CID)

	* Added CMap parser. (mkcidcct.pl is no longer needed)

	* Sync with jpatch.

2001-10-01  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Should return -1 when encoding_id >= 0 in type0_font().

2001-08-08  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Fixed a bug that raster images show up incorrectly in vertical
	  writing mode.

2001-08-07  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Removed dev_set_string2(), use dev_set_string() instead.

	* set_dev_vwmode() is renamed to set_dev_wmode().
	  Added dev_wmode() and mp_mode flag in pdfdev.c.

	* Support for Japanized MetaPost (pdfparse.h, mpost.c).
	
2001-07-21  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Fixed a bug that do not reset text state in vertical writing.

2001-07-20  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Fixed wrong positioning for slanted non-CJK font in vertical writing.

2001-07-19  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Support OS/2 table version 0x0002.

2001-07-17  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Support multiple parents for a single CID-keyed font
	(incomplete).

	  TODO:
	    check the consistency of charcter collections.

	* Removed entries for unsupported CMaps.

	* Updated cid.map.

2001-07-15  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Better font metric info for CIDFontType2.

	* Added (partial) support for vertical writing.
	  Added wmode flag to struct a_type0_font and dev_font.

	  TODO:
	    GSUB support in CIDFontType2.
	    /W2 and /DW2.

	* Added support for vertical version of CMaps in mkcidcct.pl
	
2001-07-07  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Minor fixes.

	* Updated out2uni.c
	
2001-06-30  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* --> dvipdfm-0.13.2c

2001-06-29  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Fixed a bug that select incorrect indexToLocaFormat
	(cidtype2.c).

	* Fixed several bugs in cidtype2.c.

2001-06-27  Shunsaku Hirata <hira4scp@mbox.nc.kyushu-u.ac.jp>

	* Added support for CJK-TrueType font embedding.

	* Cleaned up Type0 and CID font handling code.
